<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /captcha.php
 *  Date de création : 18/08/2007
 *  Dernière modification : 23/08/2007
 ***************************************************************************/

session_start ();

header ( 'Content-type: image/png' );
header ( 'Cache-control: no-cache, no-store' );


// Paramètres de l'image
$largeur = 300;
$hauteur = 60;


$code = '';

////////////////////
// Création du code
////////////////////

// Caractères autorisés
$lettres = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ123456789';
$lettres_melange = strlen ( $lettres );

for ( $i = 0 ; $i < 6 ; $i++ )
{
    // Selection de la lettres
    $code .= $lettres[mt_rand ( 0 , $lettres_melange - 1 )];
}


$image = ImageCreateTrueColor ( $largeur , $hauteur );


// Couleur de fond
$couleur = ImageColorAllocate ( $image , mt_rand ( 0 , 120 ) , mt_rand ( 0 , 120 ) , mt_rand ( 0 , 120 ) ) ;

ImageFill ( $image , 0 , 0 , $couleur );


// Liste des polices utilisées aléatoirement
$polices = array ( 'systeme/polices/trebuc.ttf', 'systeme/polices/tahomabd.ttf', 'systeme/polices/verdanab.ttf' );


////////////////////
// Dessin des ellipse au fond
////////////////////

$nbr_ellipses = mt_rand ( 12 , 20 );

for ( $i = 0 ; $i < $nbr_ellipses ; $i++ )
{
    // Couleur de l'ellipse
    $couleur = ImageColorAllocate ( $image , mt_rand ( 0, 120 ) , mt_rand ( 0 , 120 ) , mt_rand ( 0 , 120 ) );

    // Changement de l'épaisseur du cercle
    ImageSetThickness ( $image , mt_rand ( 1 , 2 ) );

    ImageEllipse ( $image , mt_rand ( 10 , $largeur - 10 ) , mt_rand ( 10 , $hauteur - 10 ) , mt_rand ( 5 , $hauteur ) , mt_rand ( 5 , $hauteur ) , $couleur );
}

ImageSetThickness ( $image , 1 );


////////////////////
// Dessin du code
////////////////////

$x = mt_rand ( 5 , floor ( $largeur / 12 ) );
$y = ( $hauteur / 2 ) + mt_rand ( floor ( $hauteur / 6 ) , floor ( $hauteur / 4 ) );

for ( $i = 0 ; $i < 6 ; $i++ )
{
    $taille = mt_rand ( floor ( $hauteur / 3 ) , floor ( $hauteur / 2 ) );
    $angle = mt_rand ( -20 , 20 );

    // Couleur de la lettre
    $couleur = ImageColorAllocate ( $image , mt_rand ( 150 , 255 ) , mt_rand ( 150 , 255 ) , mt_rand ( 150 , 255 ) );

    ImageTTFText ( $image , $taille , $angle , $x , $y , $couleur , realpath ( $polices[array_rand ( $polices )] ) , $code[$i] );

    // Changement de position de X
    $x += $taille + mt_rand ( 5 , floor ( $largeur / 12 ) );

    // Changement de position de Y
    $y = ( $hauteur / 2 ) + mt_rand ( floor ( $hauteur / 6 ) , floor ( $hauteur / 4 ) );
}


// Enregistrement du code dans la session
$_SESSION['captcha'] = $code;

ImagePNG ( $image );

?>