<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Tagadash
 *
 * Système de gestion de contenu
 *
 * Auteur : Teddy Michel (Doch)
 * Dernière modification : 14 septembre 2007
 * Langages : PHP, SQL
 * Version : 1.2.15
 *
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /index.php
 *  Date de création : 08/2006
 *  Dernière modification : 14/09/2007
 ***************************************************************************/


if ( is_file ( 'configuration.php' ) )
{
    include_once ( 'configuration.php' );
}
else
{
    die ( '<p><strong>Erreur&nbsp;:</strong> Le fichier /configuration.php est introuvable.</p>' );
}


// Début du script
if ( version_compare ( PHP_VERSION , '5.0' , '>' ) )
{
    $tps_execution = microtime ( true );
}
else
{
    list ( $usec , $sec ) = explode ( ' ' , microtime () );
    $tps_execution = ( (float) $usec + (float) $sec );
}


// Gestionnaire d'erreurs
if ( is_file ( 'systeme/errorhandler.' . EXT ) )
{
    include_once ( 'systeme/errorhandler.' . EXT );
    set_error_handler ( 'ErrorHandler' );
}


// Choix de la page
if ( isset ( $_GET['page'] ) )
{
    // La page doit contenir uniquement des lettres et des tirets (pour éviter les ../)
    if ( preg_match ( "#[a-z-]#s" , $_GET['page'] ) )
    {
        $page = $_GET['page'];
    }
    else
    {
        $page = 'Accueil';
        trigger_error ( 'Tentative d\'accès à la page ' . $_GET['page'] . '.' , E_USER_NOTICE );
    }
}
else
{
    $page = 'Accueil';
}


////////////////////
// Inclusion du fichier principal
////////////////////

if ( is_file ( 'systeme/mainfile.' . EXT ) )
{
    include_once ( 'systeme/mainfile.' . EXT );
}
else
{
    trigger_error ( 'Le fichier systeme/mainfile.' . EXT . ' est introuvable.' , E_USER_WARNING );
    die ( '<p><strong>Erreur</strong>&nbsp;: Le fichier systeme/mainfile.' . EXT . ' est introuvable.</p>' );
}


////////////////////
// Adresse IP bannie
////////////////////

if ( $database->connected && $page != 'Installation' )
{
    $sql = "SELECT `banni_time`,
                   `banni_duree`,
                   `banni_motif`,
                   `membre_nom`
            FROM `" . $database->pref . "bannis`
            LEFT JOIN `" . $database->pref . "membres`
                ON `membre_id` = `banni_membre`
            WHERE `banni_ip` = '" . ConvertIP ( $_SERVER['REMOTE_ADDR'] , '' ) . "';";

    $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

    if ( $database->NbrRowsSelected ( $req ) > 0 )
    {
        $row = $database->ResultArray ( $req );

        // On regarde si la durée du bannissement n'est pas dépassée
        if ( $row['banni_time'] + $row['banni_duree'] > $time || $row['banni_duree'] == 0 )
        {
            $page_titre = 'Adresse IP bannie';
            $page_simple = 1;
            $page_include = 0;

            // On simplifie la durée si possible
            if (  $row['banni_duree'] === 0 ) $duree = 'définitivement';
            else if ( $row['banni_duree'] / 31536000 === 1 ) $duree = 'pour 1 année';
            else if ( $row['banni_duree'] % 31536000 === 0 ) $duree = 'pour ' . ( $row['banni_duree'] / 31536000 ). ' années';
            else if ( $row['banni_duree'] / 2592000 === 1 ) $duree = 'pour 1 mois';
            else if ( $row['banni_duree'] % 2592000 === 0 ) $duree = 'pour ' . ( $row['banni_duree'] / 2592000 ). ' mois';
            else if ( $row['banni_duree'] / 604800 === 1 ) $duree = 'pour 1 semaine';
            else if ( $row['banni_duree'] % 604800 === 0 ) $duree = 'pour ' . ( $row['banni_duree'] / 604800 ). ' semaines';
            else if ( $row['banni_duree'] / 86400 === 1 ) $duree = 'pour 1 jour';
            else if ( $row['banni_duree'] % 86400 === 0 ) $duree = 'pour ' . ( $row['banni_duree'] / 86400 ). ' jours';
            else if ( $row['banni_duree'] / 3600 === 1 ) $duree = 'pour 1 heure';
            else if ( $row['banni_duree'] % 3600 === 0 ) $duree = 'pour ' . ( $row['banni_duree'] / 3600 ). ' heures';
            else if ( $row['banni_duree'] / 60 === 1 ) $duree = 'pour 1 minute';
            else if ( $row['banni_duree'] % 60 === 0 ) $duree = 'pour ' . ( $row['banni_duree'] / 60 ). ' minutes';
            else $duree = 'pour ' . $row['banni_duree'] . ' secondes';

            $page_texte = '<p>Votre adresse IP a été bannie du site ' . $duree . ' le ' . date ( $configuration['format_date'] , $row['banni_time'] ) . $langue['time_at'] . date ( $configuration['format_heure'] , $row['banni_time'] ) . $langue['_par_'] . $row['membre_nom'] . ".</p>\n";
            if ( !empty ( $row['banni_motif'] ) ) $page_texte .= '<p>Motif&nbsp;: ' . $row['banni_motif'] . "</p>\n";

            // À faire  : lien vers la page de contact
        }
        else
        {
            $sql = "DELETE FROM `" . $database->pref . "bannis`
                    WHERE `banni_ip` = '" . ConvertIP ( $_SERVER['REMOTE_ADDR'] , '' ) . "';";

            $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );
        }
    }
}


////////////////////
// Bloquage du site
////////////////////

if ( $configuration['bloquage'] == 1 && $_SESSION['groupe'] != 3 )
{
    $page_titre = 'Site fermé';
    $page_simple = 1;
    $page_include = 0;

    $page_texte = "<p>Le site est temporairement fermé et devrait être accessible prochainement. Veuillez revenir plus tard.</p>\n\n";
    $page_texte .= "<p>Les raisons possibles sont une maintenance du serveur, une mise-à-jour du site ou de la base de données, ou encore une fermeture pour cause de vandalisme ou de piratage.</p>\n";

    // À faire : ajout d'un texte explicatif à définir dans page d'administration
}


////////////////////
// Inclusion du fichier de la page
////////////////////

if ( $page_include == 1 )
{
    if ( is_file ( 'pages/' . $page . '.' . EXT ) )
    {
        include_once ( 'pages/' . $page . '.' . EXT );
    }
    else
    {
        $page = 'Accueil';

        if ( is_file ( 'pages/Accueil.' . EXT ) )
        {
            include_once ( 'pages/Accueil.' . EXT );
        }
    }
}


////////////////////
// Statistiques et visiteurs
////////////////////

if ( $page != 'Installation' && $page != 'Images' && $page_include == 1 && $database->connected )
{
    if ( is_file ( 'systeme/statistiques.' . EXT ) )
    {
        include_once ( 'systeme/statistiques.' . EXT );
    }
    else
    {
        trigger_error ( 'Le fichier systeme/statistiques.' . EXT . ' est introuvable.' , E_USER_NOTICE );
    }
}


// Temps d'exécution du script
if ( version_compare ( PHP_VERSION , '5.0' , '>' ) )
{
    $tps_execution = round ( ( microtime ( true ) - $tps_execution ) , 4 );
}
else
{
    list ( $usec , $sec ) = explode ( ' ' , microtime () );
    $tps_execution = round ( ( (float) $usec + (float) $sec ) - $tps_execution , 4 );
}


////////////////////
// Affichage de la page
////////////////////

if ( is_file ( 'systeme/page.' . EXT ) )
{
    include_once ( 'systeme/page.' . EXT );
}
else
{
    trigger_error ( 'Le fichier systeme/page.' . EXT . ' est introuvable.' , E_USER_NOTICE );
    die ( '<p><strong>Erreur</strong>&nbsp;: Le fichier systeme/page.' . EXT . ' est introuvable.</p>' );
}

?>