<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /pages/Administration.php
 *  Date de création : avant le 12/08/2007
 *  Dernière modification : 13/09/2007
 ***************************************************************************/

// Sécurité
if ( !defined ( 'TAGADASH' ) )
{
    header ( 'Location: ../' );
    die ( -1 );
}


// Droits d'administration
if ( $droit['administration'] == 0 )
{
    $page_msg = 2;
    include_once ( 'systeme/msg.' . EXT );
}


// Titre de la page
$page_titre = $langue['administration'];
$page_infos = $langue['administration_texte'];


$page_texte .= "\n<p>Vous êtes dans l'interface d'administration du site. Utilisez les liens ci-dessous vous gérer l'ensemble de son contenu.</p>\n\n";

$page_texte .= "<ul>\n";
$page_texte .= '  <li>Version du logiciel&nbsp;: TedSite ' . TAGADASH_VERSION . "</li>\n";
$page_texte .= '  <li>Version de PHP&nbsp;: ' . PHP_VERSION . "</li>\n";

$page_texte .= '  <li>Version de ';
if ( SGBD == 'mysql' ) $page_texte .= 'MySQL';
if ( SGBD == 'pgsql' ) $page_texte .= 'PostgreSQL';
if ( SGBD == 'odbc' ) $page_texte .= 'ODBC';
if ( SGBD == 'mssql' ) $page_texte .= 'MSSQL';
$page_texte .= ' : ' . $database->Version () . "</li>\n";

$page_texte .= "</ul>\n\n";

$page_texte .= "<h2>Articles</h2>\n\n";
$page_texte .= "<ul>\n";
$page_texte .= '  <li><a href="index.' . EXT . '?page=Administration_des_categories" title="' . $langue['admin_categorie_txt'] . '">' . $langue['admin_categorie'] . "</a></li>\n";
$page_texte .= '  <li><a href="index.' . EXT . '?page=Liste_des_articles' . "\" title=\"Voir la liste des articles\">Liste des articles</a></li>\n";
$page_texte .= '  <li><a href="index.' . EXT . '?page=Articles_supprimes' . "\" title=\"Voir la liste des articles supprimés\">Liste des articles supprimés</a></li>\n";
$page_texte .= "</ul>\n\n";

$page_texte .= "<h2>Membres</h2>\n\n";
$page_texte .= "<ul>\n";
$page_texte .= '  <li><a href="index.' . EXT . '?page=Liste_des_membres" title="' . $langue['membres_texte'] . '">' . $langue['membres_liste'] . "</a></li>\n";
$page_texte .= '  <li><a href="index.' . EXT . '?page=Modifier_un_membre" title="Modifier la fiche d\'un membre">Modifier la fiche d\'un membre' . "</a></li>\n";
$page_texte .= '  <li><a href="index.' . EXT . '?page=Supprimer_un_membre" title="' . $langue['supprimer_membre_txt'] . '">' . $langue['supprimer_membre'] . "</a></li>\n";
$page_texte .= '  <li><a href="index.' . EXT . '?page=Membres_supprimes">Liste des membres supprimés' . "</a></li>\n";
$page_texte .= "</ul>\n\n";

$page_texte .= "<h2>News</h2>\n\n";
$page_texte .= "<ul>\n";
$page_texte .= '  <li><a href="index.' . EXT . '?page=News" title="Liste des news">Liste des news' . "</a></li>\n";
$page_texte .= '  <li><a href="index.' . EXT . '?page=News&amp;action=nouvelle" title="Nouvelle news">Nouvelle news' . "</a></li>\n";
$page_texte .= "</ul>\n\n";

$page_texte .= "<h2>Autres</h2>\n\n";
$page_texte .= "<ul>\n";
$page_texte .= '  <li><a href="index.' . EXT . '?page=Administration_des_forums" title="' . $langue['admin_forums_texte'] . '">' . $langue['admin_forums'] . "</a></li>\n";
$page_texte .= '  <li><a href="index.' . EXT . '?page=Reponse_automatique" title="Gestion des réponses automatiques">Réponses automatiques' . "</a></li>\n";
$page_texte .= '  <li><a href="index.' . EXT . '?page=Administration_des_sondages' . "\" title=\"Administration des sondages\">Administration des sondages</a></li>\n";
$page_texte .= '  <li><a href="index.' . EXT . '?page=Liste_des_fichiers' . "\" title=\"Liste des fichiers\">Liste des fichiers</a></li>\n";
$page_texte .= "</ul>\n\n";

$page_texte .= "<h2>Gestion du site</h2>\n\n";
$page_texte .= "<ul>\n";
$page_texte .= '  <li><a href="index.' . EXT . '?page=Edit_accueil' . "\" title=\"Éditer la page d'accueil\">Page d'accueil</a></li>\n";
$page_texte .= '  <li><a href="index.' . EXT . '?page=Configuration' . "\" title=\"Configuration du site\">Configuration du site</a></li>\n";
$page_texte .= '  <li><a href="index.' . EXT . '?page=Messages_contact' . '" title="Messages reçus par le formulaire de contact">Messages reçus par le formulaire de contact' . "</a></li>\n";
$page_texte .= '  <li><a href="index.' . EXT . '?page=Bloquage" title="' . $langue['bloquage_texte'] . "\">" . $langue['bloquage'] . "</a></li>\n";
$page_texte .= '  <li><a href="index.' . EXT . '?page=Groupes' . '" title="Gérer les groupes et les droits">Gérer les groupes et les droits' . "</a></li>\n";
$page_texte .= '  <li><a href="index.' . EXT . '?page=Bannir' . '" title="Bannir une adresse IP">Bannir une adresse IP' . "</a></li>\n";
$page_texte .= '  <li><a href="index.' . EXT . '?page=Statistiques' . '" title="Statistiques du site">Statistiques' . "</a></li>\n";
$page_texte .= "</ul>\n";

?>