<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /pages/Administration_des_forums.php
 *  Date de création : avant le 13/08/2007
 *  Dernière modification : 02/09/2007
 ***************************************************************************/

// Sécurité
if ( !defined ( 'TAGADASH' ) )
{
    header( 'Location: ../' );
    die ( -1 );
}


// Droits d'administration
if ( $droit['administration'] == 0 )
{
    $page_msg = 2;
    include_once ( 'systeme/msg.' . EXT );
}


// Titre de la page
$page_titre = $langue['admin_forums'];
$page_infos = $langue['administration_texte'];


if ( isset ( $_GET['action'] ) )
{
    $action = $_GET['action'];
}
else
{
    $action = '';
}

switch ( $action )
{
    // Nouveau forum
    case 'nouveau_forum':

        if ( !isset ( $_GET['id'] ) && !is_numeric ( $_GET['id'] ) || $_GET['id'] < 1 )
        {
            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }

        $page_texte .= '<p><a href="index.' . EXT . '?page=Administration_des_forums' . "\" title=\"" . $langue['admin_forums_texte'] . "\">" . $langue['admin_forums'] . "</a></p>\n";

        // Traitement des données du formulaire
        if ( isset ( $_POST['submit'] ) )
        {
            $sql = "SELECT COUNT(*) AS `count`
                    FROM `" . $database->pref . "forum_cat`
                    WHERE `forum_cat_id` = '" . $_GET['id'] . "';";

            $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            if ( $database->Result ( $req , 'count' ) == 0 )
            {
                $page_texte .= '<p><strong>' . $langue['erreur'] . "</strong> : La catégorie du forum est introuvable.</p>\n\n";
            }
            else if ( empty ( $_POST['titre'] ) )
            {
                $page_texte .= '<p><strong>' . $langue['erreur'] . '</strong> : ' . $langue['err_oblig'] . "</p>\n\n";
            }
            else
            {
                // On recherche le numéro d'ordre du forum pour cette catégorie
                $ordre = 0;

                $sql = "SELECT `forum_ordre`
                        FROM `" . $database->pref . "forum_forum`
                        WHERE `forum_categorie` = '" . $_GET['id'] . "';";

                $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                while ( $row = $database->ResultArray ( $req ) )
                {
                    if ( $row['forum_ordre'] > $ordre )
                    {
                        $ordre = $row['forum_ordre'];
                    }
                }

                $ordre++;

                // On cherche si un forum porte déjà ce nom dans cette catégorie
                $sql = "SELECT COUNT(*) AS `count`
                        FROM `" . $database->pref . "forum_forum`
                        WHERE
                                `forum_nom` = '" . $_POST['titre'] . "'
                            AND `forum_categorie` = '" . $_GET['id'] . "';";

                $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                if ( $database->Result ( $req , 'count' ) == 0 )
                {
                    $sql = "INSERT INTO `" . $database->pref . "forum_forum`
                            (`forum_nom`, `forum_description`, `forum_ordre`, `forum_categorie`, `forum_last_msg`, `forum_nbr_sujet`, `forum_nbr_msg`)
                            VALUES
                            ('" . $_POST['titre'] . "', '" . $_POST['description'] . "', '" . $ordre . "', '" . $_GET['id'] . "', '0', '0', '0');";

                    $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                    header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
                    die ( -1 );
                }
                else
                {
                    $page_texte .= '<p><strong>' . $langue['erreur'] . "</strong> : Le nom choisi est déjà utilisé.</p>\n\n";
                }
            }
        }

        $page_texte .= '<form action="index.' . EXT . '?page=Administration_des_forums&amp;action=nouveau_forum&amp;id=' . $_GET['id'] . "\" method=\"post\" title=\"" . $langue['nouveau_forum'] . "\">\n\n";
        $page_texte .= "<fieldset>\n<legend>" . $langue['nouveau_forum'] . "</legend>\n\n";
        $page_texte .= "<label class=\"form_label\" for=\"id_titre\">" . $langue['titre'] . " :</label><input name=\"titre\" id=\"id_titre\" value=\"\" size=\"35\" type=\"text\" /><br/>\n";
        $page_texte .= "<label class=\"form_label\" for=\"id_description\">" . $langue['description'] . " :</label><input name=\"description\" id=\"id_description\" value=\"\" size=\"50\" type=\"text\" />\n\n";
        $page_texte .= "</fieldset>\n\n<p class=\"cleaner\"><input type=\"submit\" name=\"submit\" value=\"" . $langue['valider'] . "\" accesskey=\"s\" /></p>\n\n</form>\n";

    break;

    // Modifier un forum
    case 'modifier_forum':

        if ( !isset ( $_GET['id'] ) && !is_numeric ( $_GET['id'] ) || $_GET['id'] < 1 )
        {
            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }

        $page_texte .= '<p><a href="index.' . EXT . '?page=Administration_des_forums" title="' . $langue['admin_forums_texte'] . '">' . $langue['admin_forums'] . "</a></p>\n\n";

        if ( isset ( $_POST['submit'] ) )
        {
            if ( empty ( $_POST['titre'] ) )
            {
                $page_texte .= '<p><strong>' . $langue['erreur'] . '</strong>&nbsp;: ' . $langue['err_oblig'] . "</p>\n\n";
            }
            else
            {
                $sql = "SELECT `forum_id`
                        FROM `" . $database->pref . "forum_forum`
                        WHERE
                                `forum_nom` = '" . $_POST['titre'] . "'
                            AND `forum_id` <> '" . $_GET['id'] . "';";

                $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                if ( $database->NbrRowsSelected ( $req ) === 0 )
                {
                    $sql = "UPDATE `" . $database->pref . "forum_forum`
                            SET `forum_nom` = '" . $_POST['titre'] . "',
                                `forum_description` = '" . $_POST['description'] . "'
                            WHERE `forum_id` = '" . $_GET['id'] . "';";

                    $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                    header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
                    die ( -1 );
                }
                else
                {
                    $page_texte .= '<p><strong>' . $langue['erreur'] . '</strong>&nbsp;: ' . $langue['err_nom_use'] . "</p>\n\n";
                }
            }
        }

        $sql = "SELECT `forum_nom`,
                       `forum_description`
                FROM `" . $database->pref . "forum_forum`
                WHERE `forum_id` = '" . $_GET['id'] . "';";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        if ( $database->NbrRowsSelected ( $req ) === 0 )
        {
            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }

        while ( $row = $database->ResultArray ( $req ) )
        {
            $page_texte .= '<form action="index.' . EXT . '?page=Administration_des_forums&amp;action=modifier_forum&amp;id=' . $_GET['id'] . "\" method=\"post\" title=\"Modification du forum\">\n\n";
            $page_texte .= "<fieldset>\n<legend>Modification du forum</legend>\n\n";
            $page_texte .= "<label class=\"form_label\" for=\"id_titre\">" . $langue['titre'] . "&nbsp;:</label><input name=\"titre\" id=\"id_titre\" value=\"" . $row['forum_nom'] . "\" size=\"35\" type=\"text\" /><br/>\n";
            $page_texte .= "<label class=\"form_label\" for=\"id_description\">" . $langue['description'] . " :</label><input name=\"description\" id=\"id_description\" value=\"" . $row['forum_description'] . "\" size=\"50\" type=\"text\" />\n\n";
            $page_texte .= "</fieldset>\n\n<p class=\"cleaner\"><input type=\"submit\" name=\"submit\" value=\"" . $langue['valider'] . "\" accesskey=\"s\" /></p>\n\n</form>\n";
        }

    break;

    // Faire descendre un forum (augmenter son numéro d'ordre)
    case 'descendre_forum':

        if ( !isset ( $_GET['id'] ) && !is_numeric ( $_GET['id'] ) || $_GET['id'] < 1 )
        {
            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }

        // On vérifie que le forum existe
        $sql = "SELECT `forum_ordre`,
                       `forum_categorie`
                FROM `" . $database->pref . "forum_forum`
                WHERE `forum_id` = '" . $_GET['id'] . "';";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        if ( $database->NbrRowsSelected ( $req ) === 0 )
        {
            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }

        $row = $database->ResultArray ( $req );

        // On vérifie qu'on peut faire descendre le forum
        $sql = "SELECT COUNT(*) AS `count`
                FROM `" . $database->pref . "forum_forum`
                WHERE
                        `forum_ordre` = '" . ( $row['forum_ordre'] + 1 ) . "'
                    AND `forum_categorie` = '" . $row['forum_categorie'] . "';";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        if ( $database->Result ( $req , 'count' ) == 0 )
        {
            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }

        // On met le numéro d'ordre de ce forum à 0 (car `ordre` est unique)
        $sql = "UPDATE `" . $database->pref . "forum_forum`
                SET `forum_ordre` = '0'
                WHERE
                        `forum_id` = '" . $_GET['id'] . "'
                    AND `forum_categorie` = '" . $row['forum_categorie'] . "';";

        $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        // On change le numéro d'ordre du forum suivant
        $sql = "UPDATE `" . $database->pref . "forum_forum` 
                SET `forum_ordre` = '" . $row['forum_ordre'] . "'
                WHERE
                        `forum_ordre` = '" . ( $row['forum_ordre'] + 1 ) . "'
                    AND `forum_categorie` = '" . $row['forum_categorie'] . "';";

        $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        // On change le numéro d'ordre de ce forum
        $sql = "UPDATE `" . $database->pref . "forum_forum`
                SET `forum_ordre` = '" . ( $row['forum_ordre'] + 1 ) . "'
                WHERE
                        `forum_id` = '" . $_GET['id'] . "'
                    AND `forum_categorie` = '" . $row['forum_categorie'] . "';";

        $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
        die ( -1 );

    break;

    // Faire monter un forum (diminuer son numéro d'ordre)
    case 'monter_forum':

        if ( !isset ( $_GET['id'] ) && !is_numeric ( $_GET['id'] ) || $_GET['id'] < 1 )
        {
            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }

        // On vérifie que le forum existe
        $sql = "SELECT `forum_ordre`,
                       `forum_categorie`
                FROM `" . $database->pref . "forum_forum`
                WHERE `forum_id` = '" . $_GET['id'] . "';";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        if ( $database->NbrRowsSelected ( $req ) === 0 )
        {
            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }

        $row = $database->ResultArray ( $req );

        // On vérifie qu'on peut faire monter le forum
        $sql = "SELECT COUNT(*) AS `count`
                FROM `" . $database->pref . "forum_forum`
                WHERE
                        `forum_ordre` = '" . ( $row['forum_ordre'] - 1 ) . "'
                    AND `forum_categorie` = '" . $row['forum_categorie'] . "'";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        if ( $database->Result ( $req ,'count' ) == 0 )
        {
            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }

        // On met le numéro d'ordre de ce forum à 0 (car `ordre` est unique)
        $sql = "UPDATE `" . $database->pref . "forum_forum`
                SET `forum_ordre` = '0'
                WHERE
                        `forum_id` = '" . $_GET['id'] . "'
                    AND `forum_categorie` = '" . $row['forum_categorie'] . "';";

        $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        // On change le numéro d'ordre du forum suivant
        $sql = "UPDATE `" . $database->pref . "forum_forum`
                SET `forum_ordre`= '" . $row['forum_ordre'] . "'
                WHERE
                        `forum_ordre` = '" . ( $row['forum_ordre'] - 1 ) . "'
                    AND `forum_categorie`= '" . $row['forum_categorie'] . "';";

        $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        // On change le numéro d'ordre de ce forum
        $sql = "UPDATE `" . $database->pref . "forum_forum`
                SET `forum_ordre`= '" . ( $row['forum_ordre'] - 1 ) . "'
                WHERE
                        `forum_id` = '" . $_GET['id'] . "'
                    AND `forum_categorie`= '" . $row['forum_categorie'] . "';";

        $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
        die ( -1 );

    break;

    // Changer la catégorie du forum
    case 'changer_categorie':

        if ( !isset ( $_GET['id'] ) && !is_numeric ( $_GET['id'] ) || $_GET['id'] < 1 )
        {
            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }

        $page_texte .= '<p><a href="index.' . EXT . '?page=Administration_des_forums" title="' . $langue['admin_forums_texte'] . '">' . $langue['admin_forums'] . "</a></p>\n";

        if ( isset ( $_POST['submit'] ) )
        {
            if ( empty ( $_POST['destination'] ) )
            {
                $page_texte .= '<p><strong>' . $langue['erreur'] . '</strong>&nbsp;: ' . $langue['err_oblig'] . "</p>\n\n";
            }
            else
            {
                $ordre = 0;

                $sql = "SELECT `forum_ordre`
                        FROM `" . $database->pref . "forum_forum`
                        WHERE `forum_categorie` = '" . $_POST['destination'] . "';";

                $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                while ( $row = $database->ResultArray ( $req ) )
                {
                    if ( $row['forum_ordre'] > $ordre )
                    {
                        $ordre = $row['forum_ordre'];
                    }
                }

                $sql = "UPDATE `" . $database->pref . "forum_forum
                        SET `forum_categorie` = '" . $_POST['destination'] . "',
                            `forum_ordre` = '" . ( $ordre + 1 ) . "'
                        WHERE `forum_id` = '" . $_GET['id'] . "';";

                $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
                die ( -1 );
            }
        }

        $page_texte .= "\n<form action=\"" . 'index.' . EXT . '?page=Administration_des_forums&amp;action=changer_categorie&amp;id=' . $_GET['id'] . "\" method=\"post\" title=\"Changement de catégorie\">\n\n";
        $page_texte .= "<fieldset>\n<legend>Changement de catégorie</legend>\n\n";
        $page_texte .= "<p class=\"form_input\"><label for=\"id_destination\">Catégorie de destination&nbsp;:</label> <select name=\"destination\" id=\"id_destination\">\n";

        $sql = "SELECT `forum_categorie`
                FROM `" . $database->pref . "forum_forum`
                WHERE `forum_id` = '" . $_GET['id'] . "';";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        $row = $database->ResultArray ( $req );

        $sql = "SELECT `forum_cat_id`,
                       `forum_cat_nom`
                FROM `" . $database->pref . "forum_cat`
                WHERE `forum_cat_id` <> '" . $row['forum_categorie'] . "'
                ORDER BY `forum_cat_ordre` ASC;";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        while ( $row = $database->ResultArray ( $req ) )
        {
            $page_texte .= '<option value="' . $row['forum_cat_id'] . '">' . $row['forum_cat_nom'] . "</option>\n";
        }

        $page_texte .= "</select></p>\n\n</fieldset>\n\n<p class=\"centre\"><input type=\"submit\" name=\"submit\" value=\"" . $langue['valider'] . "\" accesskey=\"s\" /></p>\n\n</form>\n";

    break;

    // Déplacer un forum
    case 'deplacer_forum':

        if ( !isset ( $_GET['id'] ) && !is_numeric ( $_GET['id'] ) || $_GET['id'] < 1 )
        {
            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }

        $page_texte .= '<p><a href="index.' . EXT . '?page=Administration_des_forums" title="' . $langue['admin_forums_texte'] . '">' . $langue['admin_forums'] . "</a></p>\n\n";

        if ( isset ( $_POST['submit'] ) )
        {
            if ( empty ( $_POST['destination'] ) )
            {
                $page_texte .= '<p><strong>' . $langue['erreur'] . '</strong>&nbsp;: ' . $langue['err_oblig'] . "</p>\n";
            }
            else
            {
                $sql = "UPDATE `" . $database->pref . "forum_sujet`
                        SET `sujet_forum` = '" . $_POST['destination'] . "'
                        WHERE `sujet_forum` = '" . $_GET['id'] . "';";

                $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                header ( 'Location: index.' . EXT . '?page=Administration_des_forums&amp;action=supprimer_forum&amp;id=' . $_GET['id'] . '&ok' );
                die ( -1 );
            }
        }

        $page_texte .= '<form action="index.' . EXT . '?page=Administration_des_forums&amp;action=deplacer_forum&amp;id=' . $_GET['id'] . "\" method=\"post\" title=\"Déplacement du forum\">\n\n";
        $page_texte .= "<fieldset>\n<legend>Déplacement du forum</legend>\n\n";
        $page_texte .= "<p class=\"form_input\"><label for=\"id_destination\">Forum de destination&nbsp;:</label> <select name=\"destination\" id=\"id_destination\">\n";

        $sql = "SELECT `forum_id`,
                       `forum_nom`
                FROM `" . $database->pref . "forum_forum`
                WHERE `forum_id` <> '" . $_GET['id'] . "'
                ORDER BY `forum_nom` ASC;";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        while ( $row = $database->ResultArray ( $req ) )
        {
            $page_texte .= '<option value="' . $row['forum_id'] . '">' . $row['forum_nom'] . "</option>\n";
        }

        $page_texte .= "</select></p>\n\n</fieldset>\n\n";
        $page_texte .= "<p class=\"centre\"><input type=\"submit\" name=\"submit\" value=\"" . $langue['valider'] . "\" accesskey=\"s\" /></p>\n\n</form>\n";

    break;

    // Supprimer un forum
    case 'supprimer_forum':

        if ( !isset ( $_GET['id'] ) && !is_numeric ( $_GET['id'] ) || $_GET['id'] < 1 )
        {
            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }

        if ( isset ( $_GET['ok'] ) )
        {
            $sql = "SELECT `forum_ordre`
                    FROM `" . $database->pref . "forum_forum`
                    WHERE `forum_id` = '" . $_GET['id'] . "';";

            $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            $ordre = $database->Result ( $req , 'forum_ordre' );

            // On supprime le forum
            $sql = "DELETE FROM `" . $database->pref . "forum_forum`
                    WHERE `forum_id` = '" . $_GET['id'] . "';";

            $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            // On modifie le numéro de l'ordre des autres forums
            $sql = "UPDATE `" . $database->pref . "forum_forum`
                    SET `forum_ordre` = `forum_ordre` - 1
                    WHERE `forum_ordre` > " . $ordre . ";";

            $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            // On supprime tous les messages du forum
            $sql = "DELETE FROM `" . $database->pref . "forum_msg`
                    WHERE `forum_msg_forum` = '" . $_GET['id'] . "';";

            $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            // On supprime tous les sujets du forum
            $sql = "DELETE FROM `" . $database->pref . "forum_sujet`
                    WHERE `sujet_forum` = '" . $_GET['id'] . "';";

            $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }

        $sql = "SELECT `forum_categorie`
                FROM `" . $database->pref . "forum_forum`
                WHERE `forum_id` = '" . $_GET['id'] . "';";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        $sql = "SELECT COUNT(*) AS `count`
                FROM `" . $database->pref . "forum_forum`
                WHERE `forum_categorie` = '" . $database->Result ( $req , 'forum_categorie' ) . "';";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        $deplacer = ( $database->Result ( $req , 'count' ) == 1 ) ? '#' : 'index.' . EXT . '?page=Administration_des_forums&amp;action=deplacer_forum&id=' . $_GET['id'];

        $page_texte .= '<p><a href="index.' . EXT . '?page=Administration_des_forums" title="' . $langue['admin_forums_texte'] . '">' . $langue['admin_forums'] . "</a></p>\n";
        $page_texte .= "<p>La suppression d'un forum entraine la suppression des sujets et des messages de ce forum.<br />Pour supprimer le forum en conservant ses sujets et ses messages (en les déplaçant vers un autre forum), <a href=\"" . $deplacer . "\">cliquez-ici</a>, sinon <a href=\"" . 'index.' . EXT . '?page=Administration_des_forums&action=supprimer_forum&id=' . $_GET['id'] . '&ok' . "\">cliquez-ici</a>.</p>\n";

    break;

    // Modifier une catégorie
    case 'modifier_cat':

        if ( !isset ( $_GET['id'] ) && !is_numeric ( $_GET['id'] ) || $_GET['id'] < 1 )
        {
            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }

        $page_texte .= '<p><a href="index.' . EXT . '?page=Administration_des_forums" title="' . $langue['admin_forums_texte'] . '">' . $langue['admin_forums'] . "</a></p>\n\n";

        if ( isset ( $_POST['submit'] ) )
        {
            if ( empty ( $_POST['nom'] ) )
            {
                $page_texte .= '<p><strong>' . $langue['erreur'] . '</strong>&nbsp;: ' . $langue['err_oblig'] . "</p>\n\n";
            }
            else
            {
                $sql = "SELECT `forum_cat_id`
                        FROM `" . $database->pref . "forum_cat`
                        WHERE
                                `forum_cat_nom` = '" . $_POST['nom'] . "'
                            AND `forum_cat_id` <> '" . $_GET['id'] . "';";

                $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                if ( $database->NbrRowsSelected ( $req ) === 0 )
                {
                    $sql = "UPDATE `" . $database->pref . "forum_cat`
                            SET `forum_cat_nom` = '" . $database->Protege ( $_POST['nom'] ) . "'
                            WHERE `forum_cat_id` = '" . $_GET['id'] . "';";

                    $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                    header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
                    die ( -1 );
                }
                else
                {
                    $page_texte .= '<p><strong>' . $langue['erreur'] . "</strong>&nbsp;: Le nom de destination est déjà utilisé.</p>\n\n";
                }
            }
        }

        $sql = "SELECT `forum_cat_nom`
                FROM `" . $database->pref . "forum_cat`
                WHERE `forum_cat_id` = '" . $_GET['id'] . "';";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        while ( $row = $database->ResultArray ( $req ) )
        {
            $page_texte .= "\n<form action=\"" . 'index.' . EXT . '?page=Administration_des_forums&amp;action=modifier_cat&amp;id=' . $_GET['id'] . "\" method=\"post\" title=\"Modification de la catégorie\">\n\n";
            $page_texte .= "<fieldset>\n<legend>Modification de la catégorie</legend>\n\n";
            $page_texte .= '<label for="id_nom">' . $langue['titre'] . "&nbsp;:</label> <input name=\"nom\" id=\"id_nom\" value=\"" . $row['forum_cat_nom'] . "\" size=\"35\" type=\"text\" /> ";
            $page_texte .= "<input type=\"submit\" name=\"submit\" value=\"" . $langue['valider'] . "\" accesskey=\"s\" />\n\n</fieldset>\n\n</form>\n";
        }

    break;

    // Supprimer une catégorie
    case 'supprimer_cat':

        if ( !isset ( $_GET['id'] ) && !is_numeric ( $_GET['id'] ) || $_GET['id'] < 1 )
        {
            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }

        if ( isset ( $_GET['ok'] ) )
        {
            $sql = "SELECT `forum_cat_ordre`
                    FROM `" . $database->pref . "forum_cat`
                    WHERE `forum_cat_id` = '" . $_GET['id'] . "';";

            $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            $ordre = $database->Result ( $req , 'forum_cat_ordre' );

            // On modifie le numéro de l'ordre de la catégorie
            $sql = "UPDATE `" . $database->pref . "forum_cat`
                    SET `forum_cat_ordre` = '0'
                    WHERE `forum_cat_id` = " . $_GET['id'] . ";";

            $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            // On modifie le numéro de l'ordre des autres catégories
            $sql = "UPDATE `" . $database->pref . "forum_cat`
                    SET `forum_cat_ordre` = `forum_cat_ordre` - 1
                    WHERE `forum_cat_ordre` > " . $ordre . ";";

            $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            // On récupère les identifiants des forums de cette catégorie
            $sql = "SELECT `forum_id`
                    FROM `" . $database->pref . "forum_forum`
                    WHERE `forum_categorie` = '" . $_GET['id'] . "';";

            $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            while ( $row = $database->ResultArray ( $req ) )
            {
                // On supprime tous les messages de cette catégorie
                $sql = "DELETE FROM `" . $database->pref . "forum_msg`
                        WHERE `forum_msg_forum` = '" . $row['forum_id'] . "';";

                $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                // On supprime tous les sujets de cette catégorie
                $sql = "DELETE FROM `" . $database->pref . "forum_sujet`
                        WHERE `sujet_forum` = '" . $row['forum_id'] . "';";

                $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );
            }

            // On supprime les forums de cette catégorie
            $sql = "DELETE FROM `" . $database->pref . "forum_forum`
                    WHERE `forum_categorie` = '" . $_GET['id'] . "';";

            $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            // On supprime la catégorie
            $sql = "DELETE FROM `" . $database->pref . "forum_cat`
                    WHERE `forum_cat_id` = '" . $_GET['id'] . "';";

            $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }

        $sql = "SELECT COUNT(*) AS `count`
                FROM `" . $database->pref . "forum_cat`";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        $deplacer = ( $database->Result ( $req , 'forum_cat' ) == 1 ) ? '#' : 'index.' . EXT . '?page=Administration_des_forums&amp;action=deplacer_cat&id=' . $_GET['id'];

        $page_texte .= '<p><a href="index.' . EXT . '?page=Administration_des_forums" title="' . $langue['admin_forums_texte'] . "\">" . $langue['admin_forums'] . "</a></p>\n";
        $page_texte .= "<p>La suppression d'un forum entraine la suppression des sujets et des messages de ce forum.<br />Pour supprimer le forum en conservant ses sujets et ses messages (en les déplaçant vers un autre forum), <a href=\"" . $deplacer . "\">cliquez-ici</a>, sinon <a href=\"" . 'index.' . EXT . '?page=Administration_des_forums&action=supprimer_cat&id=' . $_GET['id'] . '&ok' . "\">cliquez-ici</a>.</p>\n";

    break;

    // Faire monter une catégorie (diminuer son numéro d'ordre)
    case 'monter_cat':

        if ( !isset ( $_GET['id'] ) && !is_numeric ( $_GET['id'] ) || $_GET['id'] < 1 )
        {
            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }

        // On vérifie que la catégorie existe
        $sql = "SELECT `forum_cat_ordre`
                FROM `" . $database->pref . "forum_cat`
                WHERE `forum_cat_id` = '" . $_GET['id'] . "';";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        if ( $database->NbrRowsSelected ( $req ) === 0 )
        {
            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }

        $ordre = $database->Result ( $req , 'forum_cat_ordre' );

        // On vérifie qu'on peut faire monter la catégorie
        $sql = "SELECT COUNT(*) `count`
                FROM `" . $database->pref . "forum_cat`
                WHERE `forum_cat_ordre` = '" . ( $ordre - 1 ) . "';";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        if ( $database->Result ( $req , 'count' ) == 0 )
        {
            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }

        // On change le numéro d'ordre de la catégorie suivante temporairement
        $sql = "UPDATE `" . $database->pref . "forum_cat`
                SET `forum_cat_ordre` = '0'
                WHERE `forum_cat_ordre` = '" . ( $ordre - 1 ) . "';";

        $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        // On change le numéro d'ordre de cette catégorie
        $sql = "UPDATE `" . $database->pref . "forum_cat`
                SET `forum_cat_ordre` = '" . ( $ordre - 1 ) . "'
                WHERE `forum_cat_id` = '" . $_GET['id'] . "';";

        $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        // On change le numéro d'ordre de la catégorie suivante
        $sql = "UPDATE `" . $database->pref . "forum_cat`
                SET `forum_cat_ordre` = '" . $ordre . "'
                WHERE `forum_cat_ordre` = '0';";

        $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
        die ( -1 );

    break;

    // Faire descendre une catégorie (diminuer son numéro d'ordre)
    case 'descendre_cat':

        if ( !isset ( $_GET['id'] ) && !is_numeric ( $_GET['id'] ) || $_GET['id'] < 1 )
        {
            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }

        // On vérifie que le forum existe
        $sql = "SELECT `forum_cat_ordre`
                FROM `" . $database->pref . "forum_cat`
                WHERE `forum_cat_id` = '" . $_GET['id'] . "';";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        if ( $database->NbrRowsSelected ( $req ) === 0 )
        {
            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }

        $ordre = $database->Result ( $req , 'forum_cat_ordre' );

        $sql = "SELECT COUNT(*) AS `count`
                FROM `" . $database->pref . "forum_cat`
                WHERE `forum_cat_ordre` = '" . ( $ordre + 1 ) ."';";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        // On vérifie qu'on peut faire descendre le forum
        if ( $database->Result ( $req , 'count' ) == 0 )
        {
            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }

        // On change le numéro d'ordre de la catégorie suivante temporairement
        $sql = "UPDATE `" . $database->pref . "forum_cat`
                SET `forum_cat_ordre` = '0'
                WHERE `forum_cat_ordre` = '" . ( $ordre + 1 ) . "';";

        $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        // On change le numéro d'ordre de cette catégorie
        $sql = "UPDATE `" . $database->pref . "forum_cat`
                SET `forum_cat_ordre` = '" . ( $ordre + 1 ) . "'
                WHERE `forum_cat_id` = '" . $_GET['id'] . "';";

        $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        // On change le numéro d'ordre de la catégorie suivante
        $sql = "UPDATE `" . $database->pref . "forum_cat`
                SET `forum_cat_ordre` = '" . $ordre . "'
                WHERE `forum_cat_ordre` = '0';";

        $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
        die ( -1 );

    break;

    // Déplacer une catégorie
    case 'deplacer_cat':

        if ( !isset ( $_GET['id'] ) && !is_numeric ( $_GET['id'] ) || $_GET['id'] < 1 )
        {
            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }

        $page_texte .= '<p><a href="index.' . EXT . '?page=Administration_des_forums" title="' . $langue['admin_forums_texte'] . '">' . $langue['admin_forums'] . "</a></p>\n";

        // Traitement des données du formulaire
        if ( isset ( $_POST['submit'] ) )
        {
            if ( empty ( $_POST['destination'] ) || !is_numeric ( $_POST['destination'] ) )
            {
                $page_texte .= '<p><strong>' . $langue['erreur'] . '</strong>&nbsp;: ' . $langue['err_oblig'] . "</p>\n\n";
            }
            else
            {
                // On récupère le dernier numéro d'ordre des forums de la nouvelle catégorie
                $ordre = 0;

                $sql = "SELECT `forum_ordre`
                        FROM `" . $database->pref . "forum_forum`
                        WHERE `forum_categorie` = '" . $_POST['destination'] . "';";

                $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                while ( $row = $database->ResultArray ( $req ) )
                {
                    if ( $row['forum_ordre'] > $ordre )
                    {
                        $ordre = $row['forum_ordre'];
                    }
                }

                // On change la catégorie et le numéro d'ordre des forums de la catégorie
                $sql = "UPDATE `" . $database->pref . "forum_forum`
                        SET `forum_categorie` = '" . $_POST['destination'] . "',
                            `forum_ordre` = forum_ordre+" . $ordre . "
                        WHERE `forum_categorie` = '" . $_GET['id'] . "';";

                $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                header ( 'Location: index.' . EXT . '?page=Administration_des_forums&amp;action=supprimer_cat&amp;id=' . $_GET['id'] . '&ok' );
                die ( -1 );
            }
        }
        $page_texte .= '<form action="index.' . EXT . '?page=Administration_des_forums&amp;action=deplacer_cat&amp;id=' . $_GET['id'] . "\" method=\"post\" title=\"Déplacement de la catégorie\">\n\n";

        $page_texte .= "<fieldset>\n<legend>Déplacement de la catégorie</legend>\n\n";
        $page_texte .= "<label for=\"id_destination\">Catégorie de destination :</label> <select name=\"destination\" id=\"id_destination\">\n";

        $sql = "SELECT `forum_cat_id`, `forum_cat_nom`
                FROM `" . $database->pref . "forum_cat`
                WHERE `forum_cat_id` <> '" . $_GET['id'] . "'
                ORDER BY `forum_cat_nom` ASC;";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        while ( $row = $database->ResultArray ( $req ) )
        {
            $page_texte .= '  <option value="' . $row['forum_cat_id'] . "\">" . $row['forum_cat_nom'] . "</option>\n";
        }

        $page_texte .= "</select><br/>\n\n</fieldset>\n\n<p class=\"cleaner\"><input type=\"submit\" name=\"submit\" value=\"" . $langue['valider'] . "\" accesskey=\"s\" /></p>\n\n</form>\n";

    break;

    case 'nouvelle_cat':

        $page_texte .= '<p><a href="index.' . EXT . '?page=Administration_des_forums' . "\" title=\"Administration des forums\">Administration des forums</a></p>\n";

        // Traitement des données du formulaire
        if ( isset ( $_POST['submit'] ) )
        {
            if ( empty ( $_POST['nom'] ) )
            {
                $page_texte .= '<p><strong>' . $langue['erreur'] . '</strong>&nbsp;: ' . $langue['err_oblig'] . "</p>\n\n";
            }
            else
            {
                // On recherche le numéro d'ordre de cette catégorie
                $ordre = 0;

                $sql = "SELECT `forum_cat_ordre`
                        FROM `" . $database->pref . "forum_cat`;";

                $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                while ( $row = $database->ResultArray ( $req ) )
                {
                    if ( $row['forum_cat_ordre'] > $ordre )
                    {
                        $ordre = $row['forum_cat_ordre'];
                    }
                }

                $sql = "SELECT COUNT(*) AS `count`
                        FROM `" . $database->pref . "forum_cat`
                        WHERE `forum_cat_nom` = '" . $_POST['nom'] . "';";

                $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                // On cherche si une catégorie porte déjà ce nom
                if ( $database->Result ( $req , 'count' ) > 0 )
                {
                    $page_texte .= '<p><strong>' . $langue['erreur'] . "</strong>&nbsp;: Le nom choisi est déjà utilisé.</p>\n\n";
                }
                else
                {
                    $sql = "INSERT INTO `" . $database->pref . "forum_cat`
                            (`forum_cat_nom`, `forum_cat_ordre`)
                            VALUES
                            ('" . $database->Protege ( $_POST['nom'] ) . "', '" . ( $ordre + 1 ) . "');";

                    $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                    header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
                    die ( -1 );
                }
            }
        }

        $page_texte .= "\n<form action=\"" . 'index.' . EXT . '?page=Administration_des_forums&amp;action=nouvelle_cat' . "\" method=\"post\" title=\"Nouvelle catégorie\">\n\n";
        $page_texte .= "<fieldset>\n<legend>Nouvelle catégorie</legend>\n\n";
        $page_texte .= "<label for=\"id_nom\">Nom&nbsp;:</label> <input name=\"nom\" id=\"id_nom\" value=\"\" size=\"35\" type=\"text\" /> ";
        $page_texte .= "<input type=\"submit\" name=\"submit\" value=\"" . $langue['valider'] . "\" accesskey=\"s\" />\n\n</fieldset>\n\n</form>\n";

    break;

    // Page principale
    default:

        // Traitement du formulaire
        if ( isset ( $_POST['submit'] ) )
        {
            // Le nombre de message par page doit être compris entre 0 et 100
            if ( $_POST['msg_page'] > 0 && $_POST['msg_page'] < 100 && $configuration['msg_page'] != $_POST['msg_page'] )
            {
                $sql = "UPDATE `" . $database->pref . "configuration`
                        SET `config_valeur` = '" . $_POST['msg_page'] . "'
                        WHERE `config_nom` = 'msg_page';";

                $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );
            }

            // Le nombre de sujet par page doit être compris entre 0 et 200
            if ( $_POST['sujet_page'] > 0 && $_POST['sujet_page'] < 200 && $configuration['sujet_page'] != $_POST['sujet_page'] )
            {
                $sql = "UPDATE `" . $database->pref . "configuration`
                        SET `config_valeur` = '" . $_POST['sujet_page'] . "'
                        WHERE `config_nom` = 'sujet_page';";

                $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );
            }

            if ( $configuration['tps_sujet'] != $_POST['tps_sujet'] )
            {
                $sql = "UPDATE `" . $database->pref . "configuration`
                        SET `config_valeur` = '" . $_POST['tps_sujet'] . "'
                        WHERE `config_nom` = 'tps_sujet';";

                $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );
            }

            if ( $configuration['tps_msg'] != $_POST['tps_msg'] )
            {
                $sql = "UPDATE `" . $database->pref . "configuration`
                        SET `config_valeur` = '" . $_POST['tps_msg'] . "'
                        WHERE `config_nom` = 'tps_msg';";

                $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );
            }

            header ( 'Location: index.' . EXT . '?page=Administration_des_forums' );
            die ( -1 );
        }


        // En-tête du tableau
        $page_texte .= "\n<table>\n\n";
        $page_texte .= "<thead>\n<tr>\n";
        $page_texte .= "  <th colspan=\"2\">Ordre</th>\n";
        $page_texte .= "  <th>Forums</th>\n";
        $page_texte .= '  <th>' . $langue['actions'] . "</th>\n";
        $page_texte .= "</tr>\n</thead>\n\n<tbody>\n";


        // Liste des catégories
        $sql = "SELECT `forum_cat_id`,
                       `forum_cat_nom`,
                       `forum_cat_ordre`
                FROM `" . $database->pref . "forum_cat`
                ORDER BY `forum_cat_ordre` ASC;";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        if ( $database->NbrRowsSelected ( $req ) > 0 )
        {
            while ( $row = $database->ResultArray ( $req ) )
            {
                $categorie = $row['forum_cat_id'];

                $page_texte .= "<tr class=\"forum_categorie\">\n";
                $page_texte .= "  <td class=\"centre\">";

                if ( $database->NbrRowsSelected ( $req ) > 1 )
                {
                    // Modifier l'ordre des catégories
                    if ( $row['forum_cat_ordre'] == 1 )
                    {
                        $page_texte .= "</td>\n";
                        $page_texte .= '  <td class="centre"><a href="index.' . EXT . '?page=Administration_des_forums&amp;action=descendre_cat&amp;id=' . $row['forum_cat_id'] . "\"><img src=\"themes/" . $configuration['style'] . "/images/descendre.png\" title=\"Faire descendre cette catégorie dans la liste\" alt=\"[+]\" /></a>";
                    }
                    else if ( $row['forum_cat_ordre'] == $database->NbrRowsSelected ( $req ) )
                    {
                        $page_texte .= '<a href="index.' . EXT . '?page=Administration_des_forums&amp;action=monter_cat&amp;id=' . $row['forum_cat_id'] . "\"><img src=\"themes/" . $configuration['style'] . "/images/monter.png\" title=\"Faire monter cette catégorie dans la liste\" alt=\"[-]\" /></a></td>\n";
                        $page_texte .= "  <td class=\"centre\">";
                    }
                    else
                    {
                        $page_texte .= '<a href="index.' . EXT . '?page=Administration_des_forums&amp;action=monter_cat&amp;id=' . $row['forum_cat_id'] . "\"><img src=\"themes/" . $configuration['style'] . "/images/monter.png\" title=\"Faire monter cette catégorie dans la liste\" alt=\"[-]\" /></a></td>\n";
                        $page_texte .= "  <td class=\"centre\"><a href=\"" . 'index.' . EXT . '?page=Administration_des_forums&amp;action=descendre_cat&id=' . $row['forum_cat_id'] . "\"><img src=\"themes/" . $configuration['style'] . "/images/descendre.png\" title=\"Faire descendre cette catégorie dans la liste\" alt=\"[+]\" /></a>";
                    }
                }
                else
                {
                    $page_texte .= "</td>\n  <td class=\"centre\">";
                }

                $deplacer = ( $database->NbrRowsSelected ( $req ) === 1 ) ? '#' : 'index.' . EXT . '?page=Administration_des_forums&amp;action=deplacer_cat&amp;id=' . $row['forum_cat_id'];

                $page_texte .= "</td>\n";
                $page_texte .= '  <td><a href="index.' . EXT . '?page=Forums&cat=' . $row['forum_cat_id'] . '">' . $row['forum_cat_nom'] . "</a></td>\n";
                $page_texte .= '  <td class="centre"><a href="' . 'index.' . EXT . '?page=Administration_des_forums&amp;action=modifier_cat&amp;id=' . $row['forum_cat_id'] . "\">Modifier</a> - ";
                $page_texte .= '<a href="' . $deplacer . "\">Déplacer les forums</a> - ";
                $page_texte .= '<a href="index.' . EXT . '?page=Administration_des_forums&action=supprimer_cat&amp;id=' . $row['forum_cat_id'] . "\">Supprimer</a></td>\n";
                $page_texte .= "</tr>\n";

                // Affichage des forums de la catégorie
                $sql = "SELECT `forum_ordre`,
                               `forum_id`,
                               `forum_nom`
                        FROM `" . $database->pref . "forum_forum`
                        WHERE `forum_categorie` = '" . $row['forum_cat_id'] . "'
                        ORDER BY `forum_ordre` ASC;";

                $req2 = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                if ( $database->NbrRowsSelected ( $req2 ) > 0 )
                {
                    while ( $row2 = $database->ResultArray ( $req2 ) )
                    {
                        $page_texte .= "<tr>\n  <td class=\"centre\">";

                        if ( $database->NbrRowsSelected ( $req2 ) > 1 )
                        {
                            // Modifier l'ordre des forums
                            if ( $row2['forum_ordre'] == 1 )
                            {
                                $page_texte .= "</td>\n";
                                $page_texte .= '  <td class="centre"><a href="' . 'index.' . EXT . '?page=Administration_des_forums&amp;action=descendre_forum&amp;id=' . $row2['forum_id'] . "\"><img src=\"themes/" . $configuration['style'] . "/images/descendre.png\" title=\"Faire descendre ce forum dans la liste\" alt=\"[+]\" /></a>";
                            }
                            else if ( $row2['forum_ordre'] == $database->NbrRowsSelected ( $req2 ) )
                            {
                                $page_texte .= '<a href="index.' . EXT . '?page=Administration_des_forums&amp;action=monter_forum&amp;id=' . $row2['forum_id'] . "\"><img src=\"themes/" . $configuration['style'] . "/images/monter.png\" title=\"Faire monter ce forum dans la liste\" alt=\"[-]\" /></a></td>\n";
                                $page_texte .= "  <td class=\"centre\">";
                            }
                            else
                            {
                                $page_texte .= '<a href="index.' . EXT . '?page=Administration_des_forums&amp;action=monter_forum&amp;id=' . $row2['forum_id'] . "\"><img src=\"themes/" . $configuration['style'] . "/images/monter.png\" title=\"Faire monter ce forum dans la liste\" alt=\"[-]\" /></a></td>\n";
                                $page_texte .= "  <td class=\"centre\"><a href=\"" . 'index.' . EXT . '?page=Administration_des_forums&amp;action=descendre_forum&amp;id=' . $row2['forum_id'] . "\"><img src=\"themes/" . $configuration['style'] . "/images/descendre.png\" title=\"Faire descendre ce forum dans la liste\" alt=\"[+]\" /></a>";
                            }
                        }
                        else
                        {
                            $page_texte .= "</td>\n  <td class=\"centre\">";
                        }

                        $deplacer = ( $database->NbrRowsSelected ( $req2 ) === 1 ) ? '#' : 'index.' . EXT . '?page=Administration_des_forums&amp;action=deplacer_forum&amp;id=' . $row2['forum_id'];

                        $page_texte .= "</td>\n";
                        $page_texte .= '  <td><a href="index.' . EXT . '?page=Forums&id=' . $row2['forum_id'] . '">' . $row2['forum_nom'] . "</a></td>\n";
                        $page_texte .= "  <td class=\"centre\"><a href=\"" . 'index.' . EXT . '?page=Administration_des_forums&amp;action=modifier_forum&amp;id=' . $row2['forum_id'] . '">' . $langue['modifier'] . '</a> - ';
                        $page_texte .= '<a href="' . $deplacer . "\">Déplacer les messages</a> - ";
                        $page_texte .= '<a href="index.' . EXT . '?page=Administration_des_forums&amp;action=changer_categorie&amp;id=' . $row2['forum_id'] . "\">Changer la catégorie</a> - ";
                        $page_texte .= '<a href="index.' . EXT . '?page=Administration_des_forums&amp;action=supprimer_forum&amp;id=' . $row2['forum_id'] . "\">" . $langue['supprimer'] . "</a></td>\n";

                        $page_texte .= "</tr>\n";
                    } // Boucle d'affichage des forums
                }

                $page_texte .= "<tr>\n  <td colspan=\"2\"></td>\n";
                $page_texte .= '  <td colspan="2"><a href="index.' . EXT . '?page=Administration_des_forums&amp;action=nouveau_forum&amp;id=' . $row['forum_cat_id'] . '">' . $langue['nouveau_forum'] . "</a></td>\n</tr>\n";
            } // Boucle d'affichage des catégories
        }

        $page_texte .= "<tr class=\"forum_categorie\">\n";
        $page_texte .= "  <td colspan=\"2\"></td>\n";
        $page_texte .= '  <td colspan="2"><a href="index.' . EXT . '?page=Administration_des_forums&amp;action=nouvelle_cat">' . $langue['nouvelle_categorie'] . "</a></td>\n</tr>\n";
        $page_texte .= "</tbody>\n\n</table>\n";


        // Configuration
        $page_texte .= '<form action="index.' . EXT . '?page=Administration_des_forums' . "\" method=\"post\" title=\"Configuration générale\">\n\n";
        $page_texte .= "<fieldset>\n<legend>Configuration générale</legend>\n\n";
        $page_texte .= "<p class=\"form_input\"><label class=\"form_label\" for=\"id_sujet_page\">Sujets par page&nbsp;:</label><input name=\"sujet_page\" id=\"id_sujet_page\" value=\"" . $configuration['sujet_page'] . "\" size=\"10\" type=\"text\" /></p>\n";
        $page_texte .= "<p class=\"form_input\"><label class=\"form_label\" for=\"id_msg_page\">Messages par page&nbsp;:</label><input name=\"msg_page\" id=\"id_msg_page\" value=\"" . $configuration['msg_page'] . "\" size=\"10\" type=\"text\" /></p>\n";
        $page_texte .= "<p class=\"form_input\"><label class=\"form_label\" for=\"id_tps_sujet\">Durée avant de pouvoir créer un nouveau sujet&nbsp;:</label><input name=\"tps_sujet\" id=\"id_tps_sujet\" value=\"" . $configuration['tps_sujet'] . "\" size=\"10\" type=\"text\" /> <small>secondes</small></p>\n\n";
        $page_texte .= "<p class=\"form_input\"><label class=\"form_label\" for=\"id_tps_msg\">Durée avant de pouvoir poster une nouvelle réponse&nbsp;:</label><input name=\"tps_msg\" id=\"id_tps_msg\" value=\"" . $configuration['tps_msg'] . "\" size=\"10\" type=\"text\" /> <small>secondes</small></p>\n\n";
        $page_texte .= "</fieldset>\n\n<p class=\"cleaner\"><input type=\"submit\" name=\"submit\" value=\"" . $langue['valider'] . "\" accesskey=\"s\" /></p>\n\n</form>\n";

    break;
}

?>