<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /pages/Ajouter_un_article.php
 *  Date de création : avant le 13/08/2007
 *  Dernière modification : 29/08/2007
 ***************************************************************************/

// Sécurité
if ( !defined ( 'TAGADASH' ) )
{
    header ( 'Location: ../' );
    die ( -1 );
}


// Droits de création d'un article
if ( $droit['article_edition'] == 0 )
{
    $page_msg = 3;
    include_once ( 'systeme/msg.' . EXT );
}


// Titre de la page
$page_titre = $langue['newarticle'];
$page_infos = $langue['newarticle'];


// Traitement des données du formulaire
if ( isset ( $_POST['submit'] ) )
{
    $form_champ_titre = $_POST['titre'];
    $form_champ_texte = $_POST['texte'];
    $form_langues = $site->FormSelect ( $langues , $_POST['langue'] );


    // Liste des catégories
    $form_categories = '';
    $categorie = 0;

    $sql = "SELECT cata.`cat_id` AS `categorie_id`,
                   cata.`cat_nom` AS `categorie_nom`,
                   catb.`cat_id` AS `sous_categorie_id`,
                   catb.`cat_nom` AS `sous_categorie_nom`
            FROM `" . $database->pref . "article_cat` cata
            LEFT JOIN `" . $database->pref . "article_cat` catb
                ON catb.`cat_categorie` = cata.`cat_id`
            WHERE cata.`cat_categorie` = '0'
            ORDER BY
                cata.`cat_nom` ASC,
                catb.`cat_nom` ASC;";

    $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );
    
    while ( $row = $database->ResultArray ( $req ) )
    {
        if ( $row['categorie_id'] != $categorie )
        {
            $form_categories .= '  <option value="' . $row['categorie_id'] . '"';
            if ( $row['categorie_id'] == $_POST['categorie'] ) $form_categories .= ' selected="selected"';
            $form_categories .= '>' . $row['categorie_nom'] . "</option>\n";
            $categorie = $row['categorie_id'];
        }

        if ( !empty ( $row['sous_categorie_id'] ) )
        {
            $form_categories .= '  <option value="' . $row['sous_categorie_id'] . '"';
            if ( $row['sous_categorie_id'] == $_POST['categorie'] ) $form_categories .= ' selected="selected"';
            $form_categories .= '>' . $row['categorie_nom'] . ' - ' . $row['sous_categorie_nom'] . "</option>\n";
        }
    }


    if ( empty ( $_POST['titre'] ) || empty ( $_POST['texte'] ) )
    {
        $page_texte .= '<p><strong>' . $langue['erreur'] . '</strong>&nbsp;: ' . $langue['err_oblig'] . "</p>\n\n";
    }
    else
    {
        $auteur = ( $_SESSION['groupe'] != 1 ) ? $_SESSION['membre_id'] : 0;

        $sql = "SELECT `article_id`
                FROM `" . $database->pref . "article_article`
                WHERE
                        `article_titre` = '" . $database->Protege ( $_POST['titre'] ) . "'
                    AND `article_categorie` = '" . $_POST['categorie'] . "';";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        if ( $database->NbrRowsSelected ( $req ) > 0 )
        {
            $page_texte .= sprintf ( "\n<p><strong>%s</strong>&nbsp;: " . $langue['err_article_isset'] . "</p>\n" , $langue['erreur'] , '<a href="index.' . EXT . '?page=Article&amp;id=' . $database->Result ( $req , 'article_id' ) . '">' . $_POST['titre'] . '</a>' );
        }
        else
        {
            $sql = "INSERT INTO `" . $database->pref . "article_article`
                    (`article_titre`, `article_texte`, `article_auteur`, `article_modification`, `article_compteur`, `article_langue`, `article_categorie`)
                    VALUES
                    ('" . $database->Protege ( $_POST['titre'] ) . "', '" . $database->Protege ( $_POST['texte'] ) . "', '" . $auteur . "', '" . $time . "', '0', '" . $_POST['langue'] . "', '" . $_POST['categorie'] . "');";

            $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            $article_id = $database->LastInsertId ( $req );

            $sql = "INSERT INTO `" . $database->pref . "article_historique`
                    (`historique_titre`, `historique_article`, `historique_texte`, `historique_auteur`, `historique_time`, `historique_langue`, `historique_categorie`)
                    VALUES
                    ('" . $database->Protege ( $_POST['titre'] ) . "', '" . $article_id . "', '" . $database->Protege ( $_POST['texte'] ) . "', '" . $auteur . "', '" . $time . "', '" . $_POST['langue'] . "', '" . $_POST['categorie'] . "');";

            $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            header ( 'Location: index.' . EXT . '?page=Article&id=' . $article_id );
            die ( -1 );
        }
    }
}
else
{
    $form_langues = $site->FormSelect ( array ( $langue['langue_fr'] => 'fr' ) );

    // Liste des catégories
    $form_categories = '';
    $categorie = 0;

    $sql = "SELECT cata.`cat_id` AS `categorie_id`,
                   cata.`cat_nom` AS `categorie_nom`,
                   catb.`cat_id` AS `sous_categorie_id`,
                   catb.`cat_nom` AS `sous_categorie_nom`
            FROM `" . $database->pref . "article_cat` cata
            LEFT JOIN `" . $database->pref . "article_cat` catb
                ON catb.`cat_categorie` = cata.`cat_id`
            WHERE cata.`cat_categorie` = '0'
            ORDER BY
                cata.`cat_nom` ASC,
                catb.`cat_nom` ASC;";

    $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );
    
    while ( $row = $database->ResultArray ( $req ) )
    {
        if ( $row['categorie_id'] != $categorie )
        {
            $form_categories .= '  <option value="' . $row['categorie_id'] . '">' . $row['categorie_nom'] . "</option>\n";
            $categorie = $row['categorie_id'];
        }

        if ( !empty ( $row['sous_categorie_id'] ) )
        {
            $form_categories .= '  <option value="' . $row['sous_categorie_id'] . '">' . $row['categorie_nom'] . ' - ' . $row['sous_categorie_nom'] . "</option>\n";
        }
    }
}


// Formulaire

$form_adresse = 'index.' . EXT . '?page=Ajouter_un_article';
$form_titre = $langue['newarticle'];

include ( 'systeme/form_article.' . EXT );

?>