<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /pages/Bannir.php
 *  Date de création : avant le 13/08/2007
 *  Dernière modification : 31/08/2007
 ***************************************************************************/

// Sécurité
if ( !defined ( 'TAGADASH' ) )
{
    header ( 'Location: ../' );
    die ( -1 );
}


// Droit d'administration
if ( $_SESSION['groupe'] == 1 || $droit['administration'] == 0 )
{
    $page_msg = 2;
    include_once ( 'systeme/msg.' . EXT );
}


// Titre de la page
$page_titre = $langue['bannir'];
$page_infos = $langue['administration_texte'];


if ( isset ( $_GET['membre'] ) )
{
    $sql = "SELECT `stat_ip`
            FROM `" . $database->pref . "membres`
            LEFT JOIN `" . $database->pref . "stat`
                ON `stat_membre` = `membre_id`
            GROUP BY `stat_ip`;";

    $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

    if ( $database->NbrRowsSelected ( $req ) > 0 )
    {
        if ( $_GET['membre'] == $_SESSION['membre_id'] )
        {
            header ( 'Location: index.' . EXT . '?page=Membre&id=' . $_GET['membre'] );
            die ( -1 );
        }

        while ( $row = $database->ResultArray ( $req ) )
        {
            if ( $row['stat_ip'] == ConvertIP ( $_SERVER['REMOTE_ADDR'] , '' ) )
            {
                continue;
            }

            $sql = "INSERT INTO `" . $database->pref . "bannis`
                    (`banni_ip`, `banni_time`, `banni_duree`, `banni_membre`, `banni_motif`)
                    VALUES
                    ('" . $row['stat_ip'] . "', '" . $time . "', '604800', '" . $_SESSION['membre_id'] . "', '');";

            $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );
        }

        header ( 'Location: index.' . EXT . '?page=Membre&id=' . $_GET['membre'] );
        die ( -1 );
    }
}



if ( isset ( $_GET['supprimer'] ) )
{
    $sql = "SELECT COUNT(*) AS `count`
            FROM `" . $database->pref . "bannis`
            WHERE `banni_ip` = '" . $_GET['supprimer'] . "';";

    $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

    if ( $database->Result ( $req , 'count' ) > 0 )
    {
        $sql = "DELETE FROM `" . $database->pref . "bannis`
                WHERE `banni_ip` = '" . $_GET['supprimer'] . "';";

        $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );
    }
}

if ( isset ( $_POST['submit'] ) )
{
    // Vérification de l'adresse IP
    if ( !preg_match ( "#^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$#" , $_POST['ip'] ) )
    {
        $page_texte .= '<p><strong>' . $langue['erreur'] . '</strong>&nbsp;: ' . 'Le format de l\'adresse IP n\'est pas correct.' . "</p>\n\n";
    }
    else if ( $_POST['ip'] == $_SERVER['REMOTE_ADDR'] )
    {
        $page_texte .= '<p><strong>' . $langue['erreur'] . '</strong>&nbsp;: ' . 'Vous ne pouvez pas bannir votre propre adresse IP !' . "</p>\n\n";
    }
    else
    {
        $sql = "SELECT COUNT(*) AS `count`
                FROM `" . $database->pref . "bannis`
                WHERE `banni_ip` = '" . ConvertIP ( $_POST['ip'] , '' ) . "';";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        // On vérifie que l'adresse n'est pas déjà bannies
        if ( $database->Result ( $req , 'count' ) > 0 )
        {
            $page_texte .= '<p><strong>' . $langue['erreur'] . '</strong>&nbsp;: ' . 'Cette adresse IP est déjà dans la liste.' . "</p>\n\n";
        }
        else
        {
            $sql = "INSERT INTO `" . $database->pref . "bannis`
                    (`banni_ip`, `banni_time`, `banni_duree`, `banni_membre`, `banni_motif`)
                    VALUES
                    ('" . ConvertIP ( $_POST['ip'] , '' ) . "', '" . $time . "', '" . $_POST['duree'] * $_POST['duree_unite'] . "', '" . $_SESSION['membre_id'] . "', '" . $_POST['motif'] . "');";

            $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            $page_texte .= "\n<p>L'adresse IP <q>" . $_POST['ip'] . "</q> a été ajoutée à la liste.</p>\n";
        }
    }
}

// Formulaire pour ajouter une adresse IP
$page_texte .= "<form action=\"" . 'index.' . EXT . '?page=Bannir' . "\" title=\"Bannir une adresse IP\" method=\"post\">

<fieldset>
<legend>Bannir une adresse IP</legend>

<p class=\"form_input\"><label class=\"form_label\" for=\"id_ip\">Adresse IP&nbsp;:</label><input type=\"text\" size=\"30\" name=\"ip\" id=\"id_ip\" value=\"\" tabindex=\"10\" /></p>
<p class=\"form_input\"><label class=\"form_label\" for=\"id_duree\">" . $langue['duree'] . "&nbsp;:</label><input type=\"text\" name=\"duree\" id=\"id_duree\" size=\"10\" value=\"5\" tabindex=\"11\" /> 
<select id=\"id_duree_unite\" name=\"duree_unite\" tabindex=\"12\">
  <option value=\"86400\" selected=\"selected\">jours</option>
  <option value=\"604800\">semaines</option>
  <option value=\"2592000\">mois</option>
  <option value=\"0\">définitivement</option>
</select></p>
<p class=\"form_input\"><label class=\"form_label\" for=\"id_motif\">Motif&nbsp;:</label><input type=\"text\" size=\"30\" name=\"motif\" id=\"id_motif\" value=\"\" tabindex=\"13\" /></p>

</fieldset>

<p class=\"centre\"><input type=\"submit\" name=\"submit\" accesskey=\"s\" value=\"" . $langue['valider'] . "\" tabindex=\"14\" /></p>

</form>\n<br />\n";

$page_texte .= "\n<table>\n\n<thead>\n<tr>\n";
$page_texte .= "  <th class=\"bannis_adresse\">Adresse IP</th>\n";
$page_texte .= '  <th class="bannis_date">' . $langue['date'] . "</th>\n";
$page_texte .= '  <th class="bannis_duree">' . $langue['duree'] . "</th>\n";
$page_texte .= "  <th class=\"bannis_motif\">Motif</th>\n";
$page_texte .= "</tr>\n</thead>\n\n<tbody>\n";

// Affichage de la liste des adresses IP bannies
$sql = "SELECT `banni_ip`,
               `banni_duree`,
               `banni_time`,
               `banni_motif`
        FROM `" . $database->pref . "bannis`
        ORDER BY `banni_ip` ASC;";

$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

if ( $database->NbrRowsSelected ( $req ) > 0 )
{
    while ( $row = $database->ResultArray ( $req ) )
    {
        // Si la durée du bannissement est dépassé, on supprime l'entrée
        if ( $row['banni_time'] + $row['banni_time'] > $time )
        {
            $sql = "DELETE FROM `" . $database->pref . "bannis`
                    WHERE `banni_ip` = '" . $row['banni_ip'] . "';";

            $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            continue;
        }
    
        $page_texte .= "<tr>\n  ";
        $page_texte .= "<td>" . ConvertIP ( '' , $row['banni_ip'] ) . ' [<a href="index.' . EXT . '?page=Bannir&amp;supprimer=' . $row['banni_ip'] . "\">Supprimer</a>]</td>\n";
        $page_texte .= '  <td class="centre">' . date ( $configuration['format_date'] , $row['banni_time'] ) . $langue['time_at'] . date ( $configuration['format_heure'] , $row['banni_time'] ) . "</td>\n";
        $page_texte .= '  <td>';

        // On simplifie la durée si possible
        if (  $row['banni_duree'] === 0 ) $page_texte .= 'Définitivement';
        else if ( $row['banni_duree'] / 31536000 === 1 ) $page_texte .= '1 année';
        else if ( $row['banni_duree'] % 31536000 === 0 ) $page_texte .= ( $row['banni_duree'] / 31536000 ). ' années';
        else if ( $row['banni_duree'] / 2592000 === 1 ) $page_texte .= '1 mois';
        else if ( $row['banni_duree'] % 2592000 === 0 ) $page_texte .= ( $row['banni_duree'] / 2592000 ). ' mois';
        else if ( $row['banni_duree'] / 604800 === 1 ) $page_texte .= '1 semaine';
        else if ( $row['banni_duree'] % 604800 === 0 ) $page_texte .= ( $row['banni_duree'] / 604800 ). ' semaines';
        else if ( $row['banni_duree'] / 86400 === 1 ) $page_texte .= '1 jour';
        else if ( $row['banni_duree'] % 86400 === 0 ) $page_texte .= ( $row['banni_duree'] / 86400 ). ' jours';
        else if ( $row['banni_duree'] / 3600 === 1 ) $page_texte .= '1 heure';
        else if ( $row['banni_duree'] % 3600 === 0 ) $page_texte .= ( $row['banni_duree'] / 3600 ). ' heures';
        else if ( $row['banni_duree'] / 60 === 1 ) $page_texte .= '1 minute';
        else if ( $row['banni_duree'] % 60 === 0 ) $page_texte .= ( $row['banni_duree'] / 60 ). ' minutes';
        else $page_texte .= $row['banni_duree'] . ' secondes';

        $page_texte .= "</td>\n";
        $page_texte .= '  <td>' . $row['banni_motif'] . "</td>\n";
        $page_texte .= "</tr>\n";
    }
}
else
{
    $page_texte .= "<tr>\n  <td colspan=\"4\">Aucune adresse IP n'a été bannie.</td>\n</tr>\n";
}

$page_texte .= "</tbody>\n\n</table>\n";

?>