<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /pages/Commentaires.php
 *  Date de création : 02/08/2007
 *  Dernière modification : 10/09/2007
 ***************************************************************************/

// Sécurité
if ( !defined ( 'TAGADASH' ) )
{
    header ( 'Location: ../' );
    die ( -1 );
}


$action = ( isset ( $_GET['action'] ) ) ? $_GET['action'] : '';

switch ( $action )
{
    // Nouveau commentaire
    case 'nouveau':

        $page_titre = $langue['nouveau_commentaire'];
        $page_infos = $langue['nouveau_commentaire'];

        if ( isset ( $_GET['article'] ) )
        {
            // Droits : article_commentaire
            if ( $droit['article_commentaire'] == 0 )
            {
                $page_msg = 5;
                include_once ( 'systeme/msg.' . EXT );
            }


            $sql = "SELECT COUNT(*) AS `count`
                    FROM `" . $database->pref . "article_article`
                    WHERE `article_id` = '" . $_GET['article'] . "';";

            $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            if ( $database->Result ( $req , 'count' ) > 0 )
            {
                if ( isset ( $_POST['submit'] ) )
                {
                    if ( empty ( $_POST['texte'] ) || trim ( $_POST['texte'] ) == '' )
                    {
                        $page_texte .= '<p><strong>' . $langue['erreur'] . '&nbsp;:</strong> ' . $langue['err_oblig'] . "</p>\n\n";
                    }
                    else
                    {
                        $auteur = ( $_SESSION['groupe'] != 1 ) ? $_SESSION['membre_id'] : 0;

                        $sql = "INSERT INTO `" . $database->pref . "commentaires`
                                (`commentaire_type`, `commentaire_time`, `commentaire_auteur`, `commentaire_reference`, `commentaire_texte`)
                                VALUES
                                ('0', '" . $time . "', '" . $auteur . "', '" . $_GET['article'] . "', '" . $database->Protege ( $_POST['texte'] ) . "');";

                        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                        $commentaire_id = $database->LastInsertId ( $req );

                        $sql = "UPDATE `" . $database->pref . "article_article`
                                SET `article_commentaires` = `article_commentaires` + 1
                                WHERE `article_id` = '" . $_GET['article'] . "';";

                        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                        header ( 'Location: index.' . EXT . '?page=Commentaires&id=' . $commentaire_id );
                        die ( -1 );
                    }
                }

                // Ouverture du formulaire
                $form_adresse = 'index.' . EXT . '?page=Commentaires&amp;action=nouveau&amp;article=' . $_GET['article'];
                $form_titre = $langue['nouveau_commentaire'];

                include ( 'systeme/form_message.' . EXT );
            }
            else
            {
                header ( 'Location: index.' . EXT . '?page=Liste_des_articles' );
                die ( -1 );
            }
        }
        else if ( isset ( $_GET['news'] ) )
        {
            // Droits : news_commentaire
            if ( $droit['news_commentaire'] == 0 )
            {
                $page_msg = 4;
                include_once ( 'systeme/msg.' . EXT );
            }


            $sql = "SELECT COUNT(*) AS `count`
                    FROM `" . $database->pref . "news`
                    WHERE `news_id` = '" . $_GET['news'] . "';";

            $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            if ( $database->Result ( $req , 'count' ) > 0 )
            {
                if ( isset ( $_POST['submit'] ) )
                {
                    if ( empty ( $_POST['texte'] ) || trim ( $_POST['texte'] ) == '' )
                    {
                        $page_texte .= '<p><strong>' . $langue['erreur'] . '&nbsp;:</strong> ' . $langue['err_oblig'] . "</p>\n\n";
                    }
                    else
                    {
                        $auteur = ( $_SESSION['groupe'] != 1 ) ? $_SESSION['membre_id'] : 0;

                        $sql = "INSERT INTO `" . $database->pref . "commentaires`
                                (`commentaire_type`, `commentaire_time`, `commentaire_auteur`, `commentaire_reference`, `commentaire_texte`)
                                VALUES
                                ('1', '" . $time . "', '" . $auteur . "', '" . $_GET['news'] . "', '" . $database->Protege ( $_POST['texte'] ) . "');";

                        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                        $commentaire_id = $database->LastInsertId ( $req );

                        $sql = "UPDATE `" . $database->pref . "news`
                                SET `news_commentaires` = `news_commentaires` + 1,
                                    `news_last_commentaire` = '" . $commentaire_id . "'
                                WHERE `news_id` = '" . $_GET['news'] . "';";

                        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                        header ( 'Location: index.' . EXT . '?page=Commentaires&id=' . $commentaire_id );
                        die ( -1 );
                    }
                }

                // Ouverture du formulaire
                $form_adresse = 'index.' . EXT . '?page=Commentaires&amp;action=nouveau&amp;news=' . $_GET['news'];
                $form_titre = $langue['nouveau_commentaire'];

                include ( 'systeme/form_message.' . EXT );
            }
            else
            {
                header ( 'Location: index.' . EXT . '?page=News' );
                die ( -1 );
            }
        }
        else
        {
            header ( 'Location: index.' . EXT );
            die ( -1 );
        }

        break;

    // Éditer un commentaire
    case 'editer':

        $page_titre = $langue['editer_commentaire'];
        $page_infos = $langue['editer_commentaire'];

        if ( !isset ( $_GET['id'] ) || !is_numeric ( $_GET['id'] ) || $_GET['id'] < 0 )
        {
            header ( 'Location: index.' . EXT );
            die ( -1 );
        }

        $sql = "SELECT `commentaire_auteur`,
                       `commentaire_texte`,
                       `commentaire_reference`,
                       `commentaire_type`
                FROM `" . $database->pref . "commentaires`
                WHERE `commentaire_id` = '" . $_GET['id'] . "';";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        $row = $database->ResultArray ( $req );


        // Droits : article_commentaire
        if ( $row['commentaire_type'] == 0 && $droit['article_commentaire'] == 0 )
        {
            $page_msg = 5;
            include_once ( 'systeme/msg.' . EXT );
        }
        // Droits : news_commentaire
        else if ( $row['commentaire_type'] == 1 && $droit['news_commentaire'] == 0 )
        {
            $page_msg = 4;
            include_once ( 'systeme/msg.' . EXT );
        }

        // A-t-on le droit de modifier ce commentaire ?
        if ( $row['commentaire_auteur'] != $_SESSION['membre_id'] && $_SESSION['groupe'] != 3 )
        {
            header ( 'Location: index.' . EXT );
            die ( -1 );
        }


        $form_champ_texte = $row['commentaire_texte'];

        // Traitement des données du formulaire
        if ( isset ( $_POST['submit'] ) )
        {
            if ( empty ( $_POST['texte'] ) )
            {
                $page_texte .= '<p><strong>' . $langue['erreur'] . '&nbsp;:</strong> ' . $langue['err_oblig'] . "</p>\n\n";
            }
            else if ( $_POST['texte'] != $form_champ_texte )
            {
                $sql = "UPDATE `" . $database->pref . "commentaires`
                        SET `commentaire_texte` = '" . $_POST['texte'] . "'
                        WHERE `commentaire_id` = '" . $_GET['id'] . "';";

                $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                header ( 'Location: index.' . EXT . '?page=Commentaires&id=' . $_GET['id'] );
                die ( -1 );
            }
        }

        // Ouverture du formulaire
        $form_adresse = 'index.' . EXT . '?page=Commentaires&amp;action=editer&amp;id=' . $_GET['id'];
        $form_titre = $langue['editer_commentaire'];

        include ( 'systeme/form_message.' . EXT );

        break;

    // Supprimer un commentaire
    case 'supprimer':

        if ( !isset ( $_GET['id'] ) || !is_numeric ( $_GET['id'] ) || $_GET['id'] < 0 )
        {
            header ( 'Location: index.' . EXT . '?page=News' );
            die ( -1 );
        }

        $sql = "SELECT `commentaire_auteur`,
                       `commentaire_type`,
                       `commentaire_reference`
                FROM `" . $database->pref . "commentaires`
                WHERE `commentaire_id` = '" . $_GET['id'] . "';";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        if ( $database->NbrRowsSelected ( $req ) === 0 )
        {
            header ( 'Location: index.' . EXT );
            die ( -1 );
        }

        $row = $database->ResultArray ( $req );


        if ( $droit['commentaire_suppression'] == 0 )
        {
            $page_msg = 13;
            include_once ( 'systeme/msg.' . EXT );
        }

        // Droits : article_commentaire
        if ( $row['commentaire_type'] == 0 && $droit['article_commentaire'] == 0 )
        {
            $page_msg = 5;
            include_once ( 'systeme/msg.' . EXT );
        }
        // Droits : news_commentaire
        else if ( $row['commentaire_type'] == 1 && $droit['news_commentaire'] == 0 )
        {
            $page_msg = 4;
            include_once ( 'systeme/msg.' . EXT );
        }

        // A-t-on le droit de modifier ce commentaire ?
        if ( $row['commentaire_auteur'] != $_SESSION['membre_id'] && $_SESSION['groupe'] != 3 )
        {
            header ( 'Location: index.' . EXT );
            die ( -1 );
        }


        $page_titre = 'Supprimer un commentaire';
        $page_infos = 'Supprimer un commentaire';

        if ( isset ( $_GET['ok'] ) )
        {
            $sql = "DELETE FROM `" . $database->pref . "commentaires`
                    WHERE `commentaire_id` = '" . $_GET['id'] . "';";

            $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            if ( $row['commentaire_type'] == 0 )
            {
                // On modifier l'article
                $sql = "UPDATE `" . $database->pref . "article_article`
                        SET `article_commentaires` = `article_commentaires` - 1
                        WHERE `article_id` = '" . $row['commentaire_reference'] . "';";

                $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                header ( 'Location: index.' . EXT . '?page=Articles&id=' . $row['commentaire_reference'] );
            }
            else if ( $row['commentaire_type'] == 1 )
            {
                // On récupère l'identifiant du dernier message
                $sql = "SELECT `commentaire_id`
                        FROM `" . $database->pref . "commentaires`
                        WHERE
                                `commentaire_reference` = '" . $row['commentaire_reference'] . "'
                            AND `commentaire_type` = '1'
                        ORDER BY commentaire_time` DESC
                        LIMIT 0, 1;";

                $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                // On modifie la news
                $sql = "UPDATE `" . $database->pref . "news`
                        SET `news_commentaires` = `news_commentaires` - 1
                            `news_last_commentaire` = '" . $database->Result ( $req , 'commentaire_id' ) . "'
                        WHERE `news_id` = '" . $row['commentaire_reference'] . "';";

                $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                header ( 'Location: index.' . EXT . '?page=News&id=' . $row['commentaire_reference'] );
            }

            die ( -1 );
        }

        $page_texte .= '<p>La suppression d\'un commentaire est irréversible. <a href="index.' . EXT . '?page=Commentaires&amp;action=supprimer&amp;id=' . $_GET['id'] . '&amp;ok' . "\">Cliquez-ici</a> pour supprimer ce commentaire.</p>\n\n";

        break;

    // On redirige vers la page contenant le commentaire
    default:

        if ( !isset ( $_GET['id'] ) || !is_numeric ( $_GET['id'] ) || $_GET['id'] <= 0 )
        {
            header ( 'Location: index.' . EXT );
            die ( -1 );
        }

        $sql = "SELECT `commentaire_type`,
                       `commentaire_reference`
                FROM `" . $database->pref . "commentaires`
                WHERE `commentaire_id` = '" . $_GET['id'] . "';";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        if ( $database->NbrRowsSelected ( $req ) === 0 )
        {
            header ( 'Location: index.' . EXT );
            die ( -1 );
        }

        $row = $database->ResultArray ( $req );

        $reference = $row['commentaire_reference'];


        // Commentaire d'article
        if ( $row['commentaire_type'] == 0 )
        {
            // Droits : article_lecture
            if ( $droit['article_lecture'] == 0 )
            {
                $page_msg = 1;
                include_once ( 'systeme/msg.' . EXT );
            }

            // On regarde à quelle page se trouve le commentaire
            $sql = "SELECT `commentaire_id`
                    FROM `" . $database->pref . "commentaires`
                    WHERE
                            `commentaire_reference` = '" . $reference . "'
                        AND `commentaire_type`= '0'
                    ORDER BY `commentaire_time` ASC;";

            $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            for ( $i = 0 ; $row = $database->ResultArray ( $req ) ; $i++ )
            {
                if ( $row['commentaire_id'] == $_GET['id'] )
                {
                    $page = $i - $i % $configuration['commentaires_page'];
                }
            }

            // On redirige vers cette page
            if ( $page == 0 )
            {
                header ( 'Location: index.' . EXT . '?page=Article&id=' . $reference . '#' . $_GET['id'] );
            }
            else
            {
                header ( 'Location: index.' . EXT . '?page=Article&id=' . $reference . '&start=' . $page . '#' . $_GET['id'] );
            }
        }
        // Commentaire de news
        else if ( $row['commentaire_type'] == 1 )
        {
            // Droits : news_lecture
            if ( $droit['news_lecture'] == 0 )
            {
                $page_msg = 6;
                include_once ( 'systeme/msg.' . EXT );
            }

            // On regarde à quelle page se trouve le commentaire
            $sql = "SELECT `commentaire_id`
                    FROM `" . $database->pref . "commentaires`
                    WHERE
                            `commentaire_reference` = '" . $reference . "'
                        AND `commentaire_type` = '1'
                    ORDER BY `commentaire_time` ASC;";

            $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            for ( $i = 0 ; $row = $database->ResultArray ( $req ) ; $i++ )
            {
                if ( $row['commentaire_id'] == $_GET['id'] )
                {
                    $page = $i - $i % $configuration['commentaires_page'];
                }
            }

            // On redirige vers cette page
            if ( $page == 0 )
            {
                header ( 'Location: index.' . EXT . '?page=News&id=' . $reference . '#' . $_GET['id'] );
            }
            else
            {
                header ( 'Location: index.' . EXT . '?page=News&id=' . $reference . '&start=' . $page . '#' . $_GET['id'] );
            }
        }
        else
        {
            header ( 'Location: index.' . EXT );
        }

        die ( -1 );

        break;
}

?>