<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /pages/Editer_un_article.php
 *  Date de création : avant le 13/08/2007
 *  Dernière modification : 13/09/2007
 ***************************************************************************/

// Sécurité
if ( !defined ( 'TAGADASH' ) )
{
    header ( 'Location: ../' );
    die ( -1 );
}


if ( !isset ( $_GET['id'] ) || !is_numeric ( $_GET['id'] ) )
{
    header ( 'Location: index.' . EXT . '?page=Liste_des_articles' );
    die ( -1 );
}


// Droit d'édition des articles
if ( $droit['article_edition'] == 0 )
{
    $page_msg = 3;
    include_once ( 'systeme/msg.' . EXT );
}


$sql = "SELECT `article_titre`,
               `article_langue`,
               `article_categorie`,
               `article_actif`,
               `article_auteur`,
               `article_texte`,
               `article_titre`,
               `article_modification`
        FROM `" . $database->pref . "article_article`
        WHERE `article_id` = '" . $_GET['id'] . "';";

$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

if ( $database->NbrRowsSelected ( $req ) === 0 )
{
    header ( 'Location: index.' . EXT . '?page=Liste_des_articles' );
    die ( -1 );
}


$row = $database->ResultArray ( $req );

$article = $row['article_titre'];
$article_langue = $row['article_langue'];
$article_categorie = $row['article_categorie'];


// Si l'article n'est pas actif ou qu'il a été supprimé
if ( $row['article_actif'] == 0 )
{
    header ( 'Location: index.' . EXT . '?page=Article&id=' . $_GET['id'] );
    die ( -1 );
}


// Droit d'édition d'un article
if ( $droit['article_edition_auteur'] == 0 && $droit['article_edition'] == 0 )
{
    header ( 'Location: index.' . EXT );
    die ( -1 );
}


if ( $droit['article_edition_auteur'] == 1 && $_SESSION['groupe'] != 1 && $row['article_auteur'] != $_SESSION['membre_id'] && $droit['article_edition'] == 0 )
{
    header ( 'Location: index.' . EXT );
    die ( -1 );
}


// Titre de la page
$page_titre = $langue['edit_of'] . $article;
$page_infos = $langue['edit_of'] . $article;


// Traitement des données du formulaire
if ( isset ( $_POST['submit'] ) )
{
    if ( empty ( $_POST['texte'] ) || trim ( $_POST['texte'] ) == '' )
    {
        $page_texte .= '<p><strong>' . $langue['erreur'] . '&nbsp;:</strong> ' . $langue['err_oblig'] . "</p>\n\n";
    }
    else
    {
        $article_texte_old = $database->Protege ( $row['article_texte'] );
        $article_titre_old = $database->Protege ( $row['article_titre'] );

        $sql = "INSERT INTO `" . $database->pref . "article_historique`
                (`historique_titre`, `historique_article`, `historique_texte`, `historique_auteur`, `historique_time`, `historique_langue`, `historique_categorie`)
                VALUES
                ('" . $article_titre_old . "', '" . $_GET['id'] . "', '" . $article_texte_old . "', '" . $row['article_auteur'] . "', '" . $row['article_modification'] . "', '" . $langue . "', '" . $article_categorie . "');";

        $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


        $sql = "SELECT COUNT(*) AS `count`
                FROM `" . $database->pref . "article_article`
                WHERE
                        `article_titre` = '" . $database->Protege ( $_POST['titre'] ) . "'
                    AND `article_categorie` = '" . $_POST['categorie'] . "'
                    AND `article_id` <> '" . $_GET['id'] . "';";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        if ( $database->Result ( $req , 'count' ) > 0 )
        {
            $page_texte .= '<p><strong>' . $langue['erreur'] . "&nbsp;:</strong> Un article porte déjà ce nom dans cette catégorie</p>\n\n";
        }
        else
        {
            // Mise-à-jour de l'article
            $sql = "UPDATE `" . $database->pref . "article_article`
                    SET `article_auteur` = '" . $_SESSION['membre_id'] . "',
                        `article_titre` = '" . $database->Protege ( $_POST['titre'] ) . "',
                        `article_texte` = '" . $database->Protege ( $_POST['texte'] ) . "',
                        `article_categorie` = '" . $_POST['categorie'] . "',
                        `article_modification` = '" . $time . "'
                    WHERE `article_id` = '" . $_GET['id'] . "';";

            $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


            header ( 'Location: index.' . EXT . '?page=Article&id=' . $_GET['id'] );
            die ( -1 );
        }
    }
}

$menu_article_editer = '  <li><a href="index.' . EXT . '?page=Article&amp;id=' . $_GET['id'] . '" title="' . $article . '">' . $langue['view_article'] . "</a></li>\n";
$menu_article_historique = '  <li><a href="index.' . EXT . '?page=Historique&amp;id=' . $_GET['id'] . '" title="' . $langue['historique_texte'] . '">' . $langue['historique'] . "</a></li>\n";

if ( ( $droit['article_sup_auteur'] == 1 && $_SESSION['groupe'] != 1 && $row['article_auteur'] == $_SESSION['membre_id'] ) || $droit['article_sup_edition'] == 1 )
{
    $menu_article_supprimer = '  <li><a href="index.' . EXT . '?page=Supprimer_un_article&amp;id=' . $_GET['id'] . '" title="' . $langue['supprimer_article'] . '">' . $langue['supprimer'] . "</a></li>\n";
}


// Formulaire

$form_adresse = 'index.' . EXT . '?page=Editer_un_article&amp;id=' . $_GET['id'];
$form_titre = $langue['modifier_article'];
$form_langues = $site->FormSelect ( $langues , $article_langue );

$form_champ_titre = $article;
$form_champ_texte = $row['article_texte'];


// Liste des catégories
$form_categories = '';
$categorie = 0;

$sql = "SELECT cata.`cat_id` AS `categorie_id`,
               cata.`cat_nom` AS `categorie_nom`,
               catb.`cat_id` AS `sous_categorie_id`,
               catb.`cat_nom` AS `sous_categorie_nom`
        FROM `" . $database->pref . "article_cat` cata
        LEFT JOIN `" . $database->pref . "article_cat` catb
            ON catb.`cat_categorie` = cata.`cat_id`
        WHERE cata.`cat_categorie` = '0'
        ORDER BY
            cata.`cat_nom` ASC,
            catb.`cat_nom` ASC;";

$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

while ( $row = $database->ResultArray ( $req ) )
{
    if ( $row['categorie_id'] != $categorie )
    {
        $form_categories .= '  <option value="' . $row['categorie_id'] . '"';
        if ( $row['categorie_id'] == $article_categorie ) $form_categories .= ' selected="selected"';
        $form_categories .= '>' . $row['categorie_nom'] . "</option>\n";
        $categorie = $row['categorie_id'];
    }

    if ( !empty ( $row['sous_categorie_id'] ) )
    {
        $form_categories .= '  <option value="' . $row['sous_categorie_id'] . '"';
        if ( $row['sous_categorie_id'] == $article_categorie ) $form_categories .= ' selected="selected"';
        $form_categories .= '>' . $row['categorie_nom'] . ' - ' . $row['sous_categorie_nom'] . "</option>\n";
    }
}


include ( 'systeme/form_article.' . EXT );

?>