<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /pages/Fichier.php
 *  Date de création : 09/08/2007
 *  Dernière modification : 14/09/2007
 ***************************************************************************/

// Sécurité
if ( !defined ( 'TAGADASH' ) )
{
    header ( 'Location: ../' );
    die ( -1 );
}


if ( !isset ( $_GET['id'] ) || !is_numeric ( $_GET['id'] ) )
{
    header ( 'Location: index.' . EXT . '?page=Liste_des_fichiers' );
    die ( -1 );
}


$sql = "SELECT `fichier_nom`,
               `fichier_extension`,
               `fichier_taille`,
               `fichier_time`,
               `fichier_membre`,
               `membre_nom`
        FROM `" . $database->pref . "fichiers`
        LEFT JOIN `" . $database->pref . "membres`
            ON `membre_id` = `fichier_membre`
        WHERE `fichier_id` = '" . $_GET['id'] . "';";

$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

if ( $database->NbrRowsSelected ( $req ) === 0 )
{
    header ( 'Location: index.' . EXT . '?page=Liste_des_fichiers' );
    die ( -1 );
}


$row = $database->ResultArray ( $req );


if ( isset ( $_GET['supprimer'] ) && ( ( $_SESSION['groupe'] != 1 && $_SESSION['membre_id'] == $row['fichier_membre'] ) || $_SESSION['groupe'] == 3 ) )
{
    // On supprime le fichier
    if ( is_file ( 'fichiers/' . $_GET['id'] . '.' . $row['fichier_extension'] ) )
    {
        unlink ( 'fichiers/' . $_GET['id'] . '.' . $row['fichier_extension'] );
    }

    if ( in_array ( $row['fichier_extension'] , array ( 'jpg' , 'jpeg' , 'gif' , 'png' , 'bmp' ) ) )
    {
        for ( $i = 20 ; $i < 800 ; $i++ )
        {
            // On supprime les miniatures si elles existent
            if ( is_file ( 'fichiers/thumbs/' . $i . 'px-' . $_GET['id'] . '.' . $row['fichier_extension'] ) )
            {
                unlink ( 'fichiers/thumbs/' . $i . 'px-' . $_GET['id'] . '.' . $row['fichier_extension'] );
            }
        }
    }

    $sql = "DELETE FROM `" . $database->pref . "fichiers`
            WHERE `fichier_id` = '" . $_GET['id'] . "';";

    $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

    header ( 'Location: index.' . EXT . '?page=Liste_des_fichiers' );
    die ( -1 );
}


// Titre de la page
$page_titre = $langue['file'] . ' : ' . $row['fichier_nom'];
$page_infos = 'Informations sur le fichier ' . $row['fichier_nom'];


$page_texte .= '<p><a href="index.' . EXT . '?page=Liste_des_fichiers">' . $langue['liste_file'] . "</a></p>\n\n";

$page_texte .= "<ul>\n";
$page_texte .= '  <li>' . $langue['file'] . '&nbsp;: ' . $row['fichier_nom'] . " (" . $_GET['id'] . '.' . $row['fichier_extension'] . ")</li>\n";
$page_texte .= '  <li>' . $langue['auteur'] . '&nbsp;: <a href="index.' . EXT . '?page=Membre&amp;id=' . $row['fichier_membre'] . '" title="' . $langue['view_fiche'] . $row['membre_nom'] . '">' . $row['membre_nom'] . "</a></li>\n";
$page_texte .= '  <li>' . $langue['taille'] . '&nbsp;: ' . $site->ConvertTaille ( $row['fichier_taille'] , 'Kio' ) . "</li>\n";
$page_texte .= '  <li>' . $langue['date_upload'] . '&nbsp;: ' . date ( $configuration['format_date'] , $row['fichier_time'] ) . $langue['time_at'] . date ( $configuration['format_heure'] , $row['fichier_time'] ) . "</li>\n";
$page_texte .= "</ul>\n\n";


// Affichage de l'image
if ( in_array ( $row['fichier_extension'] , array ( 'bmp' , 'gif' , 'png' , 'jpg' , 'jpeg' ) ) )
{
    // On crée une miniature de l'image
    $site->CreateMiniature ( $_GET['id'] , $row['fichier_extension'] , 200 );

    // Affichage de la miniature
    if ( is_file ( 'fichiers/thumbs/200px-' . $_GET['id'] . '.' . $row['fichier_extension'] ) )
    {
        $page_texte .= "<p class=\"centre\"><img src=\"fichiers/thumbs/200px-" . $_GET['id'] . '.' . $row['fichier_extension'] . '" alt="' . $_GET['id'] . '.' . $row['fichier_extension'] . '" title="' . $row['fichier_nom'] . "\" /></p>\n\n";
        $page_texte .= "<p class=\"centre\"><a href=\"fichiers/" . $_GET['id'] . '.' . $row['fichier_extension'] . "\">Voir ce fichier en taille réelle</a></p>\n\n";
    }
    // Affichage de l'image en taille réelle
    else if ( is_file ( 'fichiers/' . $_GET['id'] . '.' . $row['fichier_extension'] ) )
    {
        $page_texte .= '<p class="centre"><img src="fichiers/' . $_GET['id'] . '.' . $row['fichier_extension'] . '" alt="' . $_GET['id'] . '.' . $row['fichier_extension'] . '" title="' . $row['fichier_nom'] . "\" /></p>\n\n";
    }
    // Le fichier de l'image n'existe pas, on supprimer l'entrée dans la base
    else
    {
        for ( $i = 20 ; $i < 800 ; $i++ )
        {
            // On supprime les miniatures si elles existent
            if ( is_file ( 'fichiers/thumbs/' . $i . 'px-' . $_GET['id'] . '.' . $row['fichier_extension'] ) )
            {
                unlink ( 'fichiers/thumbs/' . $i . 'px-' . $_GET['id'] . '.' . $row['fichier_extension'] );
            }
        }

        $sql = "DELETE FROM `" . $database->pref . "fichiers`
                WHERE `fichier_id` = '" . $_GET['id'] . "';";

        $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        header ( 'Location: index.' . EXT . '?page=Liste_des_fichiers' );
        die ( -1 );
    }
}
else
{
    $page_texte .= '<p class="centre"><a href="fichiers/' . $_GET['id'] . '.' . $row['fichier_extension'] . "\">Ouvrir ce fichier</a></p>\n\n";
}

// Lien pour supprimer le fichier
if ( ( $_SESSION['groupe'] != 1 && $row['fichier_membre'] == $_SESSION['membre_id'] ) || $_SESSION['groupe'] == 3 )
{
    $page_texte .= '<p class="centre print_hidden"><a href="index.' . EXT . '?page=Fichier&amp;id=' . $_GET['id'] . '&amp;supprimer' . '">' . $langue['supprimer_file'] . "</a></p>\n";
}

?>