<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /pages/Forums.php
 *  Date de création : avant le 13/08/2007
 *  Dernière modification : 14/09/2007
 ***************************************************************************/

// Sécurité
if ( !defined ( 'TAGADASH' ) )
{
    header ( 'Location: ../' );
    die ( -1 );
}


// Un forum est sélectionné
if ( isset ( $_GET['id'] ) )
{
    if ( empty ( $_GET['id'] ) || !is_numeric ( $_GET['id'] ) || $_GET['id'] < 1 )
    {
        header ( 'Location: index.' . EXT . '?page=Forums' );
        die ( -1 );
    }


    if ( $droit['sujet_lecture'] == 0 )
    {
        $page_msg = 9;
        include_once ( 'systeme/msg.' . EXT );
    }


    // Si on veut voir les messages d'un membre
    $member_id = 0;


    if ( isset ( $_GET['membre'] ) && is_numeric ( $_GET['membre'] ) && $_GET['membre'] > 0 )
    {
        $sql = "SELECT `membre_nom`
                FROM `" . $database->pref . "membres`
                WHERE `membre_id` = '" . $_GET['membre'] . "';";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        if ( $database->NbrRowsSelected ( $req ) > 0 ) $member_id = $_GET['membre'];
    }

    $sql = "SELECT `forum_nbr_sujet`,
                   `forum_nom`,
                   `forum_categorie`,
                   `forum_cat_nom`
            FROM `" . $database->pref . "forum_forum`
            LEFT JOIN `" . $database->pref . "forum_cat`
                ON `forum_cat_id` = `forum_categorie`
            WHERE `forum_id` = '" . $_GET['id'] . "';";

    $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


    // Le forum n'existe pas
    if ( $database->NbrRowsSelected ( $req ) === 0 )
    {
        header ( 'Location: index.' . EXT . '?page=Forums' );
        die ( -1 );
    }


    $row = $database->ResultArray ( $req );

    $nbr_sujet = $row['forum_nbr_sujet'];
    $forum_nom = $row['forum_nom'];
    $categorie = $row['forum_categorie'];
    $categorie_nom = $row['forum_cat_nom'];


    // Actions sur plusieurs sujets
    if ( isset ( $_POST['submit'] ) && $_SESSION['groupe'] != 1 )
    {
        // Ajouter aux favoris
        if ( $_POST['action'] == 'fav_add' )
        {
            $liste_sujet = array ();
            $sujet_fav = array ();

            foreach ( $_POST as $var => $val )
            {
                if ( $var != 'fav' && preg_match ( "#^msg_[0-9]{1,9}$#" , $var ) && $val == 'on' )
                {
                    $liste_sujet[] = preg_replace ( "#^msg_([0-9]{1,9})$#" , "$1" , $var );
                }
            }

            foreach ( $liste_sujet as $i => $sujet )
            {
                // On vérifie que le sujet existe et qu'il n'est pas déjà dans les favoris
                $sql = "SELECT COUNT(*) AS `count`,
                               `fav_sujet`
                        FROM `" . $database->pref . "forum_sujet`
                        LEFT JOIN `" . $database->pref . "forum_fav`
                            ON `fav_membre` = '" . $_SESSION['membre_id'] . "'
                            AND `fav_sujet` = '" . $sujet . "'
                        WHERE `sujet_id` = '" . $sujet . "'
                        GROUP BY `sujet_id`;";

                $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                $row = $database->ResultArray ( $req );

                if ( $row['count'] == 0 || ( $row['count'] == 1 && !empty ( $row['fav_sujet'] ) ) )
                {
                    unset ( $liste_sujet[$i] );
                }
            }

            foreach ( $liste_sujet as $sujet )
            {
                $sql = "INSERT INTO `" . $database->pref . "forum_fav`
                        (`fav_sujet`, `fav_membre`)
                        VALUES
                        ('" . $sujet . "', '" . $_SESSION['membre_id'] . "');";

                $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );
            }
        }
        // Enlever des favoris
        else if ( $_POST['action'] == 'fav_del' )
        {
            $liste_sujet = array ();
            $sujet_fav = array ();

            foreach ( $_POST as $var => $val )
            {
                if ( $var != 'fav' && preg_match ( "#^msg_[0-9]{1,9}$#" , $var ) && $val == 'on' )
                {
                    $liste_sujet[] = preg_replace ( "#^msg_([0-9]{1,9})$#" , "$1" , $var );
                }
            }

            foreach ( $liste_sujet as $i => $sujet )
            {
                // On vérifie que le sujet existe et qu'il n'est pas déjà dans les favoris
                $sql = "SELECT COUNT(*) AS `count`,
                               `fav_sujet`
                        FROM `" . $database->pref . "forum_sujet`
                        LEFT JOIN `" . $database->pref . "forum_fav`
                            ON `fav_membre` = '" . $_SESSION['membre_id'] . "'
                            AND `fav_sujet` = '" . $sujet . "'
                        WHERE `sujet_id` = '" . $sujet . "'
                        GROUP BY `sujet_id`;";

                $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                $row = $database->ResultArray ( $req );

                if ( $row['count'] == 0 || ( $row['count'] == 1 && empty ( $row['fav_sujet'] ) ) )
                {
                    unset ( $liste_sujet[$i] );
                }
            }

            foreach ( $liste_sujet as $sujet )
            {
                $sql = "DELETE FROM `" . $database->pref . "forum_fav`
                        WHERE
                                `fav_sujet` = '" . $sujet . "'
                            AND `fav_membre` = '" . $_SESSION['membre_id'] . "';";
    
                $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );
            }
        }
    }


    // Voir les sujets liés à un membre
    if ( $member_id > 0 )
    {
        // Le membre est l'auteur des sujets
        if ( isset ( $_GET['auteur'] ) )
        {
            // Les sujets qu'on a crée qui contiennent des nouveaux messages
            if ( $_SESSION['groupe'] != 1 && isset ( $_GET['nouveaux'] ) )
            {
                $sql = "SELECT `sujet_id`
                        FROM `" . $database->pref . "forum_sujet`
                        LEFT JOIN `" . $database->pref . "forum_sujet_view`
                            ON `sv_sujet` = `sujet_id`
                            AND `sv_message` <> `sujet_last_msg`
                        WHERE
                                `sujet_auteur` = '" . $_SESSION['membre_id'] . "'
                            AND `sujet_forum` = '" . $_GET['id'] . "'
                            AND `sv_membre` = '" . $_SESSION['membre_id'] . "';";

                $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                $nbr_sujet = $database->NbrRowsSelected ( $req );
            }
            else
            {
                $sql = "SELECT `sujet_id`
                        FROM `" . $database->pref . "forum_sujet`
                        WHERE
                                `sujet_auteur` = '" . $member_id . "'
                            AND `sujet_forum` = '" . $_GET['id'] . "';";

                $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                $nbr_sujet = $database->NbrRowsSelected ( $req );
            }
        }
        // Le membre a participé à ces sujets
        else
        {
            // Les sujets où on a participé qui contiennent des nouveaux messages
            if ( $_SESSION['groupe'] != 1 && isset ( $_GET['nouveaux'] ) )
            {
                $sql = "SELECT `forum_msg_id`
                        FROM `" . $database->pref . "forum_msg`
                        LEFT JOIN `" . $database->pref . "forum_sujet`
                            ON `sujet_id` = `forum_msg_sujet`
                        LEFT JOIN `" . $database->pref . "forum_sujet_view`
                            ON `sv_sujet` = `sujet_id`
                            AND `sv_message` <> `sujet_last_msg`
                        WHERE
                                `forum_msg_auteur` = '" . $_SESSION['membre_id'] . "'
                            AND `forum_msg_forum` = '" . $_GET['id'] . "'
                            AND `sv_membre` = '" . $_SESSION['membre_id'] . "';";

                $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                $nbr_sujet = $database->NbrRowsSelected ( $req );
            }
            else
            {
                $sql = "SELECT `forum_msg_id`
                        FROM `" . $database->pref . "forum_msg`
                        WHERE
                                `forum_msg_auteur` = '" . $member_id . "'
                            AND `forum_msg_forum` = '" . $_GET['id'] . "'
                        GROUP BY `forum_msg_sujet`
                        ORDER BY `forum_msg_sujet` ASC;";

                $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                $nbr_sujet = $database->NbrRowsSelected ( $req );
            }
        }
    }
    else if ( $_SESSION['groupe'] != 1 )
    {
        // Voir tous les sujets qu'on a lus et où il y a des messages non lus
        if ( isset ( $_GET['visites'] ) && isset ( $_GET['nouveaux'] ) )
        {
            $sql = "SELECT `sujet_id`
                    FROM `" . $database->pref . "forum_sujet`
                    LEFT JOIN `" . $database->pref . "forum_sujet_view`
                        ON `sv_sujet` = `sujet_id`
                        AND `sv_message` <> `sujet_last_msg`
                    WHERE
                            `sujet_forum` = '" . $_GET['id'] . "'
                        AND `sv_membre` = '" . $_SESSION['membre_id'] . "';";

            $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            $nbr_sujet = $database->NbrRowsSelected ( $req );
        }
        // Voir tous sujets où il y a des messages non lus
        else if ( isset ( $_GET['nouveaux'] ) )
        {
            $nbr_sujet = 0;

            $sql = "SELECT `sv_message`,
                           `sv_sujet`,
                           `sujet_last_msg`
                    FROM `" . $database->pref . "forum_sujet`
                    LEFT JOIN `" . $database->pref . "forum_sujet_view`
                        ON `sv_sujet` = `sujet_id`
                        AND `sv_membre` = '" . $_SESSION['membre_id'] . "'
                    WHERE `sujet_forum` = '" . $_GET['id'] . "';";

            $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            while ( $row = $database->ResultArray ( $req ) )
            {
                if ( empty ( $row['sv_sujet'] ) || $row['sv_message'] != $row['sujet_last_msg'] )
                {
                    $nbr_sujet++;
                }
            }
        }
        // Voir tous sujets favoris
        else if ( isset ( $_GET['favoris'] ) )
        {
            $sql = "SELECT COUNT(*) AS `count`
                    FROM `" . $database->pref . "forum_fav`
                    LEFT JOIN `" . $database->pref . "forum_sujet`
                        ON `sujet_id` = `fav_sujet`
                    WHERE
                            `fav_membre` = '" . $_SESSION['membre_id'] . "'
                        AND `sujet_forum` = '" . $_GET['id'] . "';";

            $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            $nbr_sujet = $database->Result ( $req , 'count' );
        }
        // Voir tous les sujets qu'on a lus
        else if ( isset ( $_GET['visites'] ) )
        {
            $sql = "SELECT `sujet_id`
                    FROM `" . $database->pref . "forum_sujet_view`
                    LEFT JOIN `" . $database->pref . "forum_sujet`
                        ON `sujet_id` = `sv_sujet`
                    WHERE `sujet_forum` = '" . $_GET['id'] . "'
                        AND `sv_membre` = '" . $_SESSION['membre_id'] . "';";

            $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            $nbr_sujet = $database->NbrRowsSelected ( $req );
        }
    }


    // Création du template de la page
    $tpl_forum = new Template ( 'themes/' . $configuration['style'] . '/liste_sujets.tpl' );

    $tpl_forum->SetVar ( array (
        'FORUM_CATEGORIE_ID' => $categorie,
        'FORUM_CATEGORIE_NOM' => $categorie_nom,
        'FORUM_ID' => $_GET['id'],
        'FORUM_NOM' => $forum_nom
    ) );


    // Titre de la page et navigation
    $page_titre = $forum_nom;
    $page_infos = 'Liste des sujets de ' . $forum_nom;


    // Navigation dans les forums
    $page_texte .= '<p>' . $langue['navigation'] . '&nbsp;: <a href="index.' . EXT . '?page=Forums" title="' . $langue['forums_texte'] . '">' . $langue['forums'] . '</a> > ';
    $page_texte .= '<a href="index.' . EXT . '?page=Forums&amp;cat=' . $categorie . '">' . $categorie_nom . '</a> > ';
    $page_texte .= '<a href="index.' . EXT . '?page=Forums&amp;id=' . $_GET['id'] . '">' . $forum_nom . "</a></p>\n\n";


    // Messages à afficher
    if ( $_SESSION['groupe'] != 1 )
    {
        $page_texte .= "<div class=\"forum_options\">\n<ul>\n  <li>Voir les derniers messages... ";

        $page_texte .= '<a href="index.' . EXT . '?page=Forums&amp;id=' . $_GET['id'] . '&amp;nouveaux">nouveaux</a>';
        $page_texte .= ', <a href="index.' . EXT . '?page=Forums&amp;id=' . $_GET['id'] . '&amp;visites">visités</a>';
        $page_texte .= ' (et <a href="index.' . EXT . '?page=Forums&amp;id=' . $_GET['id'] . '&amp;visites&amp;nouveaux">nouveaux</a>)';
        $page_texte .= ', <a href="index.' . EXT . '?page=Forums&amp;id=' . $_GET['id'] . '&amp;membre=' . $_SESSION['membre_id'] . '&auteur">que j\'ai crée</a>';
        $page_texte .= ' (et <a href="index.' . EXT . '?page=Forums&amp;id=' . $_GET['id'] . '&amp;membre=' . $_SESSION['membre_id'] . '&amp;auteur&amp;nouveaux">nouveaux</a>)';
        $page_texte .= ', <a href="index.' . EXT . "?page=Forums&amp;id=" . $_GET['id'] . '&amp;membre=' . $_SESSION['membre_id'] . '">où j\'ai posté</a>';
        $page_texte .= ' (et <a href="index.' . EXT . "?page=Forums&amp;id=" . $_GET['id'] . '&amp;membre=' . $_SESSION['membre_id'] . '&amp;nouveaux">nouveaux</a>)';
        $page_texte .= ', <a href="index.' . EXT . "?page=Forums&amp;id=" . $_GET['id'] . '&amp;favoris">favoris</a>';
        $page_texte .= ' (et <a href="index.' . EXT . "?page=Forums&amp;id=" . $_GET['id'] . '&amp;favoris&amp;nouveaux">nouveaux</a>)';

        $page_texte .= "</li>\n</ul>\n</div>\n\n";
    }


    // Accès vers les autres forums
    $sql = "SELECT `forum_id`, 
                   `forum_nom`,
                   `forum_cat_id`,
                   `forum_cat_nom`
            FROM `" . $database->pref . "forum_forum`
            LEFT JOIN `" . $database->pref . "forum_cat`
                ON `forum_cat_id` = `forum_categorie`
            ORDER BY
                `forum_cat_ordre` ASC,
                `forum_ordre` ASC;";

    $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

    if ( $database->NbrRowsSelected ( $req ) > 1 )
    {
        $saut_forum = '<form action="index.' . EXT . "?page=Forums\" method=\"get\">\n\n<p class=\"form_input droite\"><input type=\"hidden\" name=\"page\" value=\"Forums\" />\n";
        $saut_forum .= '<select name="id" onchange="document.location=\'index.' . EXT . "?page=Forums&amp;id='+this.options[this.selectedIndex].value;\">\n";

        $categorie = 0;

        while ( $row = $database->ResultArray ( $req ) )
        {
            if ( $categorie != $row['forum_cat_id'] )
            {
                if ( isset ( $go_here ) )
                {
                    $saut_forum .= "  </optgroup>\n";
                }

                $saut_forum .= '  <optgroup label="' . $row['forum_cat_nom'] . "\">\n";
                $categorie = $row['forum_cat_id'];
            }

            $go_here = 1;

            $saut_forum .= '    <option value="' . $row['forum_id'] . '"';

            if ( $row['forum_id'] == $_GET['id'] )
            {
                $saut_forum .= ' selected="selected"';
            }

            $saut_forum .= '>' . $row['forum_nom'] . "</option>\n";
        }

        $saut_forum .= "  </optgroup>\n</select>\n";
        $saut_forum .= "<input type=\"submit\" value=\"Go\" /></p>\n\n";
        $saut_forum .= "</form>\n\n";
    }


    // Accès vers les autres forums
    $page_texte .= $saut_forum;


    // Droits de création d'un nouveau sujet
    if ( $droit['sujet_edition_auteur'] == 1 || $droit['sujet_edition'] == 1 )
    {
        $page_texte .= '<p class="droite print_hidden"><a href="' . 'index.' . EXT . '?page=Messages&amp;action=nouveau_sujet&amp;id=' . $_GET['id'] . '" title="' . $langue['nouveau_sujet_texte'] . '"><img src="themes/' . $configuration['style'] . '/images/nouveau.png" title="' . $langue['nouveau_sujet_texte'] . '" alt="' . $langue['nouveau_sujet'] . "\" /></a></p>\n\n";
    }


    // Premier sujet et numéro de la page affichée
    if ( isset ( $_GET['start'] ) && is_numeric ( $_GET['start'] ) && $_GET['start'] > 0 && $_GET['start'] < $nbr_sujet )
    {
        $start = $_GET['start'];
    }
    else
    {
        $start = 0;
    }

    $page_actuelle = intval ( $start / $configuration['sujet_page'] ) + 1;

    // Nombre de pages
    $nbr_page = ( ( $nbr_sujet - 1 ) - ( $nbr_sujet - 1 ) % $configuration['sujet_page'] ) / $configuration['sujet_page'] + 1;


    // Sections del a requête
    $sql_add1 = '';
    $sql_add2 = '';


    // Affichage des sujets lus/non lus pour les membres enregistrés
    if ( $_SESSION['groupe'] != 1 )
    {
        // Sélection des champs de la table
        $sql_add1 = ', `sv_membre`,
            `sv_message`,
            `sv_participe`,
            `fav_sujet`';

        // Deuxièmement, jointure
        $sql_add2 = "LEFT JOIN `" . $database->pref . "forum_sujet_view`
                        ON `sujet_id` = `sv_sujet`
                        AND `sv_membre` = '" . $_SESSION['membre_id'] . "'
                     LEFT JOIN `" . $database->pref . "forum_fav`
                        ON `fav_sujet` = `sujet_id`
                        AND `fav_membre` = '" . $_SESSION['membre_id'] . "'";
    }


    // Petite requête pour l'affichage de tous les sujets
    if ( $member_id > 0 )
    {
        if ( isset ( $_GET['auteur'] ) )
        {
            if ( $_SESSION['groupe'] != 1 && isset ( $_GET['nouveaux'] ) )
            {
                $sql = "SELECT `sujet_id`,
                               `sujet_titre`,
                               `sujet_auteur`,
                               `sujet_compteur`,
                               `sujet_nbr_msg`,
                               `sujet_time`,
                               `sujet_last_msg`,
                               `sujet_epingle`,
                               `sujet_ferme`,
                               `sujet_deplace`,
                               `forum_msg_auteur`,
                               `forum_msg_time`,
                               `sv_membre`,
                               `sv_message`,
                               `sv_participe`,
                               `fav_sujet`,
                               Ma.`membre_nom` AS `membre_nom_last_auteur`,
                               Mb.`membre_nom` AS `membre_nom_auteur`
                        FROM `" . $database->pref . "forum_sujet`
                        LEFT JOIN `" . $database->pref . "membres` Mb
                            ON Mb.`membre_id` = `sujet_auteur`
                        LEFT JOIN `" . $database->pref . "forum_msg`
                            ON `sujet_last_msg` = `forum_msg_id`
                        LEFT JOIN `" . $database->pref . "membres` Ma
                            ON Ma.`membre_id` = `forum_msg_auteur`
                        LEFT JOIN `" . $database->pref . "forum_sujet_view`
                            ON `sv_sujet` = `sujet_id`
                            AND `sv_message` <> `sujet_last_msg`
                        LEFT JOIN `" . $database->pref . "forum_fav`
                            ON `fav_sujet` = `sujet_id`
                            AND `fav_membre` = '" . $_SESSION['membre_id'] . "'
                        WHERE
                                `sujet_auteur` = '" . $_SESSION['membre_id'] . "'
                            AND
                            (
                                  `sujet_forum` = '" . $_GET['id'] . "'
                               OR `sujet_deplace` = '" . $_GET['id'] . "'
                            )
                            AND `sv_membre` = '" . $_SESSION['membre_id'] . "'";
            }
            else
            {
                $sql = "SELECT `sujet_id`,
                               `sujet_titre`,
                               `sujet_auteur`,
                               `sujet_compteur`,
                               `sujet_nbr_msg`,
                               `sujet_time`,
                               `sujet_last_msg`,
                               `sujet_epingle`,
                               `sujet_ferme`,
                               `sujet_deplace`,
                               `forum_msg_auteur`,
                               `forum_msg_time`,
                               Ma.`membre_nom` AS `membre_nom_last_auteur`,
                               Mb.`membre_nom` AS `membre_nom_auteur`
                               " . $sql_add1 . "
                        FROM `" . $database->pref . "forum_sujet`
                        LEFT JOIN `" . $database->pref . "membres` Mb
                            ON Mb.`membre_id` = `sujet_auteur`
                        LEFT JOIN `" . $database->pref . "forum_msg`
                            ON `sujet_last_msg` = `forum_msg_id`
                        LEFT JOIN `" . $database->pref . "membres` Ma
                            ON Ma.`membre_id` = `forum_msg_auteur`
                            " . $sql_add2 . "
                        WHERE
                                `sujet_auteur` = '" . $member_id . "'
                            AND
                            (
                                  `sujet_forum` = '" . $_GET['id'] . "'
                               OR `sujet_deplace` = '" . $_GET['id'] . "'
                            )";
            }
        }
        else
        {
            if ( $_SESSION['groupe'] != 1 && isset ( $_GET['nouveaux'] ) )
            {
                $sql = "SELECT `sujet_id`,
                               `sujet_titre`,
                               `sujet_auteur`,
                               `sujet_compteur`,
                               `sujet_nbr_msg`,
                               `sujet_time`,
                               `sujet_last_msg`,
                               `sujet_epingle`,
                               `sujet_ferme`,
                               `sujet_deplace`,
                               `sv_membre`,
                               `sv_message`,
                               `sv_participe`,
                               `fav_sujet`,
                               Msgb.`forum_msg_auteur`,
                               Msgb.`forum_msg_time`,
                               Mb.`membre_nom` AS `membre_nom_auteur`,
                               Ma.`membre_nom` AS `membre_nom_last_auteur`
                        FROM `" . $database->pref . "forum_msg` Msga
                        LEFT JOIN `" . $database->pref . "forum_sujet`
                            ON `sujet_id` = Msga.`forum_msg_sujet`
                        LEFT JOIN `" . $database->pref . "forum_msg` Msgb
                            ON Msgb.`forum_msg_id` = `sujet_last_msg`
                        LEFT JOIN `" . $database->pref . "membres` Ma
                            ON Ma.`membre_id` = Msgb.`forum_msg_auteur`
                        LEFT JOIN `" . $database->pref . "membres` Mb
                            ON Mb.`membre_id` = `sujet_auteur`
                        LEFT JOIN `" . $database->pref . "forum_sujet_view`
                            ON `sv_sujet` = `sujet_id`
                            AND `sv_message` <> `sujet_last_msg`
                        LEFT JOIN `" . $database->pref . "forum_fav`
                            ON `fav_sujet` = `sujet_id`
                            AND `fav_membre` = '" . $_SESSION['membre_id'] . "'
                        WHERE
                                Msga.`forum_msg_auteur` = '" . $_SESSION['membre_id'] . "'
                            AND Msga.`forum_msg_forum` = '" . $_GET['id'] . "'
                            AND `sv_membre` = '" . $_SESSION['membre_id'] . "'";
            }
            else
            {
                $sql = "SELECT `sujet_id`,
                               `sujet_titre`,
                               `sujet_auteur`,
                               `sujet_compteur`,
                               `sujet_nbr_msg`,
                               `sujet_time`,
                               `sujet_last_msg`,
                               `sujet_epingle`,
                               `sujet_ferme`,
                               `sujet_deplace`,
                               Msgb.`forum_msg_auteur`,
                               Msgb.`forum_msg_time`,
                               Mb.`membre_nom` AS `membre_nom_auteur`,
                               Ma.`membre_nom` AS `membre_nom_last_auteur`
                               " . $sql_add1 . "
                        FROM `" . $database->pref . "forum_msg` Msga
                        LEFT JOIN `" . $database->pref . "forum_sujet`
                            ON `sujet_id` = Msga.`forum_msg_sujet`
                        LEFT JOIN `" . $database->pref . "forum_msg` Msgb
                            ON Msgb.`forum_msg_id` = `sujet_last_msg`
                        LEFT JOIN `" . $database->pref . "membres` Ma
                            ON Ma.`membre_id` = Msgb.`forum_msg_auteur`
                        LEFT JOIN `" . $database->pref . "membres` Mb
                            ON Mb.`membre_id` = `sujet_auteur`
                            " . $sql_add2 . "
                        WHERE
                                Msga.`forum_msg_auteur` = '" . $member_id . "'
                            AND Msga.`forum_msg_forum` = '" . $_GET['id'] . "'
                        GROUP BY `sujet_id`";
            }
        }
    }
    else if ( $_SESSION['groupe'] != 1 )
    {
        // Voir tous les sujets qu'on a lus et où il a des messages non lus
        if ( isset ( $_GET['visites'] ) && isset ( $_GET['nouveaux'] ) )
        {
            $sql = "SELECT `sujet_id`,
                           `sujet_titre`,
                           `sujet_auteur`,
                           `sujet_compteur`,
                           `sujet_nbr_msg`,
                           `sujet_time`,
                           `sujet_last_msg`,
                           `sujet_epingle`,
                           `sujet_ferme`,
                           `sujet_deplace`,
                           `forum_msg_auteur`,
                           `forum_msg_time`,
                           `sv_membre`,
                           `sv_message`,
                           `sv_participe`,
                           `fav_sujet`,
                           Ma.`membre_nom` AS `membre_nom_auteur`,
                           Mb.`membre_nom` AS `membre_nom_last_auteur`
                    FROM `" . $database->pref . "forum_sujet_view`
                    LEFT JOIN `" . $database->pref . "forum_sujet`
                        ON `sujet_id` = `sv_sujet`
                        AND `sv_message` <> `sujet_last_msg`
                    LEFT JOIN `" . $database->pref . "membres` Ma
                        ON Ma.`membre_id` = `sujet_auteur`
                    LEFT JOIN `" . $database->pref . "forum_msg`
                        ON `sujet_last_msg` = `forum_msg_id`
                    LEFT JOIN `" . $database->pref . "membres` Mb
                        ON Mb.`membre_id` = `forum_msg_auteur`
                    LEFT JOIN `" . $database->pref . "forum_fav`
                        ON `fav_sujet` = `sujet_id`
                        AND `fav_membre` = '" . $_SESSION['membre_id'] . "'
                    WHERE
                        (
                             `sujet_forum` = '" . $_GET['id'] . "'
                          OR `sujet_deplace` = '" . $_GET['id'] . "'
                        )
                        AND `sv_membre` = '" . $_SESSION['membre_id'] . "'";
        }
        // Voir tous sujets où il a des messages non lus
        else if ( isset ( $_GET['nouveaux'] ) )
        {
            $sql = "SELECT `sujet_id`,
                           `sujet_titre`,
                           `sujet_auteur`,
                           `sujet_compteur`,
                           `sujet_nbr_msg`,
                           `sujet_time`,
                           `sujet_last_msg`,
                           `sujet_epingle`,
                           `sujet_ferme`,
                           `sujet_deplace`,
                           `forum_msg_auteur`,
                           `forum_msg_time`,
                           `sv_membre`,
                           `sv_message`,
                           `sv_participe`,
                           `sv_sujet`,
                           `fav_sujet`,
                           Ma.`membre_nom` AS `membre_nom_auteur`,
                           Mb.`membre_nom` AS `membre_nom_last_auteur`
                    FROM `" . $database->pref . "forum_sujet`
                    LEFT JOIN `" . $database->pref . "forum_msg`
                        ON `sujet_last_msg` = `forum_msg_id`
                    LEFT JOIN `" . $database->pref . "forum_sujet_view`
                        ON `sv_sujet` = `sujet_id`
                        AND `sv_membre` = '" . $_SESSION['membre_id'] . "'
                    LEFT JOIN `" . $database->pref . "membres` Ma
                        ON Ma.`membre_id` = `sujet_auteur`
                    LEFT JOIN `" . $database->pref . "membres` Mb
                        ON Mb.`membre_id` = `forum_msg_auteur`
                    LEFT JOIN `" . $database->pref . "forum_fav`
                        ON `fav_sujet` = `sujet_id`
                        AND `fav_membre` = '" . $_SESSION['membre_id'] . "'
                    WHERE
                           `sujet_forum` = '" . $_GET['id'] . "'
                        OR `sujet_deplace` = '" . $_GET['id'] . "'";
        }
        // Voir tous sujets favoris
        else if ( isset ( $_GET['favoris'] ) )
        {
            $sql = "SELECT `sujet_id`,
                           `sujet_titre`,
                           `sujet_auteur`,
                           `sujet_compteur`,
                           `sujet_nbr_msg`,
                           `sujet_time`,
                           `sujet_last_msg`,
                           `sujet_epingle`,
                           `sujet_ferme`,
                           `sujet_deplace`,
                           `forum_msg_auteur`,
                           `forum_msg_time`,
                           `sv_membre`,
                           `sv_message`,
                           `sv_participe`,
                           `sv_sujet`,
                           `fav_sujet`,
                           Ma.`membre_nom` AS `membre_nom_auteur`,
                           Mb.`membre_nom` AS `membre_nom_last_auteur`
                    FROM `" . $database->pref . "forum_sujet`
                    LEFT JOIN `" . $database->pref . "forum_msg`
                        ON `sujet_last_msg` = `forum_msg_id`
                    LEFT JOIN `" . $database->pref . "forum_sujet_view`
                        ON `sv_sujet` = `sujet_id`
                        AND `sv_membre` = '" . $_SESSION['membre_id'] . "'
                    LEFT JOIN `" . $database->pref . "membres` Ma
                        ON Ma.`membre_id` = `sujet_auteur`
                    LEFT JOIN `" . $database->pref . "membres` Mb
                        ON Mb.`membre_id` = `forum_msg_auteur`
                    LEFT JOIN `" . $database->pref . "forum_fav`
                        ON `fav_sujet` = `sujet_id`
                    WHERE
                       (
                             `sujet_forum` = '" . $_GET['id'] . "'
                          OR `sujet_deplace` = '" . $_GET['id'] . "'
                       )
                       AND `fav_membre` = '" . $_SESSION['membre_id'] . "'";
        }
        // Voir tous les sujets qu'on a lus
        else if ( isset ( $_GET['visites'] ) )
        {
            $sql = "SELECT `sujet_id`,
                           `sujet_titre`,
                           `sujet_auteur`,
                           `sujet_compteur`,
                           `sujet_nbr_msg`,
                           `sujet_time`,
                           `sujet_last_msg`,
                           `sujet_epingle`,
                           `sujet_ferme`,
                           `sujet_deplace`,
                           `forum_msg_auteur`,
                           `forum_msg_time`,
                           `fav_sujet`,
                           `sv_membre`,
                           `sv_message`,
                           `sv_participe`,
                           Ma.`membre_nom` AS `membre_nom_auteur`,
                           Mb.`membre_nom` AS `membre_nom_last_auteur`
                    FROM `" . $database->pref . "forum_sujet_view`
                    LEFT JOIN `" . $database->pref . "forum_sujet`
                        ON `sujet_id` = `sv_sujet`
                    LEFT JOIN `" . $database->pref . "membres` Ma
                        ON Ma.`membre_id` = `sujet_auteur`
                    LEFT JOIN `" . $database->pref . "forum_msg`
                        ON `sujet_last_msg` = `forum_msg_id`
                    LEFT JOIN `" . $database->pref . "membres` Mb
                        ON Mb.`membre_id` = `forum_msg_auteur`
                    LEFT JOIN `" . $database->pref . "forum_fav`
                        ON `fav_sujet` = `sujet_id`
                        AND `fav_membre` = '" . $_SESSION['membre_id'] . "'
                    WHERE
                        (
                              `sujet_forum` = '" . $_GET['id'] . "'
                           OR `sujet_deplace` = '" . $_GET['id'] . "'
                        )
                        AND `sv_membre` = '" . $_SESSION['membre_id'] . "'";
        }
        else
        {
            $sql = "SELECT `sujet_id`,
                           `sujet_titre`,
                           `sujet_auteur`,
                           `sujet_compteur`,
                           `sujet_nbr_msg`,
                           `sujet_time`,
                           `sujet_last_msg`,
                           `sujet_epingle`,
                           `sujet_ferme`,
                           `sujet_deplace`,
                           `forum_msg_auteur`,
                           `forum_msg_time`,
                           Ma.`membre_nom` AS `membre_nom_last_auteur`,
                           Mb.`membre_nom` AS `membre_nom_auteur`
                           " . $sql_add1 . "
                    FROM `" . $database->pref . "forum_sujet`
                    LEFT JOIN `" . $database->pref . "membres` Mb
                        ON Mb.`membre_id` = `sujet_auteur`
                    LEFT JOIN `" . $database->pref . "forum_msg`
                        ON `sujet_last_msg` = `forum_msg_id`
                    LEFT JOIN `" . $database->pref . "membres` Ma
                        ON Ma.`membre_id` = `forum_msg_auteur`
                        " . $sql_add2 . "
                    WHERE `sujet_forum` = '" . $_GET['id'] . "'
                       OR `sujet_deplace` = '" . $_GET['id'] . "'";
        }
    }
    else
    {
        $sql = "SELECT `sujet_id`,
                       `sujet_titre`,
                       `sujet_auteur`,
                       `sujet_compteur`,
                       `sujet_nbr_msg`,
                       `sujet_time`,
                       `sujet_last_msg`,
                       `sujet_epingle`,
                       `sujet_ferme`,
                       `sujet_deplace`,
                       `forum_msg_auteur`,
                       `forum_msg_time`,
                       Ma.`membre_nom` AS `membre_nom_last_auteur`,
                       Mb.`membre_nom` AS `membre_nom_auteur`
                       " . $sql_add1 . "
                FROM `" . $database->pref . "forum_sujet`
                LEFT JOIN `" . $database->pref . "membres` Mb
                    ON Mb.`membre_id` = `sujet_auteur`
                LEFT JOIN `" . $database->pref . "forum_msg`
                    ON `sujet_last_msg` = `forum_msg_id`
                LEFT JOIN `" . $database->pref . "membres` Ma
                    ON Ma.`membre_id` = `forum_msg_auteur`
                    " . $sql_add2 . "
                WHERE `sujet_forum` = '" . $_GET['id'] . "'
                   OR `sujet_deplace` = '" . $_GET['id'] . "'";
    }

    $sql .= "   ORDER BY `sujet_epingle` DESC,
               `sujet_last_msg` DESC";

    //=>MYSQL
        if ( SGBD == 'mysql' ) $sql .= ' LIMIT ' . $start . ', ' . $configuration['sujet_page'];
        $sql .= ';';
    //=>END

    $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


    if ( $nbr_sujet > 0 && $database->NbrRowsSelected ( $req ) > 0 )
    {
        $page_texte .= "<form action=\"index." . EXT . "?page=Forums&amp;id=" . $_GET['id'] . "\" id=\"form_act_msg\" method=\"post\">\n\n";
        $page_texte .= "\n<table>\n\n<thead>\n";


        // Liste des pages (Haut du tableau)
        if ( $nbr_sujet > $configuration['sujet_page'] )
        {
            $page_texte .= "<tr>\n  <td colspan=\"8\">" . $langue['page'] . "&nbsp;:\n";

            for ( $i = 1 ; $i <= $nbr_page ; $i++ )
            {
                $affiche_numero = false;

                for ( $numero = 1 ; $numero <= $configuration['numero_debut'] ; $numero++ )
                {
                    if ( $i == $numero ) $affiche_numero = true;
                }

                if ( !$affiche_numero )
                {
                    for ( $numero = $page_actuelle - $configuration['numero_autour'] ; $numero <= $page_actuelle + $configuration['numero_autour'] ; $numero++ )
                    {
                        if ( $i == $numero ) $affiche_numero = true;
                    }
                }

                if ( !$affiche_numero )
                {
                    for ( $numero = $nbr_page + 1 - $configuration['numero_fin'] ; $numero <= $nbr_page ; $numero++ )
                    {
                        if ( $i == $numero ) $affiche_numero = true;
                    }
                }

                if ( $affiche_numero ) 
                {
                    $page_texte .= '    <a href="index.' . EXT . '?page=Forums&amp;id=' . $_GET['id'];

                    if ( $member_id > 0 )
                    {
                        $page_texte .= '&amp;membre=' . $member_id;

                        if ( $_SESSION['groupe'] != 1 && isset ( $_GET['nouveaux'] ) ) $page_texte .= '&amp;nouveaux';
                        if ( isset ( $_GET['auteur'] ) ) $page_texte .= '&amp;auteur';
                    }
                    else if ( $_SESSION['groupe'] != 1 )
                    {
                        if ( isset ( $_GET['nouveaux'] ) ) $page_texte .= '&amp;nouveaux';
                        if ( isset ( $_GET['visites'] ) ) $page_texte .= '&amp;visites';
                    }

                    $page_texte .= '&amp;start=' . ( $i - 1 ) * $configuration['sujet_page'] . '" title="' . $langue['page_goto'] . $i . '">';

                    if ( $start == ( $i - 1 ) * $configuration['sujet_page'] )
                    {
                        $page_texte .= '<span class="page_actuelle">' . $i . '</span>';
                    }
                    else
                    {
                        $page_texte .= $i;
                    }

                    $page_texte .= "</a>\n";

                    $trois_petits_points = false;
                }
                else if ( !$trois_petits_points )
                {
                    $page_texte .= "    ...\n";
                    $trois_petits_points = true;
                }
            }

            $page_texte .= "  </td>\n</tr>\n";
        }


        // En-tête du tableau
        $page_texte .= "<tr>\n";
        $page_texte .= "  <th class=\"forum_lecture\"></th>\n";
        $page_texte .= "  <th class=\"forum_attributs\"></th>\n";
        $page_texte .= '  <th class="forum_sujet">' . $langue['sujets'] . "</th>\n";
        $page_texte .= '  <th class="forum_auteur">' . $langue['auteur'] . "</th>\n";
        $page_texte .= '  <th class="forum_reponses">' . $langue['reponses'] ."</th>\n";
        $page_texte .= '  <th class="forum_lectures">' . $langue['lectures'] . "</th>\n";
        $page_texte .= '  <th class="forum_last_msg">' . $langue['last_message'] . "</th>\n";

        if ( $_SESSION['groupe'] != 1 )
        {
            $page_texte .= "  <th></th>\n";
        }

        $page_texte .= "</tr>\n</thead>\n\n";


        // Liste des pages (Bas du tableau)
        if ( $nbr_sujet > $configuration['sujet_page'] )
        {
            $page_texte .= "<tfoot>\n<tr>\n  <td colspan=\"8\">" . $langue['page'] . "&nbsp;:\n";

            for ( $i = 1 ; $i <= $nbr_page ; $i++ )
            {
                $affiche_numero = false;

                for ( $numero = 1 ; $numero <= $configuration['numero_debut'] ; $numero++ )
                {
                    if ( $i == $numero ) $affiche_numero = true;
                }

                if ( !$affiche_numero )
                {
                    for ( $numero = $page_actuelle - $configuration['numero_autour'] ; $numero <= $page_actuelle + $configuration['numero_autour'] ; $numero++ )
                    {
                        if ( $i == $numero ) $affiche_numero = true;
                    }
                }

                if ( !$affiche_numero )
                {
                    for ( $numero = $nbr_page + 1 - $configuration['numero_fin'] ; $numero <= $nbr_page ; $numero++ )
                    {
                        if ( $i == $numero ) $affiche_numero = true;
                    }
                }

                if ( $affiche_numero ) 
                {
                    $page_texte .= '    <a href="index.' . EXT . '?page=Forums&amp;id=' . $_GET['id'];

                    if ( $member_id > 0 )
                    {
                        $page_texte .= '&amp;membre=' . $member_id;

                        if ( $_SESSION['groupe'] != 1 && isset ( $_GET['nouveaux'] ) ) $page_texte .= '&amp;nouveaux';
                        if ( isset ( $_GET['auteur'] ) ) $page_texte .= '&amp;auteur';
                    }
                    else if ( $_SESSION['groupe'] != 1 )
                    {
                        if ( isset ( $_GET['nouveaux'] ) ) $page_texte .= '&amp;nouveaux';
                        if ( isset ( $_GET['visites'] ) ) $page_texte .= '&amp;visites';
                    }

                    $page_texte .= '&amp;start=' . ( $i - 1 ) * $configuration['sujet_page'] . '" title="' . $langue['page_goto'] . $i . '">';

                    if ( $start == ( $i - 1 ) * $configuration['sujet_page'] )
                    {
                        $page_texte .= '<span class="page_actuelle">' . $i . '</span>';
                    }
                    else
                    {
                        $page_texte .= $i;
                    }

                    $page_texte .= "</a>\n";

                    $trois_petits_points = false;
                }
                else if ( !$trois_petits_points )
                {
                    $page_texte .= "    ...\n";
                    $trois_petits_points = true;
                }
            }

            $page_texte .= "  </td>\n</tr>\n</tfoot>\n\n";
        }


        $page_texte .= "<tbody>\n";


        $sql_limite = 0;

        // Affichage des sujets jusqu'à $start + $configuration['sujet_page']
        while ( $sql_limite < $start + $configuration['sujet_page'] && $row = $database->ResultArray ( $req ) )
        {
            // On commence à afficher l'enregistrement $start
            if ( SGBD != 'mysql' && $sql_limite < $start )
            {
                continue;
            }

            if ( $_SESSION['groupe'] != 1 && isset ( $_GET['nouveaux'] ) && !empty ( $row['sv_sujet'] ) && $row['sv_message'] == $row['sujet_last_msg'] )
            {
                continue;
            }

            // Image pour les sujets lus/non lus
            if ( $_SESSION['groupe'] != 1 )
            {
                // Si le membre a déjà lu ce sujet
                if ( $row['sv_membre'] == $_SESSION['membre_id'] )
                {
                    // Si le membre n'a pas participé à ce sujet
                    if ( $row['sv_participe'] == 0 )
                    {
                        // S'il a lu le dernier message
                        if ( $row['sv_message'] == $row['sujet_last_msg'] )
                        {
                            $message_image = 'message.png';
                            $message_texte = 'Pas de nouveaux messages';
                        }
                        else
                        {
                            $message_image = 'message_nouveau.png';
                            $message_texte = 'Nouveaux messages';
                        }
                    }
                    // Si le membre a participé à ce sujet
                    else
                    {
                        // S'il a lu le dernier message
                        if ( $row['sv_message'] == $row['sujet_last_msg'] )
                        {
                            $message_image = 'message_participe.png';
                            $message_texte = 'Pas de nouveaux messages, déjà participé';
                        }
                        else
                        {
                            $message_image = 'message_participe_nouveau.png';
                            $message_texte = 'Nouveau messages, déjà participé';
                        }
                    }
                }
                // Si le membre n'a jamais lu ce sujet
                else
                {
                    $message_image = 'message_nouveau.png';
                    $message_texte = 'Nouveaux messages';
                }
            }
            // Si c'est un visiteur
            else
            {
                $message_image = 'message.png';
                $message_texte = 'Nouveaux messages';
            }


            $page_texte .= "<tr>\n";
            $page_texte .= '  <td class="centre"><img src="themes/' . $configuration['style'] . '/images/' . $message_image . '" title="' . $message_texte . "\" alt=\"\" /></td>\n";
            $page_texte .= "  <td class=\"centre\"><div class=\"forum_attributs_image\">";


            // Attributs du sujet
            if ( $row['sujet_deplace'] == $_GET['id'] )
            {
                $page_texte .= '<img src="themes/' . $configuration['style'] . '/images/deplace.png" title="Sujet déplacé" alt="[Déplacé]" />';
            }
            else
            {
                if ( $row['sujet_epingle'] == 1 )
                {
                    $page_texte .= '<img src="themes/' . $configuration['style'] . '/images/epingle.png" title="Sujet épinglé" alt="[Épinglé]" />';
                }

                if ( $row['sujet_ferme'] == 1 )
                {
                    $page_texte .= '<img src="themes/' . $configuration['style'] . '/images/ferme.png" title="Sujet fermé" alt="[Fermé]" />';
                }
                
                if ( $_SESSION['groupe'] != 1 && !empty ( $row['fav_sujet'] ) )
                {
                    $page_texte .= '<img src="themes/' . $configuration['style'] . '/images/favori.png" title="Sujet favori" alt="[Favori]" />';
                }
            }


            $page_texte .= "</div></td>\n  <td>";

            // Lien vers le dernier message lu si il y a des nouveaux messages
            if ( $_SESSION['groupe'] != 1 && !empty ( $row['sv_message'] ) && ( $message_image == 'message_nouveau.png' || $message_image == 'message_participe_nouveau.png' ) )
            {
                $page_texte .= '<a href="index.' . EXT . '?page=Sujets&amp;msg=' . $row['sv_message'] . '" title="Aller au dernier message lu"><img src="themes/' . $configuration['style'] . '/images/dernier_message_lu.png" alt="" title="Aller au dernier message lu" /></a> ';
            }

            $page_texte .= '<a href="index.' . EXT . '?page=Sujets&amp;id=' . $row['sujet_id'] . '" title="Commencé le ' . date ( $configuration['format_date'] , $row['sujet_time'] ) . $langue['time_at'] . date ( $configuration['format_heure'] , $row['sujet_time'] ) . '">' . $row['sujet_titre'] . '</a>';

            // Liste des pages du sujet
            if ( $row['sujet_nbr_msg'] > $configuration['msg_page'] )
            {
                $page_texte .= '<br /><small>' . $langue['page'] . '&nbsp;: ';

                $nbr_page_msg = ( ( $row['sujet_nbr_msg'] - 1 ) - ( $row['sujet_nbr_msg'] - 1 ) % $configuration['msg_page'] ) / $configuration['msg_page'] + 1;

                for ( $i = 1 ; $i <= $nbr_page_msg ; $i++ )
                {
                    $affiche_numero = false;

                    for ( $numero = 1 ; $numero <= $configuration['numero_debut'] ; $numero++ )
                    {
                        if ( $i == $numero ) $affiche_numero = true;
                    }

                    if ( !$affiche_numero )
                    {
                        for ( $numero = $nbr_page + 1 - $configuration['numero_fin'] ; $numero <= $nbr_page ; $numero++ )
                        {
                            if ( $i == $numero ) $affiche_numero = true;
                        }
                    }

                    if ( $affiche_numero ) 
                    {
                        $page_texte .= '    <a href="index.' . EXT . '?page=Sujets&amp;id=' . $row['sujet_id'] . '&amp;start=' . ( $i - 1 ) * $configuration['msg_page'] . '" title="' . $langue['page_goto'] . $i . '">' . $i . "</a>\n";

                        $trois_petits_points = false;
                    }
                    else if ( !$trois_petits_points )
                    {
                        $page_texte .= "    ...\n";
                        $trois_petits_points = true;
                    }
                }

                $page_texte .= '</small>';
            }

            $page_texte .= "</td>\n  <td class=\"centre\">";

            if ( empty ( $row['membre_nom_auteur'] ) )
            {
                $page_texte .= $langue['anonyme'];
            }
            else
            {
                $page_texte .= '<a href="' . 'index.' . EXT . '?page=Membre&amp;id=' . $row['sujet_auteur'] . '" title="' . $langue['view_fiche'] . $row['membre_nom_auteur'] . '">' . $row['membre_nom_auteur'] . '</a>';
            }

            $page_texte .= "</td>\n  <td class=\"centre\">" . ( $row['sujet_nbr_msg'] - 1 ) . "</td>\n";
            $page_texte .= '  <td class="centre">' . $row['sujet_compteur'] . "</td>\n";

            // Dernier message
            if ( date ( 'd-m-Y' , $row['forum_msg_time'] ) === date ( 'd-m-Y' ) )
            {
                $jour = $langue['today'];
            }
            else if ( date ( 'd-m-Y' , $row['forum_msg_time'] ) === date ( 'd-m-Y' , $time - 86400 ) )
            {
                $jour = $langue['yesterday'];
            }
            else
            {
                $jour = date ( $configuration['format_date'] , $row['forum_msg_time'] );
            }

            $page_texte .= '  <td class="forum_last_message"><a href="index.' . EXT . '?page=Sujets&amp;msg=' . $row['sujet_last_msg'] . '" title="Voir le message">' . $jour . $langue['time_at'] . date ( $configuration['format_heure'] , $row['forum_msg_time'] ) . "</a><br />\n" . $langue['_par_'];

            if ( empty ( $row['membre_nom_auteur'] ) )
            {
                $page_texte .= $langue['anonyme'];
            }
            else
            {
                $page_texte .= '<a href="index.' . EXT . '?page=Membre&amp;id=' . $row['forum_msg_auteur'] . '" title="' . $langue['view_fiche'] . $row['membre_nom_last_auteur'] . '">' . $row['membre_nom_last_auteur'] . '</a>';
            }

            if ( $_SESSION['groupe'] != 1 )
            {
                $page_texte .= "</td>\n  <td class=\"centre\"><input type=\"checkbox\" name=\"msg_" . $row['sujet_id'] . '" />';
            }

            $page_texte .= "</td>\n</tr>\n";

            $sql_limite++;
        }// Fin de la boucle

        $page_texte .= "</tbody>\n\n</table>\n\n";


        // Actions sur plusieurs sujets
        if ( $_SESSION['groupe'] != 1 )
        {
            $page_texte .= "<p class=\"droite\"><input type=\"button\" name=\"deselect_all\" id=\"deselect_all\" onclick=\"deselect_all_msg();\" value=\"Tout désélectionner\" /> <input type=\"button\" name=\"select_all\" id=\"select_all\" onclick=\"select_all_msg();\" value=\"Tout sélectionner\" /><br />\n";
            $page_texte .= "<select name=\"action\" id=\"id_action\">\n";
            $page_texte .= "  <option value=\"fav_add\">Ajouter aux favoris</option>";
            $page_texte .= "  <option value=\"fav_del\">Enlever des favoris</option>";
            $page_texte .= "</select> <input type=\"submit\" name=\"submit\" value=\"" . $langue['valider'] . "\" /></p>\n\n</form>\n\n";
        }


        // Droits de création d'un nouveau sujet
        if ( $droit['sujet_edition_auteur'] == 1 || $droit['sujet_edition'] == 1 )
        {
            $page_texte .= '<p class="droite print_hidden"><a href="index.' . EXT . '?page=Messages&amp;action=nouveau_sujet&amp;id=' . $_GET['id'] . '" title="' . $langue['nouveau_sujet_texte'] . '"><img src="themes/' . $configuration['style'] . '/images/nouveau.png" title="' . $langue['nouveau_sujet_texte'] . '" alt="' . $langue['nouveau_sujet'] . "\" /></a></p>\n";
        }

        // Accès vers les autres forums
        $page_texte .= $saut_forum;
    }
    else
    {
        $page_texte .= "\n</p>Il n'y a aucun sujet dans ce forum.</p>\n";
    }
}
// Liste des forums d'une catégorie
else if ( isset ( $_GET['cat'] ) )
{
    // Titre de la page
    $page_titre = $langue['liste_forums'];
    $page_infos = $langue['liste_forums'];


    $sql = "SELECT `forum_cat_nom`
            FROM `" . $database->pref . "forum_cat`
            WHERE `forum_cat_id` = '" . $_GET['cat'] . "';";

    $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

    if ( $database->NbrRowsSelected ( $req ) === 0 )
    {
        header ( 'Location: index.' . EXT . '?page=Forums' );
        die ( -1 );
    }

    $categorie = $database->Result ( $req , 'forum_cat_nom' );


    // Navigation
    $page_texte .= '<p>' . $langue['navigation'] . ' : <a href="index.' . EXT . '?page=Forums' . "\" title=\"" . $langue['forums_texte'] . '">' . $langue['forums'] . '</a> > ';
    $page_texte .= '<a href="index.' . EXT . '?page=Forums&amp;cat=' . $_GET['cat'] . '">' . $categorie . "</a></p>\n\n";


    $sql_add1 = '';
    $sql_add2 = '';

    if ( $_SESSION['groupe'] != 1 )
    {
        $sql_add1 = ", `sv_message`";

        $sql_add2 = "LEFT JOIN `" . $database->pref . "forum_sujet_view`
                ON `sv_sujet` = `forum_msg_sujet`
                AND `sv_membre` = '" . $_SESSION['membre_id'] . "'";
    }


    // Requête sélectionnant tous les forums et toutes les catégories
    $sql = "SELECT `forum_id`,
                   `forum_nom`,
                   `forum_description`,
                   `forum_nbr_sujet`,
                   `forum_nbr_msg`,
                   `forum_last_msg`,
                   `forum_msg_time`,
                   `forum_msg_auteur`,
                   `membre_nom`
                   " . $sql_add1 . "
            FROM `" . $database->pref . "forum_forum`
            LEFT JOIN `" . $database->pref . "forum_msg`
                ON `forum_msg_id` = `forum_last_msg`
            LEFT JOIN `" . $database->pref . "forum_sujet`
                ON `sujet_id` = `forum_msg_sujet`
            LEFT JOIN `" . $database->pref . "membres`
                ON `membre_id` = `forum_msg_auteur`
            " . $sql_add2 . "
            WHERE `forum_categorie` = '" . $_GET['cat'] . "'
            ORDER BY `forum_ordre` ASC;";

    $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

    if ( $database->NbrRowsSelected ( $req ) === 0 )
    {
        $page_texte .= '<p>' . $langue['aucun_forum'] . "</p>\n\n";
    }
    else
    {
        // En-tête du tableau
        $page_texte .= "\n<table>\n\n<thead>\n<tr>\n";
        $page_texte .= "  <th class=\"forum_lecture\"></th>\n";
        $page_texte .= '  <th class="forum_nom">' . $langue['forum'] . "</th>\n";
        $page_texte .= '  <th class="forum_sujets">' . $langue['sujets'] . "</th>\n";
        $page_texte .= '  <th class="forum_msg">' . $langue['messages'] . "</th>\n";
        $page_texte .= '  <th class="forum_last_msg">' . $langue['last_message'] . "</th>\n";
        $page_texte .= "</tr>\n</thead>\n\n<tbody>\n";

        $page_texte .= "<tr class=\"forum_categorie\">\n";
        $page_texte .= '  <td colspan="5"><a href="index.' . EXT . '?page=Forums&amp;cat=' . $_GET['cat'] . '">' . $categorie . "</a></td>\n</tr>\n";

        // Liste des catégories et des forums
        while ( $row = $database->ResultArray ( $req ) )
        {
            $page_texte .= "<tr>\n";

            if ( empty ( $row['forum_nom'] ) )
            {
                $page_texte .= '  <td colspan="5">Il n\'y a aucun forum dans cette catégorie';
            }
            else
            {
                $page_texte .= '  <td class="centre"><img src="themes/' . $configuration['style'] . '/images/';

                if ( $_SESSION['groupe'] != 1 )
                {
                    if ( $row['sv_message'] == $row['forum_last_msg'] || $row['forum_last_msg'] == 0 )
                    {
                        $page_texte .= 'message.png" alt="" title="Pas de nouveaux messages" />';
                    }
                    else
                    {
                        $page_texte .= 'message_nouveau.png" alt="" title="Nouveaux messages" />';
                    }
                }
                else
                {
                    $page_texte .= 'message.png" alt="" title="Nouveaux messages" />';
                }

                $page_texte .= "</td>\n" . '  <td><a href="index.' . EXT . '?page=Forums&amp;id=' . $row['forum_id'] . '">' . $row['forum_nom'] . '</a><br />' . $row['forum_description'] . "</td>\n";
                $page_texte .= '  <td class="centre">' . $row['forum_nbr_sujet'] . "</td>\n";
                $page_texte .= '  <td class="centre">' . $row['forum_nbr_msg'] . "</td>\n";
                $page_texte .= '  <td class="forum_last_message">';

                if ( $row['forum_nbr_msg'] == 0 )
                {
                    $page_texte .= 'Aucun message';
                }
                else
                {
                    $jour = date ( $configuration['format_date'] , $row['forum_msg_time'] );

                    if ( $jour == date ( $configuration['format_date'] ) )
                    {
                        $jour = $langue['today'];
                    }
                    else if ( $jour == date ( $configuration['format_date'] , $time - 86400 ) )
                    {
                        $jour = $langue['yesterday'];
                    }

                    $page_texte .= '<a href="index.' . EXT . '?page=Sujets&amp;msg=' . $row['forum_last_msg'] . "\" title=\"Voir le dernier message\">" . $jour . $langue['time_at'] . date ( $configuration['format_heure'] , $row['forum_msg_time'] ) . '</a><br />' . $langue['_par_'];

                    if ( $row['forum_msg_auteur'] == 0 )
                    {
                        $page_texte .= $langue['anonyme'];
                    }
                    else
                    {
                        $page_texte .= '<a href="index.' . EXT . '?page=Membre&amp;id=' . $row['forum_msg_auteur'] . '" title="' . $langue['view_fiche'] . $row['membre_nom'] . '">' . $row['membre_nom'] . '</a>';
                    }
                }
            }

            $page_texte .= "</td>\n</tr>\n";
        }

        $page_texte .= "</tbody>\n\n</table>\n";
    }
}
// Liste des forums
else
{
    // Titre de la page
    $page_titre = $langue['liste_forums'];
    $page_infos = $langue['liste_forums'];


    // Navigation
    $page_texte .= '<p>' . $langue['navigation'] . ' : <a href="index.' . EXT . '?page=Forums" title="' . $langue['forums_texte'] . '">' . $langue['forums'] . "</a></p>\n\n";


    $sql_add1 = '';
    $sql_add2 = '';

    if ( $_SESSION['groupe'] != 1 )
    {
        $sql_add1 = ", `sv_message`";

        $sql_add2 = "LEFT JOIN `" . $database->pref . "forum_sujet_view`
                ON `sv_sujet` = `forum_msg_sujet`
                AND `sv_membre` = '" . $_SESSION['membre_id'] . "'";
    }


    // Requête sélectionnant tous les forums et toutes les catégories
    $sql = "SELECT `forum_cat_id`,
                   `forum_cat_nom`,
                   `forum_id`,
                   `forum_nom`,
                   `forum_description`,
                   `forum_nbr_sujet`,
                   `forum_nbr_msg`,
                   `forum_last_msg`,
                   `forum_msg_time`,
                   `forum_msg_auteur`,
                   `membre_nom`
                   " . $sql_add1 . "
            FROM `" . $database->pref . "forum_cat`
            LEFT JOIN `" . $database->pref . "forum_forum`
                ON `forum_cat_id` = `forum_categorie`
            LEFT JOIN `" . $database->pref . "forum_msg`
                ON `forum_msg_id` = `forum_last_msg`
            " . $sql_add2 . "
            LEFT JOIN `" . $database->pref . "membres`
                ON `membre_id` = `forum_msg_auteur`
            ORDER BY
                `forum_cat_ordre` ASC,
                `forum_ordre` ASC;";

    $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

    if ( $database->NbrRowsSelected ( $req ) === 0 )
    {
        $page_texte .= "\n<p>" . $langue['aucun_forum'] . "</p>\n";
    }
    else
    {
        // En-tête du tableau
        $page_texte .= "\n<table>\n\n<thead>\n<tr>\n";
        $page_texte .= "  <th class=\"forum_lecture\"></th>\n";
        $page_texte .= '  <th class="forum_nom">' . $langue['forum'] . "</th>\n";
        $page_texte .= '  <th class="forum_sujets">' . $langue['sujets'] . "</th>\n";
        $page_texte .= '  <th class="forum_msg">' . $langue['messages'] . "</th>\n";
        $page_texte .= '  <th class="forum_last_msg">' . $langue['last_message'] . "</th>\n";
        $page_texte .= "</tr>\n</thead>\n\n<tbody>\n";


        $categorie = 0;

        // Liste des catégories et des forums
        while ( $row = $database->ResultArray ( $req ) )
        {
            // On affiche une fois chaque catégorie
            if ( $categorie != $row['forum_cat_id'] )
            {
                $categorie = $row['forum_cat_id'];
                $page_texte .= "<tr class=\"forum_categorie\">\n";
                $page_texte .= '  <td colspan="5"><a href="index.' . EXT . '?page=Forums&amp;cat=' . $row['forum_cat_id'] . '">' . $row['forum_cat_nom'] . "</a></td>\n</tr>\n";
            }

            $page_texte .= "<tr>\n";

            if ( empty ( $row['forum_nom'] ) )
            {
                $page_texte .= '  <td colspan="5">Il n\'y a aucun forum dans cette catégorie';
            }
            else
            {
                $page_texte .= '  <td class="centre"><img src="themes/' . $configuration['style'] . '/images/';

                if ( $_SESSION['groupe'] != 1 )
                {
                    if ( $row['sv_message'] == $row['forum_last_msg'] || $row['forum_last_msg'] == 0 )
                    {
                        $page_texte .= 'message.png" alt="" title="Pas de nouveaux messages" />';
                    }
                    else
                    {
                        $page_texte .= 'message_nouveau.png" alt="" title="Nouveaux messages" />';
                    }
                }
                else
                {
                    $page_texte .= 'message.png" alt="" title="Nouveaux messages" />';
                }

                $page_texte .= "</td>\n" . '  <td><a href="index.' . EXT . '?page=Forums&amp;id=' . $row['forum_id'] . '">' . $row['forum_nom'] . '</a>';

                if ( !empty ( $row['forum_description'] ) )
                {
                    $page_texte .= '<br /><em>' . $row['forum_description'] . '</em>';
                }

                $page_texte .= "</td>\n";
                $page_texte .= '  <td class="centre">' . $row['forum_nbr_sujet'] . "</td>\n";
                $page_texte .= '  <td class="centre">' . $row['forum_nbr_msg'] . "</td>\n";
                $page_texte .= '  <td class="forum_last_message">';
                
                if ( $row['forum_nbr_msg'] == 0 )
                {
                    $page_texte .= $langue['aucun_message'];
                }
                else
                {
                    $jour = date ( $configuration['format_date'] , $row['forum_msg_time'] );

                    if ( $jour == date ( $configuration['format_date'] ) )
                    {
                        $jour = $langue['today'];
                    }
                    else if ( $jour == date ( $configuration['format_date'] , $time - 86400 ) )
                    {
                        $jour = $langue['yesterday'];
                    }

                    $page_texte .= '<a href="index.' . EXT . '?page=Sujets&amp;msg=' . $row['forum_last_msg'] . '" title="Voir le dernier message">' . $jour . $langue['time_at'] . date ( $configuration['format_heure'] , $row['forum_msg_time'] ) . '</a><br />' . $langue['_par_'];

                    if ( $row['forum_msg_auteur'] == 0 )
                    {
                        $page_texte .= $langue['anonyme'];
                    }
                    else
                    {
                        $page_texte .= '<a href="index.' . EXT . '?page=Membre&amp;id=' . $row['forum_msg_auteur'] . '" title="' . $langue['view_fiche'] . $row['membre_nom'] . '">' . $row['membre_nom'] . '</a>';
                    }
                }
            }
            
            $page_texte .= "</td>\n</tr>\n";
        }

        $page_texte .= "</tbody>\n\n</table>\n";
    }
}

?>