<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /pages/Inscription.php
 *  Date de création : avant le 13/08/2007
 *  Dernière modification : 14/09/2007
 ***************************************************************************/

// Sécurité
if ( !defined ( 'TAGADASH' ) )
{
    header ( 'Location: ../' );
    die ( -1 );
}


// On vérifie qu'on n'est pas connecté
if ( $_SESSION['groupe'] != 1 )
{
    $page_msg = 20;
    include_once ( 'systeme/msg.' . EXT );
}


// Titre de la page
$page_titre = $langue['inscription'];
$page_infos = $langue['inscription'];


$form_champ_utilisateur = '';
$form_champ_email = '';

// Traitement des données du formulaire
if ( isset ( $_POST['submit'] ) )
{
    $form_champ_utilisateur = $_POST['utilisateur'];
    $form_champ_email = $_POST['email'];

    if ( empty ( $_POST['utilisateur'] ) || trim ( $_POST['utilisateur'] ) == '' || empty ( $_POST['mdp'] ) || empty ( $_POST['mdp2'] ) || empty ( $_POST['email'] ) || ( $configuration['captcha'] == 1 && empty ( $_POST['captcha'] ) ) )
    {
        $page_texte .= '<p><strong>' . $langue['erreur'] . '&nbsp;:</strong> ' . $langue['err_oblig'] . "</p>\n\n";
    }
    else if ( $configuration['captcha'] == 1 && $_POST['captcha'] != $_SESSION['captcha'] )
    {
        $page_texte .= '<p><strong>' . $langue['erreur'] . "&nbsp;:</strong> Le code est incorrect.</p>\n\n";
    }
    else
    {
        $sql = "SELECT `membre_id`
                FROM `" . $database->pref . "membres`
                WHERE `membre_nom` = '" . $_POST['utilisateur'] . "';";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        if ( $database->NbrRowsSelected ( $req ) > 0 )
        {
            $page_texte .= '<p><strong>' . $langue['erreur'] . '&nbsp;:</strong> ' . 'L\'utilisateur <em>' . $_POST['utilisateur'] . "</em> existe déjà.</p>\n";
        }
        // Vérification que les deux mots de passe sont identiques
        else if ( $_POST['mdp'] != $_POST['mdp2'] )
        {
            $page_texte .= '<p><strong>' . $langue['erreur'] . '&nbsp;:</strong> ' . $langue['err_mdp'] . "</p>\n\n";
        }
        // Vérification de la longueur du mot de passe
        else if ( strlen ( $_POST['mdp'] ) < 6 || strlen ( $_POST['mdp'] ) > 16 )
        {
            $page_texte .= '<p><strong>' . $langue['erreur'] . '&nbsp;:</strong> ' . $langue['err_mdp_size'] . "</p>\n\n";
        }
        // Vérification du nom d'utilisateur
        else if ( !preg_match ( "#^([a-z0-9_@-]{4,20})$#i" , $_POST['utilisateur'] ) )
        {
            $page_texte .= '<p><strong>' . $langue['erreur'] . '&nbsp;:</strong> ' . 'Le nom d\'utilisateur doit comporter au moins 4 caractères (lettres, chiffres, tirets, underscores ou arobases).' . "</p>\n\n";
        }
        // Vérification du format de l'adresse e-mail
        else if ( !preg_match ( "#^([a-z0-9._-]+@[a-z0-9._-]{2,}\.[a-z]{2,4})$#i" , $_POST['email'] ) )
        {
            $page_texte .= '<p><strong>' . $langue['erreur'] . '&nbsp;:</strong> ' . $langue['err_email_format'] . "</p>\n\n";
        }
        else
        {
            $sql = "SELECT `membre_id`
                    FROM `" . $database->pref . "membres`
                    WHERE `membre_email` = '" . $_POST['email'] . "';";

            $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            if ( $database->NbrRowsSelected ( $req ) > 0 )
            {
                $page_texte .= '<p><strong>' . $langue['erreur'] . '&nbsp;:</strong> ' . $langue['err_email_use'] . "</p>\n";
            }
            else
            {
                $cle = mt_rand ();

                $sql = "INSERT INTO `" . $database->pref . "membres`
                        (`membre_nom`, `membre_mdp`, `membre_email`, `membre_cle`, `membre_groupe`, `membre_inscription`, `membre_anniversaire`, `membre_actif`, `membre_langue`, `membre_style`, `membre_profession`, `membre_mail_pm`, `membre_avatar`, `membre_signature`, `membre_site`, `membre_localisation`, `membre_messagerie`)
                        VALUES
                        ('" . $_POST['utilisateur'] . "', '" . md5 ( $_POST['mdp'] ) . "', '" . $_POST['email'] . "', '" . $cle . "', '2', '" . $time . "', '0000-00-00', '0', '" . $configuration['langue'] . "', '" . $configuration['style'] . "', '', '0', '', '', '', '', '');";

                $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                $member_id = $database->LastInsertId ( $req );

                $mail = SendEmail ($_POST['utilisateur'] . ' <' . $_POST['email'] . '>' , $configuration['titre'] . ' <' . $configuration['email'] . '>' , 'Inscription sur le site ' . $configuration['titre'] , '<h1>' . $configuration['titre'] . "</h1>\n\n<p>Bonjour, quelqu'un (sans doute vous) a utilisé l'adresse " . $_POST['email'] . " pour s'inscrire sur le site <a href=\"" . $configuration['adresse'] . '">' . $configuration['titre'] . "</a>.</p>\n\n<p><a href=\"" . $configuration['adresse'] . 'index.' . EXT . '?page=Membre&amp;id=' . $member_id . '&amp;cle=' . $cle . "\">Cliquez-ici</a> pour confirmer cette inscription.</p>\n\n<p>Si vous ne répondez pas à ce message, cette inscription sera annulée au bout d'une semaine.</p>" );

                if ( $mail === true )
                {
                    $page_msg = 25;
                    include_once ( 'systeme/msg.' . EXT );
                }

                $page_texte .= '<p><strong>' . $langue['erreur'] . "&nbsp;:</strong> Impossible d'envoyer le message de confirmation. Veuillez réessayer plus tard ou contacter l'administrateur du site.</p>\n\n";
            }
        }
    }
}

$page_texte .= '<form action="index.' . EXT . '?page=Inscription" title="' . $langue['inscription'] . "\" method=\"post\">

<fieldset>\n<legend>" . $langue['inscription'] . "</legend>

<p class=\"form_input\"><label class=\"form_label\" for=\"id_utilisateur\">" . $langue['user'] . "&nbsp;:</label><input type=\"text\" name=\"utilisateur\" size=\"30\" maxlength=\"20\" id=\"id_utilisateur\" tabindex=\"10\" value=\"" . $form_champ_utilisateur . "\" /></p>
<p class=\"form_input\"><label class=\"form_label\" for=\"id_mdp\">" . $langue['password'] . "&nbsp;:</label><input type=\"password\" name=\"mdp\" size=\"30\" maxlength=\"16\" id=\"id_mdp\" value=\"\" tabindex=\"11\" /></p>
<p class=\"form_input\"><label class=\"form_label\" for=\"id_mdp2\">" . $langue['confirm'] . "&nbsp;:</label><input type=\"password\" name=\"mdp2\" size=\"30\" maxlength=\"16\" id=\"id_mdp2\" value=\"\" tabindex=\"12\" /></p>
<p class=\"form_input\"><label class=\"form_label\" for=\"id_email\">" . $langue['email'] . "&nbsp;:</label><input type=\"text\" name=\"email\" size=\"30\" id=\"id_email\" value=\"" . $form_champ_email . "\" tabindex=\"13\" /></p>\n\n";

if ( $configuration['captcha'] == 1 )
{
    $page_texte .= '<p><img src="captcha.' . EXT . "\" id=\"captcha\" alt=\"Captcha\" title=\"Captcha\" /><br />\n";
    $page_texte .= "<a href=\"#\" onclick=\"javascript:document.getElementById('captcha').src='captcha." . EXT . "?'+i++;\">Changer le code</a></p>\n\n";
    $page_texte .= "<p class=\"form_input\"><label class=\"form_label\" for=\"id_captcha\">Recopiez ce code&nbsp;:</label><input type=\"text\" name=\"captcha\" size=\"30\" id=\"id_captcha\" value=\"\" tabindex=\"14\" /></p>\n\n";
}

$page_texte .= "</fieldset>\n\n<p class=\"centre\"><input type=\"submit\" name=\"submit\" tabindex=\"15\" accesskey=\"s\" value=\"" . $langue['valider'] . "\" /></p>\n\n</form>";

?>