<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /pages/Liste_des_fichiers.php
 *  Date de création : avant le 12/08/2007
 *  Dernière modification : 23/08/2007
 ***************************************************************************/

// Sécurité
if ( !defined ( 'TAGADASH' ) )
{
    header ( 'Location: ../' );
    die ( -1 );
}


if ( isset ( $_GET['membre'] ) )
{
    $page_texte .= '<p><a href="index.' . EXT . '?page=Liste_des_fichiers' . "\">Fichiers de tous les membres</a></p>\n\n";

    $sql = "SELECT `fichier_id`,
                   `fichier_extension`,
                   `fichier_nom`,
                   `fichier_membre`,
                   `membre_nom`
            FROM `" . $database->pref . "fichiers`
            LEFT JOIN `" . $database->pref . "membres`
                ON `membre_id` = `fichier_membre`
            WHERE `fichier_membre` = '" . $_GET['membre'] . "'
            ORDER BY `fichier_nom` ASC;";

    $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

    if ( $database->NbrRowsSelected ( $req ) === 0 )
    {
        header ( 'Location: index.' . EXT . '?page=Liste_des_fichiers' );
        die ( -1 );
    }
    else
    {
        $page_texte .= "\n<ul>\n";

        while ( $row = $database->ResultArray ( $req ) )
        {
            // Titre de la page
            $page_titre = 'Liste des fichiers et des images de ' . $row['membre_nom'];
            $page_infos = 'Liste des fichiers et des images de ' . $row['membre_nom'];

            $page_texte .= '  <li><a href="index.' . EXT . '?page=Fichier&amp;id=' . $row['fichier_id'] . '">' . $row['fichier_nom'] . "</a>";

            // On regarde si on a le droit de supprimer le fichier
            if ( ( $droit['upload'] == 1 && $_SESSION['membre_id'] == $row['fichier_membre'] ) || $_SESSION['groupe'] == 3 )
            {
                $page_texte .= ' [<a href="index.' . EXT . '?page=Fichier&amp;id=' . $row['fichier_id'] . '&amp;supprimer' . '">' . $langue['supprimer'] . '</a>]';
            }

            $page_texte .= "</li>\n";
        }

        $page_texte .= "</ul>\n";
    }
}
else
{
    // Titre de la page
    $page_titre = 'Liste des fichiers et des images';
    $page_infos = 'Liste des fichiers et des images';

    $sql = "SELECT `fichier_id`,
                   `fichier_nom`,
                   `fichier_membre`
            FROM `" . $database->pref . "fichiers`
            ORDER BY `fichier_nom` ASC;";

    $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

    if ( $database->NbrRowsSelected ( $req ) === 0 )
    {
        $page_texte .= "\n<p>Il n'y a aucun fichier actuellement.</p>\n";
    }
    else
    {
        $page_texte .= "\n<ul>\n";

        while ( $row = $database->ResultArray ( $req ) )
        {
            $page_texte .= '  <li><a href="index.' . EXT . '?page=Fichier&amp;id=' . $row['fichier_id'] . '">' . $row['fichier_nom'] . '</a>';

            // On regarde si on a le droit de supprimer le fichier
            if ( ( $droit['upload'] == 1 && $_SESSION['membre_id'] == $row['fichier_membre'] ) || $_SESSION['groupe'] == 3 )
            {
                $page_texte .= ' [<a href="index.' . EXT . '?page=Fichier&amp;id=' . $row['fichier_id'] . '&amp;supprimer' . '">Supprimer</a>]';
            }

            $page_texte .= "</li>\n";
        }

        $page_texte .= "</ul>\n";
    }
}

?>