<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /pages/Liste_des_membres.php
 *  Date de création : avant le 13/08/2007
 *  Dernière modification : 07/09/2007
 ***************************************************************************/

// Sécurité
if ( !defined ( 'TAGADASH' ) )
{
    header ( 'Location: ../' );
    die ( -1 );
}


// Titre de la page
$page_titre = 'Liste des membres du site';
$page_infos = 'Liste des membres du site';


// Nombre de membres
$sql = "SELECT COUNT(*) AS `count`
        FROM `" . $database->pref . "membres`
        WHERE `membre_actif`= '1';";
        
$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

$nbr_membre = $database->Result ( $req , 'count' );

// Premier membre et numéro de la page affichée
if ( isset ( $_GET['start'] ) && is_numeric ( $_GET['start'] ) && $_GET['start'] >= 0 && $_GET['start'] < $nbr_membre )
{
    $start = $_GET['start'];
}
else
{
    $start = 0;
}

$page_actuelle = intval ( $start / $configuration['membres_page'] ) + 1;

// Nombre de pages
$nbr_page = ( ( $nbr_membre - 1 ) - ( $nbr_membre - 1 ) % $configuration['membres_page'] ) / $configuration['membres_page'] + 1;


// Ordre d'affichage
$ordre = ( isset ( $_GET['ordre'] ) ) ? $_GET['ordre'] : 'nom-ASC';

switch ( $ordre )
{
    default:
    case 'nom-ASC':
        $order_by = 'membre_nom';
        $order_tri = 'ASC';
        break;

    case 'nom-DESC':
        $order_by = 'membre_nom';
        $order_tri = 'DESC';
        break;

    case 'visite-ASC':
        $order_by = 'membre_visite';
        $order_tri = 'ASC';
        break;

    case 'visite-DESC':
        $order_by = 'membre_visite';
        $order_tri = 'DESC';
        break;

    case 'anniversaire-ASC':
        $order_by = 'membre_anniversaire';
        $order_tri = 'ASC';
        break;

    case 'anniversaire-DESC':
        $order_by = 'membre_anniversaire';
        $order_tri = 'DESC';
        break;
}


$sql = "SELECT `membre_id`,
               `membre_nom`,
               `membre_visite`,
               `membre_anniversaire`,
               `visiteur_time`
        FROM `" . $database->pref . "membres`
        LEFT JOIN `" . $database->pref . "visiteurs`
            ON `visiteur_nom` = `membre_nom`
            AND `visiteur_time` > '" . ( $time - 300 ) . "'
        WHERE `membre_actif` = '1'
        ORDER BY `" . $order_by . "` " . $order_tri . "";

//=>MYSQL
    if ( SGBD == 'mysql' ) $sql .= ' LIMIT ' . $start . ', ' . $configuration['membres_page'];
//
    $sql .= ';';

$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

if ( $database->NbrRowsSelected ( $req ) > 0 )
{
    $page_texte .= "<table>\n\n<thead>\n";


    // Liste des pages
    if ( $nbr_membre > $configuration['membres_page'] )
    {
        $page_texte .= "<tr>\n  <td colspan=\"4\">" . $langue['page'] . "&nbsp;:\n";

        for ( $i = 1 ; $i <= $nbr_page ; $i++ )
        {
            $affiche_numero = false;

            for ( $numero = 1 ; $numero <= $configuration['numero_debut'] ; $numero++ )
            {
                if ( $i == $numero ) $affiche_numero = true;
            }

            if ( !$affiche_numero )
            {
                for ( $numero = $page_actuelle - $configuration['numero_autour'] ; $numero <= $page_actuelle + $configuration['numero_autour'] ; $numero++ )
                {
                    if ( $i == $numero ) $affiche_numero = true;
                }
            }

            if ( !$affiche_numero )
            {
                for ( $numero = $nbr_page + 1 - $configuration['numero_fin'] ; $numero <= $nbr_page ; $numero++ )
                {
                    if ( $i == $numero ) $affiche_numero = true;
                }
            }

            if ( $affiche_numero ) 
            {
                $page_texte .= '    <a href="index.' . EXT . '?page=Liste_des_membres&start=' . ( $i - 1 ) * $configuration['membres_page'] . '" title="' . $langue['page_goto'] . $i . '">';
                $page_texte .= ( $start == ( $i - 1 ) * $configuration['membres_page'] ) ? '<span class="page_actuelle">' . $i . "</span></a>\n" : $i . "</a>\n";
                $trois_petits_points = false;
            }
            else if ( !$trois_petits_points )
            {
                $page_texte .= "    ...\n";
                $trois_petits_points = true;
            }
        }

        $page_texte .= "  </td>\n</tr>\n";
    }


    // En-tête du tableau
    $page_texte .= "<tr>\n";
    $page_texte .= "  <th class=\"liste_membre_nom\"><a href=\"";

    $tmp_lien = ( $ordre == 'nom-ASC' ) ? 'DESC' : 'ASC';

    $page_texte .= 'index.' . EXT . '?page=Liste_des_membres&ordre=nom-' . $tmp_lien . '&start=' . $start;

    $page_texte .= '">' . $langue['user'] . "</a></th>\n";
    $page_texte .= "  <th class=\"liste_membre_visite\"><a href=\"";

    $tmp_lien = ( $ordre == 'visite-ASC' ) ? 'DESC' : 'ASC';

    $page_texte .= 'index.' . EXT . '?page=Liste_des_membres&ordre=visite-' . $tmp_lien . '&start=' . $start;

    $page_texte .= '">' . $langue['last_visite'] . "</a></th>\n";
    $page_texte .= "  <th class=\"liste_membre_anni\"><a href=\"";

    $tmp_lien = ( $ordre == 'anniversaire-ASC' ) ? 'DESC' : 'ASC';

    $page_texte .= 'index.' . EXT . '?page=Liste_des_membres&ordre=anniversaire-' . $tmp_lien . '&start=' . $start;

    $page_texte .= '">' . $langue['naissance'] . "</a></th>\n";
    $page_texte .= "</tr>\n</thead>\n\n";


    // Liste des pages
    if ( $nbr_membre > $configuration['membres_page'] )
    {
        $page_texte .= "<tfoot>\n<tr>\n  <td colspan=\"4\">" . $langue['page'] . "&nbsp;:\n";

        for ( $i = 1 ; $i <= $nbr_page ; $i++ )
        {
            $affiche_numero = false;

            for ( $numero = 1 ; $numero <= $configuration['numero_debut'] ; $numero++ )
            {
                if ( $i == $numero ) $affiche_numero = true;
            }

            if ( !$affiche_numero )
            {
                for ( $numero = $page_actuelle - $configuration['numero_autour'] ; $numero <= $page_actuelle + $configuration['numero_autour'] ; $numero++ )
                {
                    if ( $i == $numero ) $affiche_numero = true;
                }
            }

            if ( !$affiche_numero )
            {
                for ( $numero = $nbr_page + 1 - $configuration['numero_fin'] ; $numero <= $nbr_page ; $numero++ )
                {
                    if ( $i == $numero ) $affiche_numero = true;
                }
            }

            if ( $affiche_numero ) 
            {
                $page_texte .= '    <a href="index.' . EXT . '?page=Liste_des_membres&start=' . ( $i - 1 ) * $configuration['membres_page'] . '" title="' . $langue['page_goto'] . $i . '">';
                $page_texte .= ( $start == ( $i - 1 ) * $configuration['membres_page'] ) ? '<span class="page_actuelle">' . $i . "</span></a>\n" : $i . "</a>\n";
                $trois_petits_points = false;
            }
            else if ( !$trois_petits_points )
            {
                $page_texte .= "    ...\n";
                $trois_petits_points = true;
            }
        }

        $page_texte .= "  </td>\n</tr>\n</tfoot>\n\n";
    }


    $page_texte .= "<tbody>\n";


    $sql_limite = 0;

    while ( $sql_limite < $start + $configuration['membres_page'] && $row = $database->ResultArray ( $req ) )
    {
        $sql_limite++;

        // On affiche les enregistrements à partir de $start
        if ( SGBD != 'mysql' && $sql_limite < $start )
        {
            continue;
        }

        $page_texte .= "<tr>\n  <td>";

        if ( empty ( $row['visiteur_time'] ) )
        {
            $page_texte .= '<img src="themes/' . $configuration['style'] . '/images/perso1.png" title="' . $langue['deconnecte'] . '" alt="" /> ';
        }
        else
        {
            $page_texte .= '<img src="themes/' . $configuration['style'] . '/images/perso2.png" title="' . $langue['connecte'] . '" alt="" /> ';
        }

        $page_texte .= ( $droit['fiche_lecture'] == 1 ) ? '<a href="index.' . EXT . '?page=Membre&amp;id=' . $row['membre_id'] . "\" title=\"" . $langue['view_fiche'] . $row['membre_nom'] . '">' . $row['membre_nom'] . '</a>' : $row['membre_nom'];
        $page_texte .= "</td>\n";
        $page_texte .= "  <td class=\"centre\">" . date ( $configuration['format_date'] , $row['membre_visite'] ) . $langue['time_at'] . date ( $configuration['format_heure'] , $row['membre_visite'] ) . "</td>\n";
        $page_texte .= "  <td class=\"centre\">";

        // Pas de date d'anniversaire
        if ( $row['membre_anniversaire'] == '0000-00-00' || empty ( $row['membre_anniversaire'] ) )
        {
            $page_texte .= $langue['date_inconnue'];
        }
        // Si PHP 5.2 ou plus est trouvé, on utilise la fonction date_format
        else if ( version_compare ( PHP_VERSION , '5.2' , '>' ) )
        {
            $anniversaire = new DateTime ( $row['membre_anniversaire'] );
            $page_texte .= date_format ( $anniversaire , $configuration['format_date'] );
        }
        // Sinon on utilise une fonction qui retourne une date d/m/Y
        else
        {
            $page_texte .= ConvertDate ( $row['membre_anniversaire'] );
        }

        $page_texte .= "</td>\n</tr>\n";
    }


    $page_texte .= "</tbody>\n\n</table>\n";
}
else
{
    $page_texte .= "\n<p>Il n'y a aucun membre.</p>\n";
}

?>