<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /pages/News.php
 *  Date de création : 02/08/2007
 *  Dernière modification : 14/09/2007
 ***************************************************************************/

// Sécurité
if ( !defined ( 'TAGADASH' ) )
{
    header ( 'Location: ../' );
    die ( -1 );
}


$action = ( isset ( $_GET['action'] ) ) ? $_GET['action'] : '';

switch ( $action )
{
    default:

        // Affichage d'une news
        if ( isset ( $_GET['id'] ) )
        {
            if ( $droit['news_lecture'] == 0 )
            {
                $page_msg = 6;
                include_once ( 'systeme/msg.' . EXT );
            }

            $sql = "SELECT `news_titre`,
                           `news_texte`,
                           `news_time`,
                           `news_auteur`,
                           `news_lectures`,
                           `news_commentaires`,
                           `membre_nom`
                    FROM `" . $database->pref . "news`
                    LEFT JOIN `" . $database->pref . "membres`
                        ON `membre_id` = `news_auteur`
                    WHERE `news_id` = '" . $_GET['id'] . "';";

            $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            if ( $database->NbrRowsSelected ( $req ) === 0 )
            {
                header ( 'Location: index.' . EXT . '?page=News' );
                die ( -1 );
            }


            // Titre de la page
            $page_titre = $langue['read_news'];
            $page_infos = $langue['read_news'];


            while ( $row = $database->ResultArray ( $req ) )
            {
                $lectures = $row['news_lectures'] + 1;
                $nbr_commentaires = $row['news_commentaires'];

                // Mise-à-jour du compteur de la news
                $sql = "UPDATE `" . $database->pref . "news`
                        SET `news_lectures` = `news_lectures` + 1
                        WHERE `news_id` = '" . $_GET['id'] . "';";

                $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                $page_texte .= "<div class=\"news\">\n";
                $page_texte .= '<h3 class="news_titre">' . $row['news_titre'] . "</h3>\n";
                $page_texte .= '<div class="news_infos">Postée le ' . date ( $configuration['format_date'] , $row['news_time'] ) . $langue['time_at'] . date ( $configuration['format_heure'] , $row['news_time'] );
                $page_texte .= $langue['_par_'] . '<a href="index.' . EXT . '?page=Membre&amp;id=' . $row['news_auteur'] . '" title="' . $langue['view_fiche'] . $row['membre_nom'] . '">' . $row['membre_nom'] . '</a>';
                $page_texte .= ' - ';
                $page_texte .= ( $lectures <= 1 ) ? '1' . $langue['_lecture'] : $lectures . $langue['_lectures'];
                $page_texte .= ' - <a href="#commentaires">' . $row['news_commentaires'];
                $page_texte .= ( $row['news_commentaires'] <= 1 ) ? $langue['_commentaire'] : $langue['_commentaires'];
                $page_texte .= '</a>';


                // Édition et suppression de la news
                if ( ( $droit['news_edition'] == 1 && $row['news_auteur'] == $_SESSION['membre_id'] ) || $_SESSION['groupe'] == 3 )
                {
                    $page_texte .= '<span class="print_hidden"> - <a href="index.' . EXT . '?page=News&amp;action=editer&amp;id=' . $_GET['id'] . '">Éditer</a> - ';
                    $page_texte .= '<a href="index.' . EXT . '?page=News&amp;action=supprimer&amp;id=' . $_GET['id'] . '">' . $langue['supprimer'] . '</a></span>';
                }

                $page_texte .= "</div>\n<div class=\"news_texte\">" . $site->Parser ( $row['news_texte'] , 1 ) . "</div>\n";
                $page_texte .= "</div>\n\n";
            }


            // Nouveau commentaire
            if ( $droit['news_commentaire'] == 1 )
            {
                $page_texte .= '<p class="droite print_hidden"><a href="index.' . EXT . '?page=Commentaires&amp;action=nouveau&amp;news=' . $_GET['id'] . '" title="' . $langue['nouveau_commentaire'] . '"><img src="themes/' . $configuration['style'] . '/images/commentaire.png" title="' . $langue['nouveau_commentaire'] . '" alt="' . $langue['nouveau_commentaire'] . "\" /></a></p>\n";
            }


            // Premier message et numéro de la page affichée
            if ( isset ( $_GET['start'] ) && is_numeric ( $_GET['start'] ) && $start >= 0 && $start < $nbr_commentaires )
            {
                $start = $_GET['start'];
            }
            else
            {
                $start = 0;
            }

            $page_actuelle = intval ( $start / $configuration['commentaires_page'] ) + 1;

            // Nombre de pages
            $nbr_page = ( ( $nbr_commentaires - 1 ) - ( $nbr_commentaires - 1 ) % $configuration['commentaires_page'] ) / $configuration['commentaires_page'] + 1;


            // Affichage des commentaires de la news
            $sql = "SELECT `commentaire_id`,
                           `commentaire_auteur`,
                           `commentaire_time`,
                           `commentaire_texte`,
                           `membre_nom`,
                           `membre_avatar`,
                           `membre_signature`,
                           `groupe_nom`
                    FROM `" . $database->pref . "commentaires`
                    LEFT JOIN `" . $database->pref . "membres`
                        ON `membre_id` = `commentaire_auteur`
                    LEFT JOIN `" . $database->pref . "groupes`
                        ON `groupe_id` = `membre_groupe`
                    WHERE
                            `commentaire_reference` = '" . $_GET['id'] . "'
                        AND `commentaire_type` = '1'
                    ORDER BY `commentaire_time` ASC";

            //=>MYSQL
                if ( SGBD == 'mysql' ) $sql .= ' LIMIT ' . $start . ', ' . $configuration['commentaires_page'];
                $sql .= ';';
            //=>END

            $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            if ( $database->NbrRowsSelected ( $req ) > 0 )
            {
                $page_texte .= "<table class=\"forum_messages\" id=\"commentaires\">\n\n<thead>\n";

                // Liste des pages
                if ( $nbr_commentaires > $configuration['commentaires_page'] )
                {
                    $page_texte .= "<tr>\n  <td colspan=\"2\">" . $langue['page'] . "&nbsp;:\n";

                    for ( $i = 1 ; $i <= $nbr_page ; $i++ )
                    {
                        $affiche_numero = false;

                        for ( $numero = 1 ; $numero <= $configuration['numero_debut'] ; $numero++ )
                        {
                            if ( $i == $numero ) $affiche_numero = true;
                        }

                        if ( !$affiche_numero )
                        {
                            for ( $numero = $page_actuelle - $configuration['numero_autour'] ; $numero <= $page_actuelle + $configuration['numero_autour'] ; $numero++ )
                            {
                                if ( $i == $numero ) $affiche_numero = true;
                            }
                        }

                        if ( !$affiche_numero )
                        {
                            for ( $numero = $nbr_page + 1 - $configuration['numero_fin'] ; $numero <= $nbr_page ; $numero++ )
                            {
                                if ( $i == $numero ) $affiche_numero = true;
                            }
                        }

                        if ( $affiche_numero ) 
                        {
                            $page_texte .= '    <a href="index.' . EXT . '?page=News&amp;id=' . $_GET['id'] . '&start=' . ( $i - 1 ) * $configuration['commentaires_page'] . '#commentaires" title="' . $langue['page_goto'] . $i . '">';
                            $page_texte .= ( $start == ( $i - 1 ) * $configuration['commentaires_page'] ) ? '<span class="page_actuelle">' . $i . "</span></a>\n" : $i . "</a>\n";
                            $trois_petits_points = false;
                        }
                        else if ( !$trois_petits_points )
                        {
                            $page_texte .= "    ...\n";
                            $trois_petits_points = true;
                        }
                    }

                    $page_texte .= "  </td>\n</tr>\n";
                }


                // En-tête du tableau
                $page_texte .= "<tr>\n";
                $page_texte .= '  <th class="forum_messages_auteur">' . $langue['auteur'] . "</th>\n";
                $page_texte .= '  <th class="forum_messages_valeur">' . $langue['message'] . "</th>\n";
                $page_texte .= "</tr>\n</thead>\n\n";


                // Liste des pages
                if ( $nbr_commentaires > $configuration['commentaires_page'] )
                {
                    $page_texte .= "<tfoot>\n<tr>\n  <td colspan=\"2\">" . $langue['page'] . "&nbsp;:\n";

                    for ( $i = 1 ; $i <= $nbr_page ; $i++ )
                    {
                        $affiche_numero = false;

                        for ( $numero = 1 ; $numero <= $configuration['numero_debut'] ; $numero++ )
                        {
                            if ( $i == $numero ) $affiche_numero = true;
                        }

                        if ( !$affiche_numero )
                        {
                            for ( $numero = $page_actuelle - $configuration['numero_autour'] ; $numero <= $page_actuelle + $configuration['numero_autour'] ; $numero++ )
                            {
                                if ( $i == $numero ) $affiche_numero = true;
                            }
                        }

                        if ( !$affiche_numero )
                        {
                            for ( $numero = $nbr_page + 1 - $configuration['numero_fin'] ; $numero <= $nbr_page ; $numero++ )
                            {
                                if ( $i == $numero ) $affiche_numero = true;
                            }
                        }

                        if ( $affiche_numero ) 
                        {
                            $page_texte .= '    <a href="index.' . EXT . '?page=News&amp;id=' . $_GET['id'] . '&amp;start=' . ( $i - 1 ) * $configuration['commentaires_page'] . '#commentaires" title="' . $langue['page_goto'] . $i . '">';
                            $page_texte .= ( $start == ( $i - 1 ) * $configuration['commentaires_page'] ) ? '<span class="page_actuelle">' . $i . "</span></a>\n" : $i . "</a>\n";
                            $trois_petits_points = false;
                        }
                        else if ( !$trois_petits_points )
                        {
                            $page_texte .= "    ...\n";
                            $trois_petits_points = true;
                        }
                    }

                    $page_texte .= "  </td>\n</tr>\n</tfoot>\n\n";
                }


                $page_texte .= "<tbody>\n";


                $sql_limite = 0;

                while ( $sql_limite < $start + $configuration['commentaires_page'] && $row = $database->ResultArray ( $req ) )
                {
                    // On affiche les enregistrements à partir de $start
                    if ( SGBD != 'mysql' && $sql_limite < $start )
                    {
                        continue;
                    }

                    $administration = '';

                    // Édition et suppression du commentaire
                    if ( $_SESSION['groupe'] == 3 )
                    {
                        $administration = '<span class="print_hidden"> - <a href="index.' . EXT . '?page=Commentaires&amp;action=editer&amp;id=' . $row['commentaire_id'] . '" title="' . $langue['editer_message'] . '">' . $langue['editer'] . '</a> - ';
                        $administration .= '<a href="index.' . EXT . '?page=Commentaires&amp;action=supprimer&amp;id=' . $row['commentaire_id'] . '" title="' . $langue['supprimer_message'] . '">' . $langue['supprimer'] . '</a></span>';
                    }
                    else if ( $droit['news_commentaire'] && $_SESSION['membre_id'] == $row['commentaire_auteur'] )
                    {
                        $administration = '<span class="print_hidden"> - <a href="index.' . EXT . '?page=Commentaires&amp;action=editer&amp;id=' . $row['commentaire_id'] . '" title="' . $langue['editer_message'] . '">' . $langue['editer'] . '</a></span>';
                    }

                    // Première ligne : auteur et date
                    $page_texte .= "<tr class=\"message_entete\" id=" . $row['commentaire_id'] . ">\n";
                    $page_texte .= "  <td class=\"centre\">";

                    if ( $row['commentaire_auteur'] == 0 )
                    {
                        $page_texte .= $langue['anonyme'];
                    }
                    else
                    {
                        if ( $droit['fiche_lecture'] == 1 )
                        {
                            $page_texte .= '<a href="index.' . EXT . '?page=Membre&amp;id=' . $row['commentaire_auteur'] . '" title="' . $langue['view_fiche'] . $row['membre_nom'] . '">' . $row['membre_nom'] . '</a>';
                        }
                        else
                        {
                            $page_texte .= $row['membre_nom'];
                        }
                    }

                    $page_texte .= "</td>\n";
                    $page_texte .= '  <td class="message_infos">' . $langue['poste_le'] . date ( $configuration['format_date'] , $row['commentaire_time'] ) . $langue['time_at'] . date ( $configuration['format_heure'] , $row['commentaire_time'] ) . $administration . "</td>\n</tr>\n";

                    // Deuxième ligne : avatar, message et signature
                    $page_texte .= "<tr class=\"message_corps\">\n  <td class=\"centre\">";

                    if ( !empty ( $row['membre_avatar'] ) )
                    {
                        if ( is_file ( 'fichiers/thumbs/100px-' . $row['membre_avatar'] ) )
                        {
                            $page_texte .= '<img src="fichiers/thumbs/100px-' . $row['membre_avatar'] . '" alt="[' . $langue['avatar'] . ']" title="' . $langue['avatar_of'] . $row['membre_nom'] . '" />';
                        }
                        else
                        {
                            $page_texte .= '<img src="fichiers/' . $row['membre_avatar'] . '" alt="[' . $langue['avatar'] . ']" title="' . $langue['avatar_of'] . $row['membre_nom'] . '" />';
                        }
                    }

                    if ( $row['commentaire_auteur'] > 0 )
                    {
                        $page_texte .= '<br />' . $langue['groupe'] . '&nbsp;: ' . $row['groupe_nom'] . "</td>\n";
                    }

                    $page_texte .= "  <td><div class=\"message\">\n" . $site->Parser ( $row['commentaire_texte'] , 0 ) . "</div>";

                    if ( !empty ( $row['membre_signature'] ) )
                    {
                        $page_texte .= "<div class=\"signature\"><hr />" . $site->Parser ( $row['membre_signature'] , 1 ) . "</div>";
                    }

                    $page_texte .= "</td>\n</tr>\n";

                    // On récupère l'identifiant du dernier message affiché
                    $commentaire_last_msg = $row['commentaire_id'];

                    $sql_limite++;
                } // Fin du while()

                $page_texte .= "</tbody>\n\n</table>\n\n";


                // Mise-à-jour de la table des commentaires lus/non lus pour les membres enregistrés
                if ( $_SESSION['groupe'] != 1 )
                {
                    $sql = "SELECT `cv_message`
                            FROM `" . $database->pref . "commentaire_view`
                            WHERE
                                    `cv_referent` = '" . $_GET['id'] . "'
                                AND `cv_type`= '1'
                                AND `cv_membre` = '" . $_SESSION['membre_id'] . "';";

                    $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                    // Si on n'a jamais lu les commentaire de cettes news, on insère une ligne
                    if ( $database->NbrRowsSelected ( $req ) === 0 )
                    {
                        $sql = "INSERT INTO `" . $database->pref . "commentaire_view`
                                (`cv_membre`, `cv_type`, `cv_referent`, `cv_message`)
                                VALUES
                                ('" . $_SESSION['membre_id'] . "', '1', '" . $_GET['id'] . "', '" . $commentaire_last_msg . "');";

                        $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );
                    }
                    // Sinon on met-à-jour
                    else if ( $database->Result ( $req , 'cv_message' ) < $commentaire_last_msg )
                    {
                        $sql = "UPDATE `" . $database->pref . "commentaire_view`
                                SET `cv_message` = '" . $commentaire_last_msg . "'
                                WHERE
                                       `cv_referent` = '" . $_GET['id'] . "'
                                    AND `cv_type`= '1'
                                    AND `cv_membre` = '" . $_SESSION['membre_id'] . "';";

                        $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );
                    }
                }


                // Droits : news_commentaire
                $sql = "SELECT `droit_valeur`
                        FROM `" . $database->pref . "droits`
                        WHERE
                                `droit_groupe` = '" . $_SESSION['groupe'] . "'
                            AND  droit_nom = 'news_commentaire';";

                $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                // Édition et suppression de la news
                if ( $database->NbrRowsSelected ( $req ) > 0 && $database->Result ( $req , 'droit_valeur' ) == 1 )
                {
                    $page_texte .= '<p class="droite print_hidden"><a href="index.' . EXT . '?page=Commentaires&amp;action=nouveau&amp;news=' . $_GET['id'] . "\" title=\"" . $langue['nouveau_commentaire'] . "\"><img src=\"themes/" . $configuration['style'] . "/images/commentaire.png\" title=\"" . $langue['nouveau_commentaire'] . "\" alt=\"" . $langue['nouveau_commentaire'] . "\" /></a></p>\n";
                }
            }
        }
        // Affichage de la liste des news
        else
        {
            // Titre de la page
            $page_titre = $langue['liste_news'];
            $page_infos = $langue['liste_news'];

            $page_texte .= "<table>\n\n<thead>\n<tr>\n";
            $page_texte .= '  <th class="news_titre">' . $langue['titre'] . "</th>\n";
            $page_texte .= '  <th class="news_auteur">' . $langue['auteur'] . "</th>\n";
            $page_texte .= '  <th class="news_lectures">' . $langue['lectures'] . "</th>\n";
            $page_texte .= '  <th class="news_commentaires">' . $langue['commentaires'] . "</th>\n";
            $page_texte .= '  <th class="news_date">' . $langue['date'] . "</th>\n";
            $page_texte .= "</tr>\n</thead>\n\n<tbody>\n";

            $sql = "SELECT `news_id`,
                           `news_titre`,
                           `news_auteur`,
                           `news_lectures`,
                           `news_commentaires`,
                           `news_time`,
                           `membre_nom`";

            if ( $_SESSION['groupe'] != 1 )
            {
                $sql .= ", `news_last_commentaire`, `cv_message`";
            }

            $sql .= " FROM `" . $database->pref . "news`
                      LEFT JOIN `" . $database->pref . "membres`
                         ON `membre_id` = `news_auteur`";

            if ( $_SESSION['groupe'] != 1 )
            {
                $sql .= " LEFT JOIN `" . $database->pref . "commentaire_view`
                    ON `cv_referent` = `news_id`
                    AND `cv_type` = '1'
                    AND `cv_membre` = '" . $_SESSION['membre_id'] . "'";
            }

            $sql .= " ORDER BY `news_time` DESC";

            //=>MYSQL
            if ( SGBD == 'mysql' ) $sql .= ' LIMIT 0, ' . $configuration['news_page'];
            $sql .= ';';
            //=>END

            $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            if ( $database->NbrRowsSelected ( $req ) > 0 )
            {
                $sql_limite = 0;
            
                while ( $sql_limite < $configuration['news_page'] && $row = $database->ResultArray ( $req ) )
                {
                    $sql_limite++;

                    $page_texte .= "<tr>\n";
                    $page_texte .= '  <td>';

                    // Lien vers le dernier message lu si il y a des nouveaux messages
                    if ( $_SESSION['groupe'] != 1 && !empty ( $row['cv_message'] ) && $row['news_last_commentaire'] != $row['cv_message'] )
                    {
                        $page_texte .= '<a href="index.' . EXT . '?page=Commentaires&amp;id=' . $row['cv_message'] . '" title="Aller au dernier message lu"><img src="themes/' . $configuration['style'] . '/images/dernier_message_lu.png" alt="" title="Aller au dernier message lu" /></a> ';
                    }

                    $page_texte .= '<a href="index.' . EXT . '?page=News&amp;id=' . $row['news_id'] . '">' . $row['news_titre'] . "</a></td>\n";
                    $page_texte .= '  <td class="centre"><a href="index.' . EXT . '?page=Membre&amp;id=' . $row['news_auteur'] . "\" title=\"" . $langue['view_fiche'] . $row['membre_nom'] . '">' . $row['membre_nom'] . "</a></td>\n";
                    $page_texte .= '  <td class="centre">' . $row['news_lectures'] . "</td>\n";
                    $page_texte .= '  <td class="centre">' . $row['news_commentaires'] . "</td>\n";
                    $page_texte .= '  <td class="centre">' . date ( $configuration['format_date'] , $row['news_time'] ) . $langue['time_at'] . date ( $configuration['format_heure'] , $row['news_time'] ) . "</td>\n";
                    $page_texte .= "</tr>\n";
                }

                if ( $droit['news_edition'] == 1 )
                {
                    $page_texte .= "<tr>\n  <td colspan=\"5\"><a href=\"" . 'index.' . EXT . '?page=News&amp;action=nouvelle' . "\" title=\"" . $langue['news_new'] . '">' . $langue['news_new'] . "</a></td>\n</tr>\n";
                }
            }
            else
            {
                if ( $droit['news_edition'] == 1 )
                {
                    $page_texte .= "<tr>\n  <td colspan=\"5\"><a href=\"" . 'index.' . EXT . '?page=News&amp;action=nouvelle' . "\" title=\"" . $langue['news_new'] . '">' . $langue['news_new'] . "</a></td>\n</tr>\n";
                }
                else
                {
                    $page_texte .= "<tr>\n  <td colspan=\"5\">Il n'y a aucune news.</td>\n</tr>\n";
                }
            }

            $page_texte .= "</tbody>\n\n</table>";
        }

        break;

    // Rédiger une news
    case 'nouvelle':

        if ( $droit['news_edition'] == 0 )
        {
            header ( 'Location: index.' . EXT . '?page=News' );
            die ( -1 );
        }


        // Titre de la page
        $page_titre = $langue['news_new'];
        $page_infos = $langue['news_new'];


        $form_champ_titre = '';


        // Traitement des données du formulaire
        if ( isset ( $_POST['submit'] ) )
        {
            if ( empty ( $_POST['titre'] ) || empty ( $_POST['texte'] ) )
            {
                $page_texte .= '<p><strong>' . $langue['erreur'] . '</strong>&nbsp;: ' . $langue['err_oblig'] . "</p>\n\n";

                $form_champ_texte = $_POST['texte'];
                $form_champ_titre = $_POST['titre'];
            }
            else
            {

                $sql = "INSERT INTO `" . $database->pref . "news`
                        (`news_titre`, `news_texte`, `news_auteur`, `news_lectures`, `news_commentaires`, `news_time`)
                        VALUES
                        ('" . $_POST['titre'] . "', '" . $_POST['texte'] . "', '" . $_SESSION['membre_id'] . "', '0', '0', '" . $time . "');";

                $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                header ( 'Location: index.' . EXT . '?page=News&amp;id=' . $database->LastInsertId ( $req ) );
                die ( -1 );
            }
        }

        // Ouverture du formulaire
        $form_adresse = 'index.' . EXT . '?page=News&amp;action=nouvelle';
        $form_titre = 'Nouvelle news';
        $form_sujet = "\n<p class=\"form_input\"><label for=\"id_titre\">" . $langue['titre'] . "&nbsp;:</label> <input type=\"text\" id=\"id_titre\" name=\"titre\" size=\"60\" value=\"" . $form_champ_titre . "\" /></p>\n<br />\n";

        include ( 'systeme/form_message.' . EXT );

        break;

    // Modifier une news
    case 'editer':

        if ( !isset ( $_GET['id'] ) || !is_numeric ( $_GET['id'] ) )
        {
            header ( 'Location: index.' . EXT . '?page=News' );
            die ( -1 );
        }

        if ( $droit['news_edition'] == 0 )
        {
            header ( 'Location: index.' . EXT . '?page=News' );
            die ( -1 );
        }

        $sql = "SELECT `news_auteur`,
                       `news_texte`,
                       `news_titre`
                FROM `" . $database->pref . "news`
                WHERE `news_id` = '" . $_GET['id'] . "';";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        // On vérifie que la news existe
        if ( $database->NbrRowsSelected ( $req ) === 0 )
        {
            header ( 'Location: index.' . EXT . '?page=News' );
            die ( -1 );
        }

        $row = $database->ResultArray ( $req );

        if ( $_SESSION['groupe'] != 3 && ( $_SESSION['groupe'] != 1 && $row['news_auteur'] != $_SESSION['membre_id'] ) )
        {
            header ( 'Location: index.' . EXT . '?page=News' );
            die ( -1 );
        }


        // Titre de la page
        $page_titre = $langue['editer_news'];
        $page_infos = $langue['editer_news'];


        $form_champ_titre = $row['news_titre'];
        $form_champ_texte = $row['news_texte'];

        // Traitement des données du formulaire
        if ( isset ( $_POST['submit'] ) )
        {
            if ( empty ( $_POST['titre'] ) || empty ( $_POST['texte'] ) )
            {
                $page_texte .= '<p><strong>' . $langue['erreur'] . '</strong>&nbsp;: ' . $langue['err_oblig'] . "</p>\n\n";

                $form_champ_texte = $_POST['texte'];
                $form_champ_titre = $_POST['titre'];
            }
            else
            {
                $sql = "UPDATE `" . $database->pref . "news`
                        SET `news_titre` = '" . $_POST['titre'] . "',
                            `news_texte` = '" . $_POST['texte'] . "'
                        WHERE `news_id` = '" . $_GET['id'] . "';";

                $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                header ( 'Location: index.' . EXT . '?page=News&id=' . $_GET['id'] );
                die ( -1 );
            }
        }

        // Ouverture du formulaire
        $form_adresse = 'index.' . EXT . '?page=News&amp;action=editer&amp;id=' . $_GET['id'];
        $form_titre = $langue['editer_news'];
        $form_sujet = "\n<p class=\"form_input\"><label for=\"id_titre\">Titre&nbsp;:</label> <input type=\"text\" id=\"id_titre\" name=\"titre\" size=\"60\" value=\"" . $form_champ_titre . "\" maxlength=\"50\" /></p><br />\n";

        include ( 'systeme/form_message.' . EXT );

        break;

    // Supprimer une news
    case 'supprimer':

        if ( !isset ( $_GET['id'] ) || !is_numeric ( $_GET['id'] ) || $_GET['id'] <= 0 )
        {
            header ( 'Location: index.' . EXT . '?page=News' );
            die ( -1 );
        }

        if ( $droit['news_edition_auteur'] == 0 && $droit['news_edition'] == 0 )
        {
            header ( 'Location: index.' . EXT . '?page=News' );
            die ( -1 );
        }

        $sql = "SELECT `news_auteur`
                FROM `" . $database->pref . "news`
                WHERE `news_id` = '" . $_GET['id'] ."';";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        // On vérifie que la news existe
        if ( $database->NbrRowsSelected ( $req ) === 0 )
        {
            header ( 'Location: index.' . EXT . '?page=News' );
            die ( -1 );
        }

        $row = $database->ResultArray ( $req );

        if ( $droit['news_edition_auteur'] == 1 && $_SESSION['groupe'] != 1 && $row['news_auteur'] != $_SESSION['membre_id'] && $droit['news_edition'] == 0 )
        {
            header ( 'Location: index.' . EXT . '?page=News' );
            die ( -1 );
        }

        if ( isset ( $_GET['ok'] ) )
        {
            // On supprime la news
            $sql = "DELETE FROM `" . $database->pref . "news`
                    WHERE `news_id` = '" . $_GET['id'] . "';";

            $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            // On supprime les commentaires
            $sql = "DELETE FROM `" . $database->pref . "commentaires`
                    WHERE
                            `commentaire_reference` = '" . $_GET['id'] . "'
                        AND `commentaire_type` = '1';";

            $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            header ( 'Location: index.' . EXT . '?page=News' );
            die ( -1 );
        }


        // Titre de la page
        $page_titre = $langue['editer_news'];
        $page_infos = $langue['editer_news'];


        $page_texte .= '<p>La suppression d\'une news est irréversible. <a href="index.' . EXT . '?page=News&amp;action=supprimer&amp;id=' . $_GET['id'] . '&ok' . "\">Cliquez-ici</a> pour supprimer cette news et les commentaires associés.</p>\n\n";

        break;
}

?>