<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /pages/Plan_du_site.php
 *  Date de création : 23/08/2007
 *  Dernière modification : 09/09/2007
 ***************************************************************************/

// Sécurité
if ( !defined ( 'TAGADASH' ) )
{
    header ( 'Location: ../' );
    die ( -1 );
}

$page_titre = 'Plan du site';
$page_infos = 'Plan du site';

$page_texte .= "<ul>\n";
$page_texte .= '  <li><a href="index.' . EXT . "\">Accueil</a></li>\n<br />\n";
$page_texte .= '  <li><a href="index.' . EXT . "?page=Plan_du_site\">Plan du site</a></li>\n";
$page_texte .= '  <li><a href="index.' . EXT . "?page=Equipe\">Équipe du site</a></li>\n";
$page_texte .= '  <li><a href="index.' . EXT . "?page=Contact\">Contactez-nous</a></li>\n<br />\n";
$page_texte .= '  <li><a href="index.' . EXT . "?page=News\">News</a></li>\n";
$page_texte .= '  <li><a href="index.' . EXT . "?page=Liste_des_fichiers\">Liste des fichiers</a></li>\n";
$page_texte .= '  <li><a href="index.' . EXT . "?page=Sondages\">Sondages</a></li>\n<br />\n";

if ( $droit['article_edition_auteur'] == 1 || $droit['article_edition'] == 1 )
{
    $page_texte .= '  <li><a href="index.' . EXT . "?page=Ajouter_un_article\">Nouvel article</a></li>\n";
}

$page_texte .= '  <li><a href="index.' . EXT . "?page=Liste_des_articles\">Articles</a>\n  <ul>\n";

// Liste des catégories
$categorie = 0;
$go_here = false;
$affiche_ul = false;

$sql = "SELECT cata.`cat_id` AS `categorie_id`,
               cata.`cat_nom` AS `categorie_nom`,
               catb.`cat_id` AS `sous_categorie_id`,
               catb.`cat_nom` AS `sous_categorie_nom`
        FROM `" . $database->pref . "article_cat` cata
        LEFT JOIN `" . $database->pref . "article_cat` catb
            ON catb.`cat_categorie` = cata.`cat_id`
        WHERE cata.`cat_categorie` = '0'
        ORDER BY
            cata.`cat_nom` ASC,
            catb.`cat_nom` ASC;";

$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

while ( $row = $database->ResultArray ( $req ) )
{
    if ( $row['categorie_id'] != $categorie )
    {
        if ( $affiche_ul ) $page_texte .= "  </ul>\n";
        if ( $go_here ) $page_texte .= "</li>\n";
        $page_texte .= '    <li><a href="index.' . EXT . "?page=Liste_des_articles&amp;categorie=" . $row['categorie_id'] . "\">" . $row['categorie_nom'] . '</a>';

        $categorie = $row['categorie_id'];
        $affiche_ul = false;
    }

    $go_here = true;

    if ( !empty ( $row['sous_categorie_id'] ) )
    {
        if ( !$affiche_ul ) $page_texte .= "\n    <ul>\n";
        $affiche_ul = true;

        $page_texte .= '      <li><a href="index.' . EXT . "?page=Liste_des_articles&amp;categorie=" . $row['sous_categorie_id'] . "\">" . $row['sous_categorie_nom'] . "</a></li>\n";
    }
}

if ( $affiche_ul ) $page_texte .= "    </ul>\n    </li>\n";

$page_texte .= "  </ul>\n  </li>\n<br/>\n";

// Liste des forums
$page_texte .= '  <li><a href="index.' . EXT . "?page=Forums\">Forums</a>\n  <ul>\n";

$categorie = 0;
$go_here = false;

$sql = "SELECT `forum_cat_nom`,
               `forum_cat_id`,
               `forum_nom`,
               `forum_id`
        FROM `" . $database->pref . "forum_forum`
        LEFT JOIN `" . $database->pref . "forum_cat`
            ON `forum_cat_id` = `forum_categorie`
        ORDER BY
            `forum_cat_ordre` ASC,
            `forum_ordre` ASC;";

$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

while ( $row = $database->ResultArray ( $req ) )
{
    if ( $row['forum_cat_id'] != $categorie )
    {
        if ( $go_here ) $page_texte .= "    </ul>\n    </li>\n";
        $page_texte .= "    <li><a href=\"index." . EXT . "?page=Forums&amp;cat=" . $row['forum_cat_id'] . "\">" . $row['forum_cat_nom'] . "</a>\n    <ul>\n";

        $categorie = $row['forum_cat_id'];
    }

    $go_here = true;

    $page_texte .= "      <li><a href=\"index." . EXT . "?page=Forums&amp;id=" . $row['forum_id'] . "\">" . $row['forum_nom'] . "</a></li>\n";
}

if ( $go_here ) $page_texte .= "    </ul>\n    </li>\n";

$page_texte .= "  </ul>\n  </li>\n<br/>\n";

$page_texte .= '  <li><a href="index.' . EXT . "?page=Liste_des_membres\">Membres du site</a></li>\n";
$page_texte .= '  <li><a href="index.' . EXT . "?page=Visiteurs\">Visiteurs du site</a></li>\n";

if ( $_SESSION['groupe'] != 1 )
{
    $page_texte .= '  <li><a href="index.' . EXT . "?page=Preferences\">Modifier vos préférences</a></li>\n";
    $page_texte .= '  <li><a href="index.' . EXT . "?page=Deconnexion\">Déconnexion</a></li>\n";
    $page_texte .= '  <li><a href="index.' . EXT . "?page=Amis\">Vos amis</a></li>\n";
    $page_texte .= '  <li><a href="index.' . EXT . "?page=Messagerie\">Vos messages</a></li>\n";
    $page_texte .= '  <li><a href="index.' . EXT . "?page=Liste_des_fichiers&membre=" . $_SESSION['membre_id'] . "\">Liste des fichiers que vous avez envoyés</a></li>\n";
}
else
{
    $page_texte .= '  <li><a href="index.' . EXT . "?page=Connexion\">Connexion</a></li>\n";
    $page_texte .= '  <li><a href="index.' . EXT . "?page=Inscription\">Inscription</a></li>\n";
}

$page_texte .= "</ul>\n\n";

?>