<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /pages/Preferences.php
 *  Date de création : avant le 13/08/2007
 *  Dernière modification : 14/09/2007
 ***************************************************************************/

// Sécurité
if ( !defined ( 'TAGADASH' ) )
{
    header ( 'Location: ../' );
    die ( -1 );
}


if ( $_SESSION['groupe'] == 1 )
{
    header ( 'Location: index.' . EXT );
    die ( -1 );
}


if ( isset ( $_GET['id'] ) && $_SESSION['groupe'] == 3 )
{
    $sql = "SELECT `membre_nom`,
                   `membre_groupe`
            FROM `" . $database->pref . "membres`
            WHERE `membre_id` = '" . $_GET['id'] . "';";

    $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

    if ( $database->NbrRowsSelected ( $req ) === 0 )
    {
        header ( 'Location: index.' . EXT . '?page=Membre' );
        die ( -1 );
    }

    $row = $database->ResultArray ( $req );

    $member_id = $_GET['id'];
    $membre_nom = $row['membre_nom'];
    $membre_groupe = $row['membre_groupe'];
}


// Traitement des données du formulaire
if ( isset ( $_POST['submit'] ) )
{
    if ( isset ( $_GET['id'] ) && $_SESSION['groupe'] == 3 )
    {
        $sql = "SELECT `membre_nom`
                FROM `" . $database->pref . "membres`
                WHERE `membre_id` = '" . $_GET['id'] . "';";

        $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        $member_id = $_GET['id'];
        $membre_nom = $database->Result ( $req , 'membre_nom' );
        $membre_groupe = $_POST['groupe'];
    }
    else
    {
        $membre_nom = $_SESSION['membre'];
        $member_id = $_SESSION['membre_id'];
        $membre_groupe = $_SESSION['groupe'];

        // Vérification des mots de passe
        if ( !empty ( $_POST['mdp0'] ) && !empty ( $_POST['mdp1'] ) && !empty ( $_POST['mdp2'] ) )
        {
            $sql = "SELECT `membre_id`
                    FROM `" . $database->pref . "membres`
                    WHERE
                            `membre_mdp` = '" . md5 ( $_POST['mdp0'] ) . "'
                        AND `membre_nom` = '" . $membre_nom . "'
                        AND `membre_id` = '" . $member_id . "';";

            $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            // L'ancien mot de passe est incorrect
            if ( $database->NbrRowsSelected ( $req ) === 0 )
            {
                $page_texte .= '<p><strong>' . $langue['erreur'] . '</strong> : ' . $langue['err_mdp_old'] . "</p>\n\n";
            }
            // Les mots de passe sont différents
            else if ( $_POST['mdp1'] != $_POST['mdp2'] )
            {
                $page_texte .= '<p><strong>' . $langue['erreur'] . '</strong> : ' . $langue['err_mdp'] . "</p>\n\n";
            }
            // Vérification de la longueur du mot de passe
            else if ( strlen ( $_POST['mdp1'] ) < 6 || strlen ( $_POST['mdp1'] ) > 16 )
            {
                $page_texte .= '<p><strong>' . $langue['erreur'] . '</strong> : ' . $langue['err_mdp_size'] . "</p>\n\n";
            }
            else
            {

                $sql = "UPDATE `" . $database->pref . "membres`
                        SET `membre_mdp`=  '" . md5 ( $_POST['mdp1'] ) . "'
                        WHERE
                                `membre_nom` = '" . $membre_nom . "'
                            AND `membre_id` = '" . $member_id . "';";

                $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

                // Actualisation du cookie au cas où le membre veut qu'on se souvienne de lui (sinon, le cookie est supprimé dès l'affichage d'une nouvelle page)
                setcookie ( 'membre_mdp' , md5 ( $_POST['mdp1'] ) , $time + 31536000 );
            }
        }
    }

    if ( empty ( $_POST['email'] ) )
    {
        $page_texte .= '<p><strong>' . $langue['erreur'] . '</strong>&nbsp;: ' . $langue['err_oblig'] . "</p>\n\n";
    }
    // Vérification de l'adresse e-mail
    else if ( !preg_match ( "#([a-z0-9._-]+@[a-z0-9._-]{2,}\.[a-z]{2,4})#U" , $_POST['email'] ) )
    {
        $page_texte .= '<p><strong>' . $langue['erreur'] . '</strong>&nbsp;: ' . $langue['err_email_format'] . "</p>\n\n";
    }
    else
    {
        // On met à jour l'image contenant l'adresse e-mail
        $site->CreateImageEmail ( $member_id , $_POST['email'] );

        if ( !empty ( $_POST['avatar'] ) )
        {
            $avatar_nom = preg_replace ( "#^(.+)\.(.+)$#" , "$1" , $_POST['avatar'] );
            $avatar_ext = preg_replace ( "#^(.+)\.(.+)$#" , "$2" , $_POST['avatar'] );

            // On tente de créer une miniature de 100px pour l'avatar
            $site->CreateMiniature ( $avatar_nom , $avatar_ext , 100 );
        }

        $membre_style = ( empty ( $_POST['style'] ) ) ? 'Chuwiki' : $_POST['style'];
        $membre_langue = ( empty ( $_POST['langue'] ) ) ? 'fr' : $_POST['langue'];
        $afficher_email = ( isset ( $_POST['afficher_email'] ) ) ? 1 : 0;
        $mail_pm = ( isset ( $_POST['mail_pm'] ) ) ? 1 : 0;
        $mail_fav = ( isset ( $_POST['mail_fav'] ) ) ? 1 : 0;

        if ( preg_match ( "#^([0-9]{1,2})/([0-9]{1,2})/([0-9]{4})$#is" , $_POST['anniversaire'] ) )
        {
            $anniversaire = preg_replace ( "#^([0-9]{1,2})/([0-9]{1,2})/([0-9]{4})$#U" , "$3-$2-$1" , $_POST['anniversaire'] );
        }
        else
        {
            $anniversaire = '0000-00-00';
        }

        // Mise-à-jour des informations de ce membre
        $sql = "UPDATE `" . $database->pref . "membres`
                SET `membre_email` = '" . $_POST['email'] . "',
                    `membre_messagerie` = '" . $_POST['messagerie'] . "',
                    `membre_anniversaire` = '" . $anniversaire . "',
                    `membre_site` = '" . $_POST['site'] . "',
                    `membre_afficher_email` = '" . $afficher_email . "',
                    `membre_avatar` = '" . $_POST['avatar'] . "',
                    `membre_profession` = '" . $_POST['profession'] . "',
                    `membre_signature` = '" . $_POST['signature'] . "',
                    `membre_localisation` = '" . $_POST['localisation'] . "',
                    `membre_style` = '" . $membre_style . "',
                    `membre_langue` = '" . $membre_langue . "',
                    `membre_groupe` = '" . $membre_groupe . "',
                    `membre_mail_pm` = '" . $mail_pm . "',
                    `membre_mail_fav` = '" . $mail_fav . "'
                WHERE
                        `membre_nom` = '" . $membre_nom . "'
                    AND `membre_id` = '" . $member_id . "';";

        $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        if ( isset ( $_GET['id'] ) )
        {
            header ( 'Location: index.' . EXT . '?page=Preferences&id=' . $_GET['id'] );
        }
        else
        {
            header ( 'Location: index.' . EXT . '?page=Preferences' );
        }

        die ( -1 );
    }
}

// Titre de la page
$page_titre = $langue['prefs'];
$page_infos = $langue['prefs'];


if ( $droit['administration'] == 1 && isset ( $_GET['id'] ) && is_numeric ( $_GET['id'] ) && $_GET['id'] > 0 )
{
    $sql = "SELECT `membre_anniversaire`,
                   `membre_nom`,
                   `membre_email`,
                   `membre_afficher_email`,
                   `membre_groupe`,
                   `membre_langue`,
                   `membre_style`,
                   `membre_localisation`,
                   `membre_profession`,
                   `membre_messagerie`,
                   `membre_site`,
                   `membre_avatar`,
                   `membre_signature`,
                   `membre_mail_pm`,
                   `membre_mail_fav`
            FROM `" . $database->pref . "membres`
            WHERE `membre_id` = '" . $_GET['id'] . "';";

    $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

    if ( $database->NbrRowsSelected ( $req ) === 0 )
    {
        header ( 'Location: index.' . EXT . '?page=Liste_des_membres' );
        die ( -1 );
    }

    $row = $database->ResultArray ( $req );

    $anniversaire = '';

    if ( preg_match ( "#^([0-9]{4})-([0-9]{2})-([0-9]{2})$#isU" , $row['membre_anniversaire'] ) )
    {
        $anniversaire = preg_replace ( "#^([0-9]{4})-([0-9]{2})-([0-9]{2})$#isU" , "$3/$2/$1" , $row['membre_anniversaire'] );
        
        if ( $anniversaire == '00/00/0000' ) $anniversaire = '';
    }

    $page_texte .= "\n<noscript>\n<p><strong>" . $langue['attention'] . "</strong>&nbsp;: Vous n'avez pas activé JavaScript, vous devez donc <a href=\"" . 'images.' . EXT . "\" target=\"_blank\">cliquez ici</a> pour rechercher un avatar parmi les images que vous avez envoyées.</p>\n</noscript>\n\n";
    $page_texte .= '<form action="index.' . EXT . '?page=Preferences&amp;id=' . $_GET['id'] . '" title="' . $langue['prefs'] . "\" method=\"post\">\n\n";

    $page_texte .= "<fieldset>\n<legend>Paramètres</legend>\n\n";
    $page_texte .= "<label class=\"form_label\" for=\"id_utilisateur\">" . $langue['user'] . "&nbsp;:</label><input type=\"text\" size=\"30\" name=\"utilisateur\" id=\"id_utilisateur\" value=\"" . $row['membre_nom'] . "\" /><br/>\n";
    $page_texte .= "<label class=\"form_label\" for=\"id_email\">" . $langue['email'] . "&nbsp;:</label><input type=\"text\" size=\"30\" name=\"email\" id=\"id_email\" value=\"" . $row['membre_email'] . "\" /> <small>Champ obligatoire</small><br/>\n";
    $page_texte .= "<input type=\"checkbox\" name=\"afficher_email\" id=\"id_afficher_email\"";
    if ( $row['membre_afficher_email'] == 1 ) $page_texte .= ' checked="checked"';
    $page_texte .= "> <label for=\"id_afficher_email\">Rendre visible cette adresse aux autres membres du site</label><br/>";

    // Groupe
    $page_texte .= "<label class=\"form_label\" for=\"id_groupe\">" . $langue['groupe'] . "&nbsp;:</label><select name=\"groupe\" id=\"id_groupe\">\n";

    $sql = "SELECT `groupe_nom`,
                   `groupe_id`
            FROM `" . $database->pref . "groupes`
            WHERE
                    `groupe_id` <> '1'
                AND `groupe_id` <> '3'
            ORDER BY `groupe_nom` ASC;";

    $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

    while ( $row2 = $database->ResultArray ( $req ) )
    {
        $page_texte .= '  <option value="' . $row2['groupe_id'] . '"';
        if ( $row['membre_groupe'] == $row2['groupe_id'] ) $page_texte .= ' selected="selected"';
        $page_texte .= '>' . $row2['groupe_nom'] . "</option>\n";
    }

    $page_texte .= "</select><br/>\n";

    // Langues
    $page_texte .= "<label class=\"form_label\" for=\"id_langue\">" . $langue['langue'] . "&nbsp;:</label><select name=\"langue\" id=\"id_langue\">\n";
    $page_texte .= $site->FormSelect ( $langues , $row['membre_langue'] );
    $page_texte .= "</select><br/>\n";

    // Styles
    $page_texte .= "<label class=\"form_label\" for=\"id_style\">" . $langue['style'] . "&nbsp;:</label><select name=\"style\" id=\"id_style\">\n";
    $page_texte .= $site->FormSelect ( $themes , $row['membre_style'] );
    $page_texte .= "</select><br/>\n";

    $page_texte .= "</fieldset>\n\n";

    $page_texte .= "<fieldset>\n<legend>Informations</legend>\n\n";
    $page_texte .= "<label class=\"form_label\" for=\"id_localisation\">" . $langue['localisation'] . "&nbsp;:</label><input type=\"text\" size=\"30\" name=\"localisation\" id=\"id_localisation\" value=\"" . $row['membre_localisation'] . "\" /><br/>\n";
    $page_texte .= "<label class=\"form_label\" for=\"id_profession\">Profession :</label><input type=\"text\" size=\"30\" name=\"profession\" id=\"id_profession\" value=\"" . $row['membre_profession'] . "\" /><br/>\n";
    $page_texte .= "<label class=\"form_label\" for=\"id_messagerie\">Adresse de messagerie&nbsp;:</label><input type=\"text\" size=\"30\" name=\"messagerie\" id=\"id_messagerie\" value=\"" . $row['membre_messagerie'] . "\" /><br />\n";
    $page_texte .= "<label class=\"form_label\" for=\"id_site\">Site Internet&nbsp;:</label><input type=\"text\" size=\"30\" name=\"site\" id=\"id_site\" value=\"" . $row['membre_site'] . "\" /><br/>\n";
    $page_texte .= "<label class=\"form_label\" for=\"id_anniversaire\">Date d'anniversaire&nbsp;:</label><input type=\"text\" size=\"30\" name=\"anniversaire\" id=\"id_anniversaire\" value=\"" . $anniversaire . "\" /> <small>Format de la date&nbsp;: jj/mm/aaaa</small><br/>\n";
    $page_texte .= "<label class=\"form_label\" for=\"id_avatar\">" . $langue['avatar'] . "&nbsp;:</label><input type=\"text\" size=\"30\" name=\"avatar\" id=\"id_avatar\" value=\"" . $row['membre_avatar'] . "\" />\n";
    $page_texte .= "<input type=\"button\" onclick=\"javascript:window.parent.ChercherImage(); return false;\" value=\"" . $langue['avatar_search'] . "\" /><br/>\n";
    $page_texte .= "<p class=\"form_input\"><label class=\"form_label\" for=\"id_signature\">" . $langue['signature'] . "&nbsp;:</label></p>\n";
    $page_texte .= "<textarea rows=\"3\" cols=\"40\" name=\"signature\" id=\"id_signature\">" . $row['membre_signature'] . "</textarea>\n";
    $page_texte .= "<p class=\"form_input\"><input type=\"checkbox\" name=\"mail_pm\" id=\"id_mail_pm\"";
    if ( $row['membre_mail_pm'] == 1 ) $page_texte .= ' checked="checked"';
    $page_texte .= "> <label for=\"id_mail_pm\">Être averti par e-mail des messages privés reçus.</label></p>\n";
    $page_texte .= "<p class=\"form_input\"><input type=\"checkbox\" name=\"mail_fav\" id=\"id_mail_fav\"";
    if ( $row['membre_mail_fav'] == 1 ) $page_texte .= ' checked="checked"';
    $page_texte .= "> <label for=\"id_mail_fav\">Être averti par e-mail des nouveaux messages postés dans un forum favori.</label></p>\n";

    $page_texte .= "</fieldset>\n\n";

    $page_texte .= "<p class=\"centre\"><input type=\"submit\" name=\"submit\" value=\"" . $langue['valider'] . "\" /></p>\n\n</form>\n";
}
else
{
    $sql = "SELECT `membre_anniversaire`,
                   `membre_email`,
                   `membre_afficher_email`,
                   `membre_langue`,
                   `membre_style`,
                   `membre_localisation`,
                   `membre_profession`,
                   `membre_messagerie`,
                   `membre_site`,
                   `membre_avatar`,
                   `membre_signature`,
                   `membre_mail_pm`,
                   `membre_mail_fav`
            FROM `" . $database->pref . "membres`
            WHERE `membre_id` = '" . $_SESSION['membre_id'] . "';";

    $req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

    $row = $database->ResultArray ( $req );

    $anniversaire = '';

    if ( preg_match ( "#^([0-9]{4})-([0-9]{2})-([0-9]{2})$#is" , $row['membre_anniversaire'] ) )
    {
        $anniversaire = preg_replace ( "#^([0-9]{4})-([0-9]{2})-([0-9]{2})$#isu" , "$3/$2/$1" , $row['membre_anniversaire'] );
        
        if ( $anniversaire == '00/00/0000' ) $anniversaire = '';
    }

    $page_texte .= "\n<noscript>\n<p><strong>" . $langue['attention'] . "</strong>&nbsp;: Vous n'avez pas activé JavaScript, vous devez donc <a href=\"images." . EXT . "\" target=\"_blank\">cliquez-ici</a> pour rechercher un avatar parmi les images que vous avez envoyées.</p>\n</noscript>\n\n";
    $page_texte .= '<form action="index.' . EXT . '?page=Preferences" title="' . $langue['prefs'] . "\" method=\"post\">\n\n";

    $page_texte .= "<fieldset>\n<legend>Paramètres</legend>\n\n";
    $page_texte .= "<p class=\"form_input\"><label class=\"form_label\" for=\"id_utilisateur\">" . $langue['user'] . "&nbsp;:</label><input type=\"text\" size=\"30\" maxlength=\"20\" disabled=\"disabled\" name=\"utilisateur\" id=\"id_utilisateur\" value=\"" . $_SESSION['membre'] . "\" /></p>\n";
    $page_texte .= "<p class=\"form_input\"><label class=\"form_label\" for=\"id_email\">" . $langue['email'] . "&nbsp;:</label><input type=\"text\" size=\"30\" name=\"email\" id=\"id_email\" value=\"" . $row['membre_email'] . "\" /> <small>Champ obligatoire</small></p>\n";
    $page_texte .= "<p class=\"form_input\"><input type=\"checkbox\" name=\"afficher_email\" id=\"id_afficher_email\"";
    if ( $row['membre_afficher_email'] == 1 ) $page_texte .= ' checked="checked"';
    $page_texte .= "> <label for=\"id_afficher_email\">Rendre visible cette adresse aux autres membres du site.</label></p>\n";

    // Langues
    $page_texte .= "<p class=\"form_input\"><label class=\"form_label\" for=\"id_langue\">" . $langue['langue'] . "&nbsp;:</label><select name=\"langue\" id=\"id_langue\">\n";
    $page_texte .= $site->FormSelect ( $langues , $row['membre_langue'] );
    $page_texte .= "</select></p>\n";

    // Styles
    $page_texte .= "<p class=\"form_input\"><label class=\"form_label\" for=\"id_style\">" . $langue['style'] . "&nbsp;:</label><select name=\"style\" id=\"id_style\">\n";
    $page_texte .= $site->FormSelect ( $themes , $row['membre_style'] );
    $page_texte .= "</select></p>\n";

    $page_texte .= "</fieldset>\n\n";

    $page_texte .= "<fieldset>\n<legend>Informations</legend>\n\n";
    $page_texte .= "<p class=\"form_input\"><label class=\"form_label\" for=\"id_localisation\">" . $langue['localisation'] . "&nbsp;:</label><input type=\"text\" size=\"30\" name=\"localisation\" id=\"id_localisation\" value=\"" . $row['membre_localisation'] . "\" /></p>\n";
    $page_texte .= "<p class=\"form_input\"><label class=\"form_label\" for=\"id_profession\">Profession :</label><input type=\"text\" size=\"30\" name=\"profession\" id=\"id_profession\" value=\"" . $row['membre_profession'] . "\" /></p>\n";
    $page_texte .= "<p class=\"form_input\"><label class=\"form_label\" for=\"id_messagerie\">Adresse de messagerie&nbsp;:</label><input type=\"text\" size=\"30\" name=\"messagerie\" id=\"id_messagerie\" value=\"" . $row['membre_messagerie'] . "\" /></p>\n";
    $page_texte .= "<p class=\"form_input\"><label class=\"form_label\" for=\"id_site\">Site Internet&nbsp;:</label><input type=\"text\" size=\"30\" name=\"site\" id=\"id_site\" value=\"" . $row['membre_site'] . "\" /></p>\n";
    $page_texte .= "<p class=\"form_input\"><label class=\"form_label\" for=\"id_anniversaire\">Date d'anniversaire&nbsp;:</label><input type=\"text\" size=\"30\" name=\"anniversaire\" id=\"id_anniversaire\" value=\"" . $anniversaire . "\" /> <small>Format de la date&nbsp;: jj/mm/aaaa</small></p>\n";
    $page_texte .= "<p class=\"form_input\"><label class=\"form_label\" for=\"id_avatar\">" . $langue['avatar'] . "&nbsp;:</label><input type=\"text\" size=\"30\" maxlength=\"14\" name=\"avatar\" id=\"id_avatar\" value=\"" . $row['membre_avatar'] . "\" />\n";
    $page_texte .= "<input type=\"button\" onclick=\"javascript:window.parent.ChercherImage(); return false;\" value=\"" . $langue['avatar_search'] . "\" /></p>\n";
    $page_texte .= "<p class=\"form_input\"><label class=\"form_label\" for=\"id_signature\">" . $langue['signature'] . "&nbsp;:</label></p>\n";
    $page_texte .= "<textarea rows=\"3\" cols=\"40\" name=\"signature\" id=\"id_signature\">" . $row['membre_signature'] . "</textarea>\n";
    $page_texte .= "<p class=\"form_input\"><label class=\"form_label\" for=\"id_decalage\">Décalage horaire&nbsp;:</label><input type=\"text\" size=\"30\" name=\"decalage\" id=\"id_decalage\" maxlength=\"9\" value=\"\" /> <small>Format de l'heure&nbsp;: ± hh:mm:ss</small></p>\n";
    $page_texte .= "<p class=\"form_input\">\n<a href=\"#\" onclick=\"javascript:decalage(" . ( 3600 * date ( 'H' ) + 60 * date ( 'i' ) + date ( 's' ) ) . ");\">Calculer le décalage horaire</a></p>\n";
    $page_texte .= "<p class=\"form_input\"><input type=\"checkbox\" name=\"mail_pm\" id=\"id_mail_pm\"";
    if ( $row['membre_mail_pm'] == 1 ) $page_texte .= ' checked="checked"';
    $page_texte .= "> <label for=\"id_mail_pm\">Être averti par e-mail des messages privés reçus.</label></p>\n";
    $page_texte .= "<p class=\"form_input\"><input type=\"checkbox\" name=\"mail_fav\" id=\"id_mail_fav\"";
    if ( $row['membre_mail_fav'] == 1 ) $page_texte .= ' checked="checked"';
    $page_texte .= "> <label for=\"id_mail_fav\">Être averti par e-mail des nouveaux messages postés dans un forum favori.</label></p>\n";

    $page_texte .= "</fieldset>\n\n";

    // Mot de passe
    $page_texte .= "<fieldset>\n<legend>" . $langue['password'] . "</legend>\n\n";
    $page_texte .= "<p class=\"form_input\"><label class=\"form_label\" for=\"id_mdp0\">" . $langue['oldpass'] . "&nbsp;:</label><input type=\"password\" name=\"mdp0\" id=\"id_mdp0\" value=\"\" /> <small>Ne remplissez ces champs que si vous désirez changer de mot de passe</small></p>\n";
    $page_texte .= "<p class=\"form_input\"><label class=\"form_label\" for=\"id_mdp1\">" . $langue['newpass'] . "&nbsp;:</label><input type=\"password\" name=\"mdp1\" id=\"id_mdp1\" value=\"\" /></p>\n";
    $page_texte .= "<p class=\"form_input\"><label class=\"form_label\" for=\"id_mdp2\">" . $langue['confirm'] . "&nbsp;:</label><input type=\"password\" name=\"mdp2\" id=\"id_mdp2\" value=\"\" /></p>\n\n";
    $page_texte .= "</fieldset>\n\n";

    $page_texte .= "<p class=\"centre\"><input type=\"submit\" name=\"submit\" accesskey=\"s\" value=\"" . $langue['valider'] . "\" /></p>\n\n</form>\n";
}

?>