<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /pages/Statistiques.php
 *  Date de création : avant le 13/08/2007
 *  Dernière modification : 12/09/2007
 ***************************************************************************/

// Sécurité
if ( !defined ( 'TAGADASH' ) )
{
    header ( 'Location: ../' );
    die ( -1 );
}


if ( $_SESSION['groupe'] != 3 )
{
    header ( 'Location: index.' . EXT );
    die ( -1 );
}


// Titre de la page
$page_titre = $langue['statistiques'];
$page_infos = $langue['administration_texte'];


/*******************************
 * Quelques chiffres
 ******************************/

$sql = "SELECT COUNT(*) AS `count`
        FROM `" . $database->pref . "visiteurs`;";

$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

$nbr_ip = $database->Result ( $req , 'count' );


$sql = "SELECT COUNT(*) AS `count`,
               SUM(`stat_hit`) AS `pages_vues`
        FROM `" . $database->pref . "stat`;";

$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

$row = $database->ResultArray ( $req );

$nbr_stats = $row['count'];
$nbr_pages_vues = $row['pages_vues'];

// Nombre de visites au total et journée record
$nbr_visites = 0;
$jour_record_nbr = 0;
$jour_record_mois_nbr = 0;

/*
// Nombre de jour du mois en cours
$nbr_jour = date ( 't' );

for ( $i = 1 ; $i <= $nbr_jour ; $i++ )
{
    $jour[$i] = 0;
}


$sql = "SELECT `stat_visiteurs`,
               `stat_jour`,
               `stat_mois`,
               `stat_annee`
        FROM `" . $database->pref . "stat_jours`;";

$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


while ( $row = $database->ResultArray ( $req ) )
{
    // Journée record
    if ( $jour_record_nbr < $row['stat_visiteurs'] )
    {
        $jour_record_nbr = $row['stat_visiteurs'];

        $row_jour = ( $row['stat_jour'] < 10 ) ? '0' . $row['stat_jour'] : $row['stat_jour'];
        $row_mois = ( $row['stat_mois'] < 10 ) ? '0' . $row['stat_mois'] : $row['stat_mois'];

        $jour_record = $row_jour . '/' . $row_mois . '/' . $row['stat_annee'];
    }

    // Journée record du mois
    if ( $row['stat_mois'] == date ( 'n' ) && $row['stat_annee'] == date ( 'Y' ) && $jour_record_mois_nbr < $row['stat_visiteurs'] )
    {
        $jour_record_mois_nbr = $row['stat_visiteurs'];
    }

    $nbr_visites += $row['stat_visiteurs'];

    if ( $row['stat_jour'] == date ( 'j' ) && $row['stat_mois'] == date ( 'n' ) && $row['stat_annee'] == date ( 'Y' ) )
    {
        $nbr_visites_today = $row['stat_visiteurs'];
    }

    if ( $row['stat_mois'] == date ( 'n' ) && $row['stat_annee'] == date ( 'Y' ) )
    {
        $jour[$row['stat_jour']] = $row['stat_visiteurs'];
    }
}
*/
$page_texte .= "<h2>Quelques chiffres</h2>\n\n<ul>\n";
$page_texte .= '  <li>Visiteurs uniques&nbsp;: <strong>' . $nbr_ip . "</strong></li>\n";
$page_texte .= '  <li>Pages vues&nbsp;: <strong>' . $nbr_pages_vues . "</strong></li>\n";
/*
$page_texte .= '  <li>Nombre de visites au total&nbsp;: <strong>' . $nbr_visites . "</strong></li>\n";
$page_texte .= '  <li>Nombre de visites aujourd\'hui&nbsp;: <strong>' . $nbr_visites_today .  "</strong></li>\n";
$page_texte .= '  <li>Journée record&nbsp;: ' . $jour_record . ' (' . $jour_record_nbr . " visites)</li>\n";
*/
$page_texte .= "</ul>\n\n";


/*******************************
 * Nombre de visites pour chaque jour du mois
 ******************************/

$page_texte .= "<h2>Statistiques du mois en cours</h2>\n\n";
/*
$image = ImageCreate ( $nbr_jour * 20 + 10 , 220 );

// Couleurs de l'image
$couleur_blanc = ImageColorAllocate ( $image , 255 , 255 , 255 );
$couleur_noir = ImageColorAllocate ( $image , 0 , 0 , 0 );
$couleur_orange = ImageColorAllocate ( $image , 255 , 210 , 130 );


ImageLine ( $image , 5 , 200 , 5 , 205, $couleur_noir );
ImageLine ( $image , 5 , 200 , $nbr_jour * 20 + 5 , 200 , $couleur_noir );

// Titre du graphique
ImageString ( $image , 5 , $nbr_jour * 10 + 25 - ImageFontWidth ( 5 ) * strlen ( 'Statistiques du mois de ' . $langue['mois_' . date ( 'm' ) ] . ' ' . date ( 'Y' ) ) / 2 , 0 , 'Statistiques du mois de ' . $langue['mois_' . date ( 'm' ) ] . ' ' . date ( 'Y' ) , $couleur_noir );


// Hauteur en pixels d'un visiteur sur une barre
$hauteur_par_visiteur = 150 / $jour_record_mois_nbr;


// Nombre de visites pour chaque jour
for ( $i = 0 ; list ( $day , $nbr ) = each ( $jour ) ; $i++ )
{
    $position = 20 * $i + 5;

    // Numéro du jour
    ImageString ( $image , 3 , $position + 10 - ImageFontWidth ( 3 ) * strlen ( $day ) / 2 , 205 , $day , $couleur_noir );

    // Barre de l'histogramme
    ImageFilledRectangle ( $image , $position + 1 , 199 - $hauteur_par_visiteur * $nbr , $position + 19 , 199 , $couleur_orange );

    // Nombre de visiteurs
    if ( $nbr != 0 ) ImageString ( $image , 2 , $position + 10 - ImageFontWidth ( 2 ) * strlen ( $nbr ) / 2 , 199 - $hauteur_par_visiteur * $nbr - ImageFontHeight ( 2 ) , $nbr , $couleur_noir );

    // Petite ligne en bas pour séparer les jours
    ImageLine ( $image , $position + 20 , 200 , $position + 20 , 205 , $couleur_noir );
}

ImageColorTransparent ( $image , $couleur_blanc );
ImagePNG ( $image , 'fichiers/stats/' . date ( 'Y-m' ) . '.png' );

$page_texte .= "<p class=\"centre\"><img src=\"fichiers/stats/" . date ( 'Y-m' ) . ".png\" alt=\"\" title=\"Statistiques du mois de " . $langue['mois_' . date ( 'm' ) ] . " " . date ( 'Y' ) . "\" /></p>\n\n";
*/

// Nombre de jour du mois en cours
$nbr_jour = date ( 't' );

for ( $i = 1 ; $i <= $nbr_jour ; $i++ )
{
    $visite_month[$i] = 0;
}

$mois = date ( 'm-Y' );


// Attention : cette requêt n'est valable qu'avec MySQL
$sql = "SELECT FROM_UNIXTIME(`stat_time`,'%e') AS `stat_jour`,
               COUNT(DISTINCT(`stat_ip`)) AS `count`
        FROM `" . $database->pref . "stat`
        WHERE FROM_UNIXTIME(`stat_time`,'%m-%Y') = '" . $mois . "'
        GROUP BY FROM_UNIXTIME(`stat_time`,'%m-%d');";

$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

while ( $row = $database->ResultArray ( $req ) )
{
    $visite_month[$row['stat_jour']] = $row['count'];
}


$image = ImageCreate ( $nbr_jour * 20 + 10 , 220 );

// Couleurs de l'image
$couleur_blanc = ImageColorAllocate ( $image , 255 , 255 , 255 );
$couleur_noir = ImageColorAllocate ( $image , 0 , 0 , 0 );
$couleur_orange = ImageColorAllocate ( $image , 255 , 210 , 130 );


ImageLine ( $image , 5 , 200 , 5 , 205, $couleur_noir );
ImageLine ( $image , 5 , 200 , $nbr_jour * 20 + 5 , 200 , $couleur_noir );

// Titre du graphique
ImageString ( $image , 5 , $nbr_jour * 10 + 25 - ImageFontWidth ( 5 ) * strlen ( 'Statistiques du mois de ' . $langue['mois_' . date ( 'm' ) ] . ' ' . date ( 'Y' ) ) / 2 , 0 , 'Statistiques du mois de ' . $langue['mois_' . date ( 'm' ) ] . ' ' . date ( 'Y' ) , $couleur_noir );


// Hauteur en pixels d'un visiteur sur une barre
$hauteur_par_visiteur = 150 / max ( $visite_month );


// Nombre de visites pour chaque jour
for ( $i = 0 ; list ( $day , $nbr ) = each ( $visite_month ) ; $i++ )
{
    $position = 20 * $i + 5;

    // Numéro du jour
    ImageString ( $image , 3 , $position + 10 - ImageFontWidth ( 3 ) * strlen ( $day ) / 2 , 205 , $day , $couleur_noir );

    // Barre de l'histogramme
    ImageFilledRectangle ( $image , $position + 1 , 199 - $hauteur_par_visiteur * $nbr , $position + 19 , 199 , $couleur_orange );

    // Nombre de visiteurs
    if ( $nbr != 0 ) ImageString ( $image , 2 , $position + 10 - ImageFontWidth ( 2 ) * strlen ( $nbr ) / 2 , 199 - $hauteur_par_visiteur * $nbr - ImageFontHeight ( 2 ) , $nbr , $couleur_noir );

    // Petite ligne en bas pour séparer les jours
    ImageLine ( $image , $position + 20 , 200 , $position + 20 , 205 , $couleur_noir );
}

ImageColorTransparent ( $image , $couleur_blanc );
ImagePNG ( $image , 'fichiers/stats/' . date ( 'Y-m' ) . '.png' );

$page_texte .= '<p class="centre"><img src="fichiers/stats/' . date ( 'Y-m' ) . '.png" alt="" title="Statistiques du mois de ' . $langue['mois_' . date ( 'm' ) ] . ' ' . date ( 'Y' ) . "\" /></p>\n\n";


/*******************************
 * Statistiques des navigateurs
 ******************************/

$page_texte .= '<h2>' . $langue['navigateurs'] . "</h2>\n\n<ul>\n";

$navigateurs = array ();
$total_nav = 0;


if ( $configuration['stat_count'] == 'hits' )
{
    $sql = "SELECT `stat_navigateur`,
                   SUM(`stat_hit`) AS `count`
            FROM `" . $database->pref . "stat`
            GROUP BY `stat_navigateur`;";
}
else
{
    $sql = "SELECT `stat_navigateur`,
                   COUNT(*) AS `count`
            FROM `" . $database->pref . "stat`
            GROUP BY `stat_navigateur`;";
}

$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

while ( $row = $database->ResultArray ( $req ) )
{
    $row_navigateur = preg_replace ( "#^(.+) \| (.+)$#" , "$1" , $row['stat_navigateur'] );

    // On n'affiche pas les robots
    if ( $row_navigateur == 'Robot' )
    {
        continue;
    }

    if ( isset ( $navigateurs[$row_navigateur] ) )
    {
        $navigateurs[$row_navigateur] += $row['count'];
    }
    else
    {
        $navigateurs[$row_navigateur] = $row['count'];
    }

    $total_nav += $row['count'];
}

// Tri des navigateurs par ordre décroissant
array_multisort ( $navigateurs , SORT_DESC );

foreach ( $navigateurs as $nav_nom => $nav_nbr )
{
    $page_texte .= '  <li><img src="themes/commun/images/statistiques/';

    switch ( $nav_nom )
    {
        default:                    $page_texte .= 'inconnu.png';       break;
        case 'Epiphany':            $page_texte .= 'nav_epiphany.png';  break;
        case 'Internet Explorer':   $page_texte .= 'nav_explorer.png';  break;
        case 'Mozilla Firefox':     $page_texte .= 'nav_firefox.png';   break;
        case 'Konqueror':           $page_texte .= 'nav_konqueror.png'; break;
        case 'Mozilla':             $page_texte .= 'nav_mozilla.png';   break;
        case 'Opera':               $page_texte .= 'nav_opera.png';     break;
        case 'Safari':              $page_texte .= 'nav_safari.png';    break;
    }

    $page_texte .= '" alt="" title="' . $nav_nom . '" /> ' . $nav_nom . '&nbsp;: ' . round ( ( $nav_nbr / $total_nav * 100 ) , 2 ) . " %</li>\n";
}

$page_texte .= "</ul>\n\n";


/*******************************
 * Statistiques des systèmes d'exploitation
 ******************************/

$page_texte .= '<h2>' . $langue['systemes'] . "</h2>\n\n<ul>\n";

$systemes = array ();
$total_os = 0;


if ( $configuration['stat_count'] == 'hits' )
{
    $sql = "SELECT `stat_os`,
                   SUM(`stat_hit`) AS `count`
            FROM `" . $database->pref . "stat`
            GROUP BY `stat_os`;";
}
else
{
    $sql = "SELECT `stat_os`,
                   COUNT(*) AS `count`
            FROM `" . $database->pref . "stat`
            GROUP BY `stat_os`;";
}


$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

while ( $row = $database->ResultArray ( $req ) )
{
    $robot = preg_replace ( "#^(.+) \| (.+)$#" , "$1" , $row['stat_os'] );

    // On n'affiche pas les robots
    if ( $robot == 'Robot' )
    {
        continue;
    }

    if ( isset ( $systemes[$row['stat_os']] ) )
    {
        $systemes[$row['stat_os']] += $row['count'];
    }
    else
    {
        $systemes[$row['stat_os']] = $row['count'];
    }

    $total_os += $row['count'];
}

// Tri des systèmes d'exploitation par ordre décroissant
array_multisort ( $systemes , SORT_DESC );

foreach ( $systemes as $os_nom => $os_nbr )
{
    $row_systeme = preg_replace ( "#^(.+) \| (.+)$#" , "$2" , $os_nom  );
    $row_icone = preg_replace ( "#^(.+) \| (.+)$#" , "$1" , $os_nom  );

    $page_texte .= '  <li><img src="themes/commun/images/statistiques/';

    switch ( $row_icone )
    {
        default:        $page_texte .= 'inconnu.png';       break;
        case 'Windows': $page_texte .= 'os_windows.png';    break;
        case 'Linux':   $page_texte .= 'os_linux.png';      break;
        case 'FreeBSD': $page_texte .= 'os_freebsd.png';    break;
        case 'Mac':     $page_texte .= 'os_macosx.png';     break;
    }

    $page_texte .= '" alt="" title="' . $row_systeme . '" /> ' . $row_systeme . '&nbsp;: ' . round ( ( $os_nbr / $total_os * 100 ) , 2 ) . " %</li>\n";
}

$page_texte .= "</ul>\n\n";


/*******************************
 * Statistiques des robots
 ******************************/

$robots = array ();
$total_robot = 0;


if ( $configuration['stat_count'] == 'hits' )
{
    $sql = "SELECT `stat_os`,
                   SUM(`stat_hit`) AS `count`
            FROM `" . $database->pref . "stat`
            WHERE `stat_os` REGEXP 'Robot'
            GROUP BY `stat_os`;";
}
else
{
    $sql = "SELECT `stat_os`,
                   COUNT(*) AS `count`
            FROM `" . $database->pref . "stat`
            WHERE `stat_os` REGEXP 'Robot'
            GROUP BY `stat_os`;";
}


$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

while ( $row = $database->ResultArray ( $req ) )
{
    $robot = preg_replace ( "#^Robot \| (.+)$#" , "$1" , $row['stat_os'] );

    if ( isset ( $robots[$robot] ) )
    {
        $robots[$robot] += $row['count'];
    }
    else
    {
        $robots[$robot] = $row['count'];
    }

    $total_robot += $row['count'];
}

// Tri des robots par ordre décroissant
array_multisort ( $robots , SORT_DESC );

if ( $total_robot > 0 )
{
    $page_texte .= "<h2>Robots</h2>\n\n<ul>\n";

    foreach ( $robots as $robot => $count )
    {
        $page_texte .= '  <li><img src="themes/commun/images/statistiques/';

        if ( $robot == 'Exabot' || $robot == 'Exabot Thumbnails' )
        {
            $page_texte .= 'robot_exabot';
        }
        else if ( $robot == 'GoogleBot' )
        {
            $page_texte .= 'robot_google';
        }
        else if ( $robot == 'Validateur CSS W3C' || $robot == 'Validateur W3C' )
        {
            $page_texte .= 'robot_validator';
        }
        else if ( $robot == 'Yahoo' )
        {
            $page_texte .= 'robot_yahoo';
        }
        else if ( $robot == 'MSN Bot' )
        {
            $page_texte .= 'robot_msn';
        }
        else
        {
            $page_texte .= 'inconnu';
        }

        $page_texte .= '.png" alt="" title="' . $robot . '" /> ' . $robot . '&nbsp;: ' . round ( ( $count / $total_robot * 100 ) , 2 ) . " %</li>\n";
    }

    $page_texte .= "</ul>\n\n";
}

/*******************************
 * Statistiques des langues
 ******************************/

$page_texte .= '<h2>' . $langue['langues'] . "</h2>\n\n<ul>\n";

$stat_langues = array ();
$total_langues = 0;


if ( $configuration['stat_count'] == 'hits' )
{
    $sql = "SELECT `stat_langue`,
                   SUM(`stat_hit`) AS `count`
            FROM `" . $database->pref . "stat`
            GROUP BY `stat_langue`;";
}
else
{
    $sql = "SELECT `stat_langue`,
                   COUNT(*) AS `count`
            FROM `" . $database->pref . "stat`
            GROUP BY `stat_langue`;";
}


$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

while ( $row = $database->ResultArray ( $req ) )
{
    if ( preg_match ( "#^([a-z]{2})-([a-z]{2})$#" , $row['stat_langue'] ) )
    {
        $lng = preg_replace ( "#^([a-z]{2})-([a-z]{2})$#" , "$1" , $row['stat_langue'] );
        $ss_lng = preg_replace ( "#^([a-z]{2})-([a-z]{2})$#" , "$2" , $row['stat_langue'] );
    }
    else
    {
        $lng = $row['stat_langue'];
        $ss_lng = '';
    }

    if ( isset ( $stat_langues[$lng]['0'] ) )
    {
        $stat_langues[$lng]['0'] += $row['count'];
    }
    else
    {
        $stat_langues[$lng]['0'] = $row['count'];
    }

    if ( !empty ( $ss_lng ) )
    {
        if ( isset ( $stat_langues[$lng][$ss_lng] ) )
        {
            $stat_langues[$lng][$ss_lng] += $row['count'];
        }
        else
        {
            $stat_langues[$lng][$ss_lng] = $row['count'];
        }
    }
    else
    {
        if ( isset ( $stat_langues[$lng]['1'] ) )
        {
            $stat_langues[$lng]['1'] += $row['count'];
        }
        else
        {
            $stat_langues[$lng]['1'] = $row['count'];
        }
    }

    $total_langues += $row['count'];
}

// Tri des langues par ordre décroissant
array_multisort ( $stat_langues , SORT_DESC );

foreach ( $stat_langues as $lng_nom => $lng_ss_lng )
{
    $page_texte .= '  <li>'. $langue['langue_' . $lng_nom] . '&nbsp;: ' . round ( ( $lng_ss_lng['0'] / $total_langues * 100 ) , 2 ) . ' %';

    if ( sizeof ( $lng_ss_lng ) > 2 )
    {
        $page_texte .= '<ul>';

        array_multisort ( $lng_ss_lng , SORT_DESC );

        foreach ( $lng_ss_lng as $lng_ss_nom => $lng_nbr )
        {
            if ( $lng_ss_nom == '1' )
            {
                $page_texte .= '  <li>' . $langue['langue_' . $lng_nom] . ' (Standard)&nbsp;: ' . round ( ( $lng_nbr / $total_langues * 100 ) , 2 ) . " %</li>\n";
            }
            else if ( $lng_ss_nom != '0' )
            {
                $page_texte .= '  <li>' . $langue['langue_' . $lng_nom] . ' (' . $langue['pays_' . strtoupper ( $lng_ss_nom )] . ')&nbsp;: ' . round ( ( $lng_nbr / $total_langues * 100 ) , 2 ) . " %</li>\n";
            }
        }

        $page_texte .= '</ul>';
    }

    $page_texte .= "</li>\n";
}

$page_texte .= "</ul>\n\n";


/*******************************
 * Statistiques des pays
 ******************************/

$page_texte .= "<h2>Pays</h2>\n\n<ul>\n";

$pays = array ();
$total_pays = 0;


if ( $configuration['stat_count'] == 'hits' )
{
    $sql = "SELECT `stat_pays`,
                   SUM(`stat_hit`) AS `count`
            FROM `" . $database->pref . "stat`
            GROUP BY `stat_pays`;";
}
else
{
    $sql = "SELECT `stat_pays`,
                   COUNT(*) AS `count`
            FROM `" . $database->pref . "stat`
            GROUP BY `stat_pays`;";
}


$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

while ( $row = $database->ResultArray ( $req ) )
{
    if ( isset ( $pays[$row['stat_pays']] ) )
    {
        $pays[$row['stat_pays']] += $row['count'];
    }
    else
    {
        $pays[$row['stat_pays']] = $row['count'];
    }

    $total_pays += $row['count'];
}

// Tri des pays par ordre décroissant
array_multisort ( $pays , SORT_DESC );

foreach ( $pays as $pays_nom => $pays_nbr )
{
    $page_texte .= '  <li><img src="themes/commun/images/pays/' . strtolower ( $pays_nom ) . '.png" alt="" title="' . $langue['pays_' . $pays_nom] . '" /> ' . $langue['pays_' . $pays_nom] . '&nbsp;: ' . round ( ( $pays_nbr / $total_pays * 100 ) , 2 ) . " %</li>\n";
}


$page_texte .= "</ul>\n\n";


/*******************************
 * Statistiques des FAI
 ******************************/

$page_texte .= "<h2>FAI</h2>\n\n<ul>\n";

$fai = array ();
$total_fai = 0;


if ( $configuration['stat_count'] == 'hits' )
{
    $sql = "SELECT `stat_fai`,
                   SUM(`stat_hit`) AS `count`
            FROM `" . $database->pref . "stat`
            GROUP BY `stat_fai`;";
}
else
{
    $sql = "SELECT `stat_fai`,
                   COUNT(*) AS `count`
            FROM `" . $database->pref . "stat`
            GROUP BY `stat_fai`;";
}


$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

while ( $row = $database->ResultArray ( $req ) )
{
    if ( $row['stat_fai'] == 'free' || $row['stat_fai'] == 'proxad' )
    {
        if ( isset ( $fai['free'] ) )
        {
            $fai['free'] += $row['count'];
        }
        else
        {
            $fai['free'] = $row['count'];
        }
    }
    else
    {
        if ( isset ( $fai[$row['stat_fai']] ) )
        {
            $fai[$row['stat_fai']] += $row['count'];
        }
        else
        {
            $fai[$row['stat_fai']] = $row['count'];
        }
    }

    $total_fai += $row['count'];
}

// Tri des FAI par ordre décroissant
array_multisort ( $fai , SORT_DESC );

foreach ( $fai as $fai_nom => $fai_nbr )
{
    $page_texte .= '  <li>';

    if ( $fai_nom == 'inconnu' )
    {
        $page_texte .= 'Inconnu';
    }
    else if ( $fai_nom == 'proxad' || $fai_nom == 'free' )
    {
        $page_texte .= '<a href="http://www.free.fr/">Free</a>';
    }
    else if ( $fai_nom == 'wanadoo' )
    {
        $page_texte .= '<a href="http://www.orange.fr/">Wanadoo</a>';
    }
    else if ( $fai_nom == 'belgacom' )
    {
        $page_texte .= '<a href="http://www.belgacom.be/">Belgacom</a>';
    }
    else if ( $fai_nom == 'bluewin' )
    {
        $page_texte .= '<a href="http://www.bluewin.ch/">Bluewin</a>';
    }
    else if ( $fai_nom == 'club-internet' )
    {
        $page_texte .= '<a href="http://www.club-internet.fr/">Club-Internet</a>';
    }
    else if ( $fai_nom == 'tele2' )
    {
        $page_texte .= '<a href="http://www.tele2.fr/">TELE2</a>';
    }
    else if ( $fai_nom == 'tpnet' )
    {
        $page_texte .= '<a href="http://www.tpnet.psi.br/">TPNET</a>';
    }
    else if ( $fai_nom == 'numericable' )
    {
        $page_texte .= '<a href="http://www.numericable.fr/">Numericable</a>';
    }
    else if ( $fai_nom == 'mobileinternet.proxi' )
    {
        $page_texte .= 'Mobile Internet';
    }
    else if ( $fai_nom == 'tiscali' )
    {
        $page_texte .= '<a href="http://www.aliceadsl.fr/">Alice ADSL (Tiscali)</a>';
    }
    else
    {
        $page_texte .= $fai_nom;
    }

    $page_texte .= '&nbsp;: ' . round ( ( $fai_nbr / $total_fai * 100 ) , 2 ) . " %</li>\n";
}


$page_texte .= "</ul>\n\n";


/*******************************
 * Forums
 ******************************/

// Nombre de messages
$sql = "SELECT COUNT(*) AS `count`
        FROM `" . $database->pref . "forum_msg`;";

$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

$forum_nbr_msg = $database->Result ( $req , 'count' );

$sql = "SELECT COUNT(*) AS `count`
        FROM `" . $database->pref . "forum_sujet`;";

$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

$forum_nbr_sujet = $database->Result ( $req , 'count' );

$page_texte .= '<h2>' . $langue['forums'] . "</h2>\n\n<ul>\n";
$page_texte = sprintf ( "%s  <li>" . $langue['nbr_sujets'] . "</li>\n"  , $page_texte , $forum_nbr_sujet );
$page_texte = sprintf ( "%s  <li>" . $langue['nbr_msg'] . "</li>\n"  , $page_texte , $forum_nbr_msg );
$page_texte .= '  <li>';
$page_texte .= ( $forum_nbr_sujet == 0 ) ? 0 : round ( $forum_nbr_msg / $forum_nbr_sujet , 1 );
$page_texte .= " messages par sujets</li>\n</ul>\n\n";


/*******************************
 *
 *  Liste des visites
 *
 ******************************/

$page_texte .= '<h2 id="liste">' . $langue['stat_visites'] . "</h2>\n\n";
$page_texte .= "<table>\n\n<thead>\n";


// Première entrée des stats et numéro de la page affichée
$start = ( isset ( $_GET['start'] ) && is_numeric ( $_GET['start'] ) ) ? $_GET['start'] : 0;
$page_actuelle = intval ( $start / 50 ) + 1;


// Liste des pages (Haut du tableau)
if ( $nbr_stats > 50 )
{
    $page_texte .= "<tr>\n  <td colspan=\"6\">" . $langue['page'] . "&nbsp;:\n";

    $nbr_page = ( $nbr_stats - $nbr_stats % 50 ) / 50 + 1;

    for ( $i = 1 ; $i <= $nbr_page ; $i++ )
    {
        $affiche_numero = false;

        for ( $numero = 1 ; $numero <= $configuration['numero_debut'] ; $numero++ )
        {
            if ( $i == $numero ) $affiche_numero = true;
        }

        if ( !$affiche_numero )
        {
            for ( $numero = $page_actuelle - $configuration['numero_autour'] ; $numero <= $page_actuelle + $configuration['numero_autour'] ; $numero++ )
            {
                if ( $i == $numero ) $affiche_numero = true;
            }
        }

        if ( !$affiche_numero )
        {
            for ( $numero = $nbr_page + 1 - $configuration['numero_fin'] ; $numero <= $nbr_page ; $numero++ )
            {
                if ( $i == $numero ) $affiche_numero = true;
            }
        }

        // On affiche que certaines pages
        if ( $affiche_numero )
        {
            $page_texte .= '    <a href="index.' . EXT . '?page=Statistiques&start=' . ( $i - 1 ) * 50 . '#liste" title="' . $langue['page_goto'] . $i . '">';
            $page_texte .= ( $start == ( $i - 1 ) * 50 ) ? '<span class="page_actuelle">' . $i . "</span></a>\n" : $i . "</a>\n";
            $trois_petits_points = false;
        }
        // On affiche trois petits points entre les numéros de page
        else if ( !$trois_petits_points )
        {
            $page_texte .= '    ...';
            $trois_petits_points = true;
        }
    }

    $page_texte .= "  </td>\n</tr>\n";
}


// En-tête du tableau
$page_texte .= "<tr>\n";
$page_texte .= "  <th class=\"stat_date\">Date et heure</th>\n";
$page_texte .= '  <th class="stat_ip">' . $langue['adresse_ip'] . "</th>\n";
$page_texte .= '  <th class="stat_navigateur">' . $langue['navigateur'] . "</th>\n";
$page_texte .= '  <th class="stat_systeme">' . $langue['systeme'] . "</th>\n";
$page_texte .= '  <th class="stat_langue">' . $langue['langue'] . "</th>\n";
$page_texte .= '  <th class="stat_pays">' . $langue['pays'] . "</th>\n";
$page_texte .= "</tr>\n</thead>\n\n";


// Liste des pages (Bas du tableau)
if ( $nbr_stats > 50 )
{
    $page_texte .= "<tfoot>\n<tr>\n  <td colspan=\"6\">" . $langue['page'] . "&nbsp;:\n";

    $nbr_page = ( $nbr_stats - $nbr_stats % 50 ) / 50 + 1;

    for ( $i = 1 ; $i <= $nbr_page ; $i++ )
    {
        $affiche_numero = false;

        for ( $numero = 1 ; $numero <= $configuration['numero_debut'] ; $numero++ )
        {
            if ( $i == $numero ) $affiche_numero = true;
        }

        if ( !$affiche_numero )
        {
            for ( $numero = $page_actuelle - $configuration['numero_autour'] ; $numero <= $page_actuelle + $configuration['numero_autour'] ; $numero++ )
            {
                if ( $i == $numero ) $affiche_numero = true;
            }
        }

        if ( !$affiche_numero )
        {
            for ( $numero = $nbr_page + 1 - $configuration['numero_fin'] ; $numero <= $nbr_page ; $numero++ )
            {
                if ( $i == $numero ) $affiche_numero = true;
            }
        }

        // On affiche que certaines pages
        if ( $affiche_numero )
        {
            $page_texte .= '    <a href="index.' . EXT . '?page=Statistiques&start=' . ( $i - 1 ) * 50 . '#liste" title="' . $langue['page_goto'] . $i . '">';
            $page_texte .= ( $start == ( $i - 1 ) * 50 ) ? '<span class="page_actuelle">' . $i . "</span></a>\n" : $i . "</a>\n";
            $trois_petits_points = false;
        }
        // On affiche trois petits points entre les numéros de page
        else if ( !$trois_petits_points )
        {
            $page_texte .= '    ...';
            $trois_petits_points = true;
        }
    }

    $page_texte .= "  </td>\n</tr>\n</tfoot>\n\n";
}


$page_texte .= "<tbody>\n";


$sql = "SELECT `stat_time`,
               `stat_ip`,
               `stat_navigateur`,
               `stat_os`,
               `stat_langue`,
               `stat_pays`
        FROM `" . $database->pref . "stat`
        ORDER BY `stat_time` DESC";

//=>MYSQL
    if ( SGBD == 'mysql' ) $sql .= ' LIMIT ' . $start . ', 50';
//
    $sql .= ';';

$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

$sql_limite = 0;

while ( $sql_limite < $start + 50 && $row = $database->ResultArray ( $req ) )
{
    $sql_limite++;

    // On affiche les enregistrements à partir de $start
    if ( SGBD != 'mysql' && $sql_limite < $start )
    {
        continue;
    }

    if ( preg_match ( "#^Robot \| (.+)$#" , $row['stat_navigateur'] ) )
    {
        $navigateur = preg_replace ( "#^Robot \| (.+)$#" , "$1" , $row['stat_navigateur'] );
    }
    else if ( preg_match ( "#^(.+) \| (.+)$#" , $row['stat_navigateur'] ) )
    {
        $navigateur = preg_replace ( "#^(.+) \| (.+)$#" , "$1 $2" , $row['stat_navigateur'] );
    }
    else
    {
        $navigateur = $row['stat_navigateur'];
    }

    $page_texte .= "<tr>\n";
    $page_texte .= '  <td class="centre">' . date ( $configuration['format_date'] , $row['stat_time'] ) . $langue['time_at'] . date ( $configuration['format_heure'] , $row['stat_time'] ) . "</td>\n";
    $page_texte .= '  <td>' . ConvertIP ( '' , $row['stat_ip'] ) . "</td>\n";

    // Navigateur et système d'exploitation
    if ( $navigateur == preg_replace ( "#^(.+) \| (.+)$#" , "$2" , $row['stat_os'] ) )
    {
        $page_texte .= '  <td colspan="2"><img src="themes/commun/images/statistiques/';

        if ( preg_match ( "#^Robot \| (.+)$#" , $row['stat_navigateur'] ) )
        {
            if ( $navigateur == 'Exabot' || $navigateur == 'Exabot Thumbnails' )
            {
                $page_texte .= 'robot_exabot';
            }
            else if ( $navigateur == 'GoogleBot' )
            {
                $page_texte .= 'robot_google';
            }
            else if ( $navigateur == 'Validateur CSS W3C' || $navigateur == 'Validateur W3C' )
            {
                $page_texte .= 'robot_validator';
            }
            else if ( $navigateur == 'Yahoo' )
            {
                $page_texte .= 'robot_yahoo';
            }
            else if ( $navigateur == 'MSN Bot' )
            {
                $page_texte .= 'robot_msn';
            }
            else
            {
                $page_texte .= 'inconnu';
            }
        }
        else
        {
            $page_texte .= 'inconnu';
        }

        $page_texte .= '.png" alt="" title="' . $navigateur . '" /> ' . $navigateur . "</td>\n";
    }
    else
    {
        $page_texte .= '  <td><img src="themes/commun/images/statistiques/';

        switch ( preg_replace ( "#^(.+) \| (.+)$#" , "$1" , $row['stat_navigateur'] ) )
        {
            default:                    $page_texte .= 'inconnu.png';       break;
            case 'Epiphany':            $page_texte .= 'nav_epiphany.png';  break;
            case 'Internet Explorer':   $page_texte .= 'nav_explorer.png';  break;
            case 'Mozilla Firefox':     $page_texte .= 'nav_firefox.png';   break;
            case 'Konqueror':           $page_texte .= 'nav_konqueror.png'; break;
            case 'Mozilla':             $page_texte .= 'nav_mozilla.png';   break;
            case 'Opera':               $page_texte .= 'nav_opera.png';     break;
            case 'Safari':              $page_texte .= 'nav_safari.png';    break;
        }

        $page_texte .= '" alt="" title="' . $navigateur . '" /> ' . $navigateur . "</td>\n";
        $page_texte .= '  <td><img src="themes/commun/images/statistiques/';

        switch ( preg_replace ( "#^(.+) \| (.+)$#" , "$1" , $row['stat_os'] ) )
        {
            default:        $page_texte .= 'inconnu.png';       break;
            case 'Windows': $page_texte .= 'os_windows.png';    break;
            case 'Linux':   $page_texte .= 'os_linux.png';      break;
            case 'FreeBSD': $page_texte .= 'os_freebsd.png';    break;
            case 'Mac':     $page_texte .= 'os_macosx.png';     break;
        }

        $page_texte .= '" alt="" title="' . preg_replace ( "#^(.+) \| (.+)$#" , "$2" , $row['stat_os'] ) . '" /> ' . preg_replace ( "#^(.+) \| (.+)$#" , "$2" , $row['stat_os'] ) . "</td>\n";
    }

    $page_texte .= '  <td>';

    if ( empty ( $row['stat_langue'] ) )
    {
        $page_texte .= $langue['langue_00'];
    }
    else if ( preg_match ( "#^([a-z]{2})-([a-z]{2})$#" , $row['stat_langue'] ) )
    {
        $page_texte .= $langue['langue_' . preg_replace ( "#^([a-z]{2})-([a-z]{2})$#" , "$1" , $row['stat_langue'] )] . ' (' . $langue['pays_' . strtoupper ( preg_replace ( "#^([a-z]{2})-([a-z]{2})$#" , "$2" , $row['stat_langue'] ) ) ] . ')';
    }
    else
    {
        $page_texte .= $langue['langue_' . $row['stat_langue']];
    }

    $page_texte .= "</td>\n  <td class=\"centre\">";

    // Si l'adresse IP est 127.0.0.1
    if ( $row['stat_ip'] == '2130706433' )
    {
        $pays = '00';
    }
    else if ( empty ( $row['stat_pays'] ) )
    {
        $pays = '00';
    }
    else
    {
        $pays = $row['stat_pays'];
    }

    $page_texte .= '<img src="themes/commun/images/pays/' . strtolower ( $pays ) . '.png" alt="" title="' . $langue['pays_' . $pays] . '" /> ' . $langue['pays_' . $pays] . "</td>\n";
    $page_texte .= "</tr>\n";
}

$page_texte .= "</tbody>\n\n</table>\n\n";

?>