<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /pages/Supprimer_un_article.php
 *  Date de création : avant le 13/08/2007
 *  Dernière modification : 01/09/2007
 ***************************************************************************/

// Sécurité
if ( !defined ( 'TAGADASH' ) )
{
    header ( 'Location: ../' );
    die ( -1 );
}


// Droit d'édition des articles
if ( $droit['article_edition'] == 0 )
{
    $page_msg = 3;
    include_once ( 'systeme/msg.' . EXT );
}


if ( !isset ( $_GET['id'] ) || !is_numeric ( $_GET['id'] ) )
{
    header ( 'Location: index.' . EXT . '?page=Liste_des_articles' );
    die ( -1 );
}


$sql = "SELECT `article_actif`,
               `article_auteur`,
               `article_titre`,
               `article_texte`,
               `article_modification`,
               `article_langue`,
               `article_categorie`
        FROM `" . $database->pref . "article_article`
        WHERE `article_id` = '" . $_GET['id'] . "';";

$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

// On vérifie que l'article existe
if ( $database->NbrRowsSelected ( $req ) === 0 )
{
    header ( 'Location: index.' . EXT . '?page=Liste_des_articles' );
    die ( -1 );
}

$row = $database->ResultArray ( $req );

$article = $row['article_titre'];


// Si on a le droit d'éditer l'article
if ( $droit['article_sup_auteur'] == 1 || $droit['article_sup'] == 1 )
{
    if ( $row['article_actif'] == 1 && ( $droit['article_sup_auteur'] == 1 && $_SESSION['groupe'] != 1 && $row['article_auteur'] == $_SESSION['membre_id'] || $droit['article_sup'] == 1 ) )
    {
        if ( isset ( $_GET['ok'] ) )
        {
            $sql = "INSERT INTO `" . $database->pref . "article_historique`
                    (`historique_titre`, `historique_texte`, `historique_auteur`, `historique_time`, `historique_langue`, `historique_categorie`)
                    VALUES
                    ('" . $database->Protege ( $row['article_titre'] , false ) . "', '" . $database->Protege ( $row['article_texte'] , false ) . "', '" . $row['article_auteur'] . "', '" . $row['article_modification'] . "', '" . $row['article_langue'] . "', '" . $row['article_categorie'] . "');";

            $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            $sql = "UPDATE `" . $database->pref . "article_article`
                    SET `article_actif` = '0'
                    WHERE `article_id` = '" . $_GET['id'] . "';";

            $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

            header ( 'Location: index.' . EXT );
            die ( -1 );
        }


        // Titre de la page
        $page_titre = $langue['delete_of'] . $article;
        $page_infos = $langue['delete_of'] . $article;


        $page_texte .= '<p><a href="index.' . EXT . '?page=Supprimer_un_article&amp;id=' . $_GET['id'] . '&amp;ok' . '" title="' . $langue['supprimer_article'] . '">' . $langue['clic_here'] . '</a>' . $langue['_to_delete'] . "</p>\n\n";

        $menu_article_editer = '  <li><a href="index.' . EXT . '?page=Editer_un_article&amp;id=' . $_GET['id'] . '" title="' . $langue['editer_article'] . '">' . $langue['editer'] . "</a></li>\n";
        $menu_article_historique = '  <li><a href="index.' . EXT . '?page=Historique&amp;id=' . $_GET['id'] . '" title="' . $langue['historique_texte'] . '">' . $langue['historique'] . "</a></li>\n";
        $menu_article_supprimer = '  <li><a href="index.' . EXT . '?page=Article&amp;id=' . $_GET['id'] . '" title="' . $article . '">' . $langue['view_article'] . "</a></li>\n";
    }

    // Supprimer définitivement un article
    else if ( $row['article_actif'] == 0 && $_SESSION['groupe'] == 3 && isset ( $_GET['ok'] ) )
    {
        $sql = "DELETE FROM `" . $database->pref . "article_article`
                WHERE `article_id` = '" . $_GET['id'] . "';";

        $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        $sql = "DELETE FROM `" . $database->pref . "article_historique`
                WHERE `historique_article` = '" . $_GET['id'] . "';";

        $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

        header ( 'Location: index.' . EXT );
        die ( -1 );
    }
    else
    {
        header ( 'Location: index.' . EXT );
        die ( -1 );
    }
}
else
{
    header ( 'Location: index.' . EXT );
    die ( -1 );
}

?>