<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /pages/Visiteurs.php
 *  Date de création : avant le 12/08/2007
 *  Dernière modification : 14/09/2007
 ***************************************************************************/

// Sécurité
if ( !defined ( 'TAGADASH' ) )
{
    header ( 'Location: ../' );
    die ( -1 );
}


// Titre de la page
$page_titre = $langue['liste_visiteurs'];
$page_infos = $langue['liste_visiteurs'];


$page_texte .= '<p>Record de visiteurs sur le site&nbsp;: ' . $configuration['record_visiteurs'] . ' le ' . date ( $configuration['format_date'] , $configuration['record_time'] ) . $langue['time_at'] . date ( $configuration['format_heure'] , $configuration['record_time'] ) . "</p>\n\n";


// On regarde le nombre de visiteurs
$sql = "SELECT COUNT(*) AS `count`
        FROM `" . $database->pref . "visiteurs`
        WHERE `visiteur_time` > '" . ( $time - 300 ) . "';";

$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

$nbr_visites_now = $database->Result ( $req , 'count' );


// Premier membre et numéro de la page affichée
if ( isset ( $_GET['start'] ) && is_numeric ( $_GET['start'] ) && $_GET['start'] >= 0 && $_GET['start'] < $nbr_visites_now )
{
    $start = $_GET['start'];
}
else
{
    $start = 0;
}

$page_actuelle = intval ( $start / $configuration['membres_page'] ) + 1;

// Nombre de pages
$nbr_page = ( ( $nbr_visites_now - 1 ) - ( $nbr_visites_now - 1 ) % $configuration['membres_page'] ) / $configuration['membres_page'] + 1;


$page_texte .= "<table>\n\n<thead>\n";


// Liste des pages
if ( $nbr_visites_now > $configuration['membres_page'] )
{
    $page_texte .= "<tr>\n  <td colspan=\"2\">" . $langue['page'] . "&nbsp;:\n";

    for ( $i = 1 ; $i <= $nbr_page ; $i++ )
    {
        $affiche_numero = false;

        for ( $numero = 1 ; $numero <= $configuration['numero_debut'] ; $numero++ )
        {
            if ( $i == $numero ) $affiche_numero = true;
        }

        if ( !$affiche_numero )
        {
            for ( $numero = $page_actuelle - $configuration['numero_autour'] ; $numero <= $page_actuelle + $configuration['numero_autour'] ; $numero++ )
            {
                if ( $i == $numero ) $affiche_numero = true;
            }
        }

        if ( !$affiche_numero )
        {
            for ( $numero = $nbr_page + 1 - $configuration['numero_fin'] ; $numero <= $nbr_page ; $numero++ )
            {
                if ( $i == $numero ) $affiche_numero = true;
            }
        }

        if ( $affiche_numero ) 
        {
            $page_texte .= '    <a href="index.' . EXT . '?page=Visiteurs&amp;start=' . ( $i - 1 ) * $configuration['membres_page'] . '" title="' . $langue['page_goto'] . $i . '">';
            $page_texte .= ( $start == ( $i - 1 ) * $configuration['membres_page'] ) ? '<span class="page_actuelle">' . $i . "</span></a>\n" : $i . "</a>\n";
            $trois_petits_points = false;
        }
        else if ( !$trois_petits_points )
        {
            $page_texte .= "    ...\n";
            $trois_petits_points = true;
        }
    }

    $page_texte .= "  </td>\n</tr>\n</tfoot>\n\n";
}


// En-tête du tableau
$page_texte .= "<tr>\n";
$page_texte .= '  <th class="liste_visiteur_nom">' . $langue['user'] . "</th>\n";
$page_texte .= '  <th class="liste_visiteur_page">' . $langue['page'] . "</th>\n";
$page_texte .= '  <th class="liste_visiteur_visite">' . $langue['last_visite'] . "</th>\n";
$page_texte .= "</tr>\n";

$page_texte .= "</thead>\n\n";


// Liste des pages
if ( $nbr_visites_now > $configuration['membres_page'] )
{
    $page_texte .= "<tfoot>\n<tr>\n  <td colspan=\"2\">" . $langue['page'] . "&nbsp;:\n";

    for ( $i = 1 ; $i <= $nbr_page ; $i++ )
    {
        $affiche_numero = false;

        for ( $numero = 1 ; $numero <= $configuration['numero_debut'] ; $numero++ )
        {
            if ( $i == $numero ) $affiche_numero = true;
        }

        if ( !$affiche_numero )
        {
            for ( $numero = $page_actuelle - $configuration['numero_autour'] ; $numero <= $page_actuelle + $configuration['numero_autour'] ; $numero++ )
            {
                if ( $i == $numero ) $affiche_numero = true;
            }
        }

        if ( !$affiche_numero )
        {
            for ( $numero = $nbr_page + 1 - $configuration['numero_fin'] ; $numero <= $nbr_page ; $numero++ )
            {
                if ( $i == $numero ) $affiche_numero = true;
            }
        }

        if ( $affiche_numero ) 
        {
            $page_texte .= '    <a href="index.' . EXT . '?page=Visiteurs&amp;start=' . ( $i - 1 ) * $configuration['membres_page'] . '" title="' . $langue['page_goto'] . $i . '">';
            $page_texte .= ( $start == ( $i - 1 ) * $configuration['membres_page'] ) ? '<span class="page_actuelle">' . $i . "</span></a>\n" : $i . "</a>\n";
            $trois_petits_points = false;
        }
        else if ( !$trois_petits_points )
        {
            $page_texte .= "    ...\n";
            $trois_petits_points = true;
        }
    }

    $page_texte .= "  </td>\n</tr>\n</tfoot>\n\n";
}


$page_texte .= "<tbody>\n";


$sql = "SELECT `visiteur_ip`,
               `visiteur_nom`,
               `visiteur_time`,
               `visiteur_page`,
               `membre_id`
        FROM `" . $database->pref . "visiteurs`
        LEFT JOIN `" . $database->pref . "membres`
            ON `membre_nom` = `visiteur_nom`
        WHERE `visiteur_time` > '" . ( $time - 300 ) . "'
        ORDER BY `visiteur_time` DESC";

//=>MYSQL
    if ( SGBD == 'mysql' ) $sql .= ' LIMIT ' . $start . ', ' . $configuration['membres_page'];
    $sql .= ';';
//=>END

$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


for ( $sql_limite = 0 ; $sql_limite < $start + $configuration['membres_page'] && $row = $database->ResultArray ( $req ) ; $sql_limite++ )
{
    // On affiche les enregistrements à partir de $start
    if ( SGBD != 'mysql' && $sql_limite < $start )
    {
        continue;
    }

    $page_texte .= "<tr>\n  <td>";
    $page_texte .= ( $row['visiteur_nom'] == 'Anonyme' ) ? $langue['anonyme'] : '<a href="index.' . EXT . '?page=Membre&amp;id=' . $row['membre_id'] . '" title="' . $langue['view_fiche'] . $row['visiteur_nom'] . '">' . $row['visiteur_nom'] . "</a>";
    $page_texte .= "</td>\n  <td>";

    // La mise-à-jour de la table des visiteurs se fait après la génération de la page,
    // donc $row['visiteur_page'] contient la page vue précédemment
    $page_texte .= ( $row['visiteur_ip'] == ConvertIP ( $_SERVER['REMOTE_ADDR'] , '' ) ) ? $langue['liste_visiteurs'] : $row['visiteur_page'];

    $page_texte .= "</td>\n  <td class=\"centre\">" . date ( $configuration['format_date'] , $row['visiteur_time'] ) . $langue['time_at'] . date ( $configuration['format_heure'] , $row['visiteur_time'] ) . "</td>\n";
    $page_texte .= "</tr>\n";
}


$page_texte .= "</tbody>\n\n</table>\n";

?>