<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /systeme/lib_php5/templates.php
 *  Date de création : 24/08/2007
 *  Dernière modification : 14/09/2007
 ***************************************************************************/

// Sécurité
if ( !defined ( 'TAGADASH' ) )
{
    header ( 'Location: ../' );
    die ( -1 );
}


class Template
{
    private $texte = '';
    private $vars = array ();

    // Constructeur : adresse du fichier
    public function __construct ( $fichier )
    {
        if ( !is_file ( $fichier ) )
        {
            return false;
        }
    
        $file = fopen ( $fichier , 'r' );

        if ( !$file )
        {
            return false;
        }

        while ( !feof ( $file ) )
        {
            // On récupère une ligne
            $this->texte .= fgets ( $file , 255 );
        }

        fclose ( $file );

        return true;
    }

    // Définie les variables à transformer dans la page
    public function SetVar ( array $vars )
    {
        if ( !is_array ( $vars ) )
        {
            return false;
        }

        foreach ( $vars as $var => $val )
        {
            $this->vars[$var] = $val;
        }

        return true;
    }

    // Retourne le texte de la page
    public function Parse ()
    {
        foreach ( $this->vars as $var => $val )
        {
            $this->texte = str_replace ( '{' . $var . '}' , $val , $this->texte );
        }

        return $this->texte;
    }
}

?>