<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /systeme/page.php
 *  Date de création : avant le 12/08/2007
 *  Dernière modification : 14/09/2007
 ***************************************************************************/

// Sécurité
if ( !defined ( 'TAGADASH' ) )
{
    header ( 'Location: ../' );
    die ( -1 );
}


header ( 'Content-Type: text/html; charset=utf-8' );
header ( 'Cache-Control: no-cache, must-revalidate' );


// Affichage d'une page normale si le fichier du template existe
if ( $page_simple == 0 && is_file ( 'themes/' . $configuration['style'] . '/templates/page_content.tpl' ) )
{
    $tpl_page_content = new Template ( 'themes/' . $configuration['style'] . '/templates/page_content.tpl' );

    $tpl_page_content->SetVar ( array (
        'TITRE'         => $page_titre,
        'TEXTE'         => $page_texte,
        'NBR_VISITEURS' => $visiteurs,
        'NBR_REQUETES'  => $database->nbr_requetes,
        'TPS_REQUETES'  => round ( $database->tps_requetes , 4 ),
        'TPS_EXECUTION' => $tps_execution,
        'LNG_SECONDE'   => $langue['seconde'],
        'LOGO'          => $configuration['titre'],
        'LIENS'         => '',
        'COPYRIGHT'     => ''
    ) );

    $menu_recherche = true;
    $menu_last_forums = true;

    if ( $menu_recherche )
    {
        include ( 'systeme/menus/recherche.php' );
        $tpl_page_content->SetVar ( array ( 'MENU_RECHERCHE' => $menu_texte ) );
    }
    else
    {
        $tpl_page_content->SetVar ( array ( 'MENU_RECHERCHE' => '' ) );
    }

    if ( $menu_last_forums )
    {
        include ( 'systeme/menus/last_forums.php' );
        $tpl_page_content->SetVar ( array ( 'MENU_LAST_FORUMS' => $menu_texte ) );
    }
    else
    {
        $tpl_page_content->SetVar ( array ( 'MENU_LAST_FORUMS' => '' ) );
    }

    // Visiteurs
    if ( $_SESSION['groupe'] == 1 )
    {
        $tpl_page_content->SetVar ( array ( 'MENU_MEMBRE' => "  <li class=\"barredroite\"><a href=\"index." . EXT . "?page=Inscription\" title=\"" . $langue['inscription_texte'] . '">' . $langue['inscription'] . "</a></li>\n  <li class=\"barredroite\"><a href=\"index." . EXT . "?page=Connexion\" title=\"" . $langue['login_texte'] . '">' . $langue['login'] . '</a></li>' ) );
    }
    else
    {
        if ( $configuration['bloquage'] == 0 )
        {
            $logout = '<a href="index.' . EXT . '?page=Deconnexion" title="' . $langue['logout_texte'] . '">' . $langue['logout'] . '</a>';
        }
        else
        {
            $logout = '<a href="#" title="' . $langue['logout_texte'] . '"><span class="rouge">' . $langue['logout'] . '</span></a>';
        }
    
        $tpl_page_content->SetVar ( array ( 'MENU_MEMBRE' => "  <li class=\"barredroite\"><a href=\"index." . EXT . "?page=Membre&amp;id=" . $_SESSION['membre_id'] . '" title="' . $langue['view_fiche'] . $_SESSION['membre'] . '">' . $_SESSION['membre'] . "</a></li>\n  <li class=\"barredroite\"><a href=\"index." . EXT . '?page=Preferences" title="' . $langue['prefs_texte'] . '">' . $langue['prefs'] . "</a></li>\n  <li class=\"barredroite\">" . $logout . '</li>' ) );
    }


    $menu_navigation = '';
    $menu_navigation_explode = explode ( ';' , $configuration['navigation'] );

    foreach ( $menu_navigation_explode as $entree )
    {
        $menu_navigation .= '  <li class="barregauche">';

        if ( $entree == 'Accueil' ) $menu_navigation .= '<a href="index.' . EXT . '" title="' . $langue['accueil_texte'] . '">' . $langue['accueil'] . '</a>';
        else if ( $entree == 'News' ) $menu_navigation .= '<a href="index.' . EXT . '?page=News" title="' . $langue['news_texte'] . '">' . $langue['news'] . '</a>';
        else if ( $entree == 'Articles' ) $menu_navigation .= '<a href="index.' . EXT . '?page=Liste_des_articles" title="' . $langue['articles_texte'] . '">' . $langue['articles'] . '</a>';
        else if ( $entree == 'Forums' ) $menu_navigation .= '<a href="index.' . EXT . '?page=Forums" title="' . $langue['forums_texte'] . '">' . $langue['forums'] . '</a>';
        else if ( $entree == 'Sondages' ) $menu_navigation .= '<a href="index.' . EXT . '?page=Sondages" title="' . $langue['sondages_texte'] . '">' . $langue['sondages'] . '</a>';
        else if ( $entree == 'Plan' ) $menu_navigation .= '<a href="index.' . EXT . '?page=Plan_du_site" title="Plan du site">Plan du site</a>';
        else if ( $entree == 'Contact' ) $menu_navigation .= '<a href="index.' . EXT . '?page=Contact" title="Contactez-nous">Contact</a>';
        else if ( $entree == 'Equipe' ) $menu_navigation .= '<a href="index.' . EXT . '?page=Equipe" title="Membres de l\'équipe">Équipe</a>';
        else if ( $entree == 'Membres' ) $menu_navigation .= '<a href="index.' . EXT . '?page=Liste_des_membres" title="' . $langue['membres_texte'] . '">' . $langue['membres'] . "</a>";
        else if ( $entree == 'Administration' && $droit['administration'] == 1 ) $menu_navigation .= '<a href="index.' . EXT . '?page=Administration" title="' . $langue['administration_texte'] . '">' . $langue['administration'] . '</a></li>';
        else $menu_navigation .= '<a href="#">' . $entree . '</a>';

        $menu_navigation .= "</li>\n";
    }

    $tpl_page_content->SetVar ( array ( 'MENU_NAVIGATION' => $menu_navigation ) );


    // Menu : Communauté
    $menu_communaute = '  <li><a href="index.' . EXT . '?page=Visiteurs" title="' . $langue['liste_visiteurs'] . '">' . $langue['visiteurs'] . "</a></li>\n";
    $menu_communaute .= '  <li><a href="index.' . EXT . '?page=Liste_des_membres" title="' . $langue['membres_texte'] . '">' . $langue['membres'] . "</a></li>\n";

    // Membre connecté
    if ( $_SESSION['groupe'] != 1 )
    {
        $menu_communaute .= '  <li><a href="index.' . EXT . "?page=Amis\" title=\"Gestion de vos amis\">Vos amis</a></li>\n";

        if ( $nbr_new_private_msg > 0 )
        {
            $menu_communaute .= '  <li><a href="index.' . EXT . "?page=Messagerie\" title=\"Gestion de vos messages\">Vos messages</a> (" . $nbr_new_private_msg . ")</li>\n";
        }
        else
        {
            $menu_communaute .= '  <li><a href="index.' . EXT . "?page=Messagerie\" title=\"Gestion de vos messages\">Vos messages</a></li>\n";
        }
    }

    // Envoyer des fichiers
    if ( $droit['upload'] == 1 )
    {
        $menu_communaute .=  '  <li><a href="index.' . EXT . "?page=Envoyer_un_fichier\" title=\"Envoyer un fichier ou une image sur le site\">" . $langue['upload'] . "</a></li>\n";
        $menu_communaute .= '  <li><a href="index.' . EXT . "?page=Liste_des_fichiers&amp;membre=" . $_SESSION['membre_id'] . "\" title=\"Liste des fichiers que vous avez envoyés\">Liste des fichiers</a></li>\n";
    }

    // Écrire un nouvel article
    if ( $droit['article_edition_auteur'] == 1 || $droit['article_edition'] == 1 )
    {
        $menu_communaute .= '  <li><a href="index.' . EXT . "?page=Ajouter_un_article\">Nouvel article</a></li>\n";
    }

    $tpl_page_content->SetVar ( array ( 'MENU_COMMUNAUTE' => '<h2>' . $langue['communaute'] . "</h2>\n\n<ul>\n" . $menu_communaute . '</ul>' ) );


    if ( is_file ( 'themes/' . $configuration['style'] . '/images/logo.png' ) )
    {
        $tpl_page_content->SetVar ( array ( 'LOGO' => '<img src="themes/' , $configuration['style'] , '/images/logo.png" alt="' , $configuration['titre'] , '" title="' , $configuration['titre'] , '" />' ) );
    }

    if ( !empty ( $configuration['liens'] ) ) 
    {
        $tpl_page_content->SetVar ( array ( 'LIENS' => '<p>' . $configuration['liens'] . "</p>\n" ) );
    }

    if ( !empty ( $configuration['copyright'] ) )
    {
        $tpl_page_content->SetVar ( array ( 'COPYRIGHT' => '<p>' . $configuration['copyright'] . "</p>\n" ) );
    }

    $page_CSS .= '<link rel="stylesheet" type="text/css" media="screen" title="' . $configuration['style'] . '" href="' . $configuration['adresse'] . 'themes/' . $configuration['style'] . '/styles/table.css" />';

    $content = $tpl_page_content->Parse ();
}

// Affichage d'une page simple
else
{
    $tpl_page_content = new Template ( 'themes/' . $configuration['style'] . '/templates/page_simple.tpl' );

    $tpl_page_content->SetVar ( array (
        'TITRE'    => $page_titre,
        'LOGO'     => $configuration['titre'],
        'TEXTE'    => $page_texte
    ) );

    $page_CSS .= '<link rel="stylesheet" type="text/css" media="screen" title="' . $configuration['style'] . '" href="' . $configuration['adresse'] . 'themes/' . $configuration['style'] . '/styles/autres.css" />';

    $content = $tpl_page_content->Parse ();
}


// Page
$tpl_page = new Template ( 'themes/' . $configuration['style'] . '/templates/page.tpl' );

$tpl_page->SetVar ( array (
    'TITRE'         => $page_titre . ' - ' . $configuration['titre'],
    'STYLE'         => $configuration['style'],
    'ADRESSE'       => $configuration['adresse'],
    'LANGUE'        => $configuration['langue'],
    'DATETIME'      => date ( $configuration['format_date'] ) . $langue['time_at'] . date ( $configuration['format_heure'] ),
    'ADRESSE_IP'    => $_SERVER['REMOTE_ADDR'],
    'ADD_CSS'       => $page_CSS,
    'CONTENT'       => $content,
    '#EXT'          => EXT
) );

echo $tpl_page->Parse ();


die ( -1 );

?>