<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /systeme/statistiques.php
 *  Date de création : avant le 12/08/2007
 *  Dernière modification : 13/09/2007
 ***************************************************************************/

// Sécurité
if ( !defined ( 'TAGADASH' ) )
{
    header ( 'Location: ../' );
    die ( -1 );
}


////////////////////
// Nombre de visiteurs connectés
////////////////////

// Nom du visiteur
$connecte = ( isset ( $_SESSION['membre'] ) && isset ( $_SESSION['membre_id'] ) ) ? $_SESSION['membre'] : 'Anonyme';

// On regarde si le visiteur est déjà dans la base
$sql = "SELECT COUNT(*) AS `count`
        FROM `" . $database->pref . "visiteurs`
        WHERE `visiteur_ip` = '" . ConvertIP ( $_SERVER['REMOTE_ADDR'] , '' ) . "';";

$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

// Si non : on l'ajoute
if ( $database->Result ( $req ,'count' ) == 0 )
{
    $sql = "INSERT INTO `" . $database->pref . "visiteurs`
            (`visiteur_ip`, `visiteur_nom`, `visiteur_time`, `visiteur_page`)
            VALUES
            ('" . ConvertIP ( $_SERVER['REMOTE_ADDR'] , '' ) . "', '" . $connecte . "', '" . $time . "', '" . $database->Protege ( $page_infos , false ) . "');";

    $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );
}
// Si oui : on le met à jour
else
{
    $sql = "UPDATE `" . $database->pref . "visiteurs`
            SET `visiteur_time` = '" . $time . "',
                `visiteur_nom` = '" . $connecte . "',
                `visiteur_page` = '" . $database->Protege ( $page_infos , false ) . "'
            WHERE `visiteur_ip` = '" . ConvertIP ( $_SERVER['REMOTE_ADDR'] , '' ) . "';";

    $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );
}

// On regarde le nombre de visiteurs
$sql = "SELECT COUNT(*) AS `count`
        FROM `" . $database->pref . "visiteurs`
        WHERE `visiteur_time` > '" . ( $time - $configuration['stat_time'] ) . "';";

$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

$nbr_visites_now = $database->Result ( $req , 'count' );

if ( $nbr_visites_now <= 1 )
{
    $visiteurs = '1 visiteur';
}
else
{
    $visiteurs = $nbr_visites_now . ' visiteurs';
}

// Record du nombre de visiteurs
if ( $nbr_visites_now > $configuration['record_visiteurs'] )
{
    $configuration['record_visiteurs'] = $nbr_visites_now;

    $sql = "UPDATE `" . $database->pref . "configuration`
            SET `config_valeur` = '" . $nbr_visites_now . "'
            WHERE `config_nom` = 'record_visiteurs';";

    $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

    $sql = "UPDATE `" . $database->pref . "configuration`
            SET `config_valeur` = '" . $time . "'
            WHERE `config_nom` = 'record_time';";

    $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );
}


////////////////////
// Compteur de visites de la journée
////////////////////
/*
// On regarde le compteur de visites de cette journée
$sql = "SELECT COUNT(*) AS `count`
        FROM `" . $database->pref . "stat`
        WHERE
                `stat_ip` = '" . ConvertIP ( $_SERVER['REMOTE_ADDR'] , '' ) . "'
            AND `stat_time` > '" . ( $time - date ( 's' ) - 60 * date ( 'i' ) - 3600 * date ( 'H' ) ) . "';";

$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

if ( $database->Result ( $req , 'count' ) == 0 )
{
    $sql = "SELECT COUNT(*) AS `count`
            FROM `" . $database->pref . "stat_jours`
            WHERE
                    `stat_annee` = '" . date ( 'Y' ) . "'
                AND `stat_mois` = '" . date ( 'n' ) . "'
                AND `stat_jour` = '" . date ( 'd' ) . "';";

    $req = $database->Requete( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

    if ( $database->Result ( $req , 'count' ) == 0 )
    {
        $sql = "INSERT INTO `" . $database->pref . "stat_jours`
                (`stat_annee`, `stat_mois`, `stat_jour`, `stat_visiteurs`)
                VALUES
                ('" . date ( 'Y' ) . "', '" . date ( 'n' ) . "', '" . date ( 'd' ) . "', '1');";

        $database->Requete( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );
    }
    else
    {
        $sql = "UPDATE `" . $database->pref . "stat_jours`
                SET `stat_visiteurs` = `stat_visiteurs` + 1
                WHERE
                        `stat_annee` = '" . date ( 'Y' ) . "'
                    AND `stat_mois` = '" . date ( 'n' ) . "'
                    AND `stat_jour` = '" . date ( 'd' ) . "';";

        $database->Requete( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );
    }
}
*/

////////////////////
// Statistiques
////////////////////

// On regarde s'il y a une entrée pour ce visiteur qui date de moins de 5 minutes
$sql = "SELECT `stat_id`
        FROM `" . $database->pref . "stat`
        WHERE
                `stat_ip` = '" . ConvertIP ( $_SERVER['REMOTE_ADDR'] , '' ) . "'
            AND `stat_time` > '" . ( $time - $configuration['stat_time'] ) . "';";

$req = $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

if ( $database->NbrRowsSelected ( $req ) > 0 )
{
    // On incrémente le nombre de pages vues
    $sql = "UPDATE `" . $database->pref . "stat`
            SET `stat_hit` = `stat_hit` + 1
            WHERE `stat_id` = '" . $database->Result ( $req , 'stat_id' ) . "';";

    $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );
}
else
{
    // Recherche du navigateur

    if ( preg_match ( "#(.{0,})Opera(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $navigateur = preg_replace ( "#(.{0,})Opera[ /]([0-9.+]{1,10})(.{0,})#i" , "Opera | $2" , $_SERVER['HTTP_USER_AGENT'] );
    }

    // Robots
    else if ( preg_match ( "#(.{0,})Exabot(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $navigateur = 'Robot | Exabot';
    }
    else if ( preg_match ( "#(.{0,})\(Exabot-Thumbnails\)(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $navigateur = 'Robot | Exabot Thumbnails';
    }
    else if ( preg_match ( "#(.{0,})msnbot(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $navigateur = 'Robot | MSN Bot';
    }
    else if ( preg_match ( "#(.{0,})W3C_Validator(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $navigateur = 'Robot | Validateur W3C';
    }
    else if ( preg_match ( "#(.{0,})W3C_CSS_Validator(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $navigateur = 'Robot | Validateur CSS W3C';
    }
    else if ( preg_match ( "#(.{0,})Googlebot(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $navigateur = 'Robot | GoogleBot';
    }
    else if ( preg_match ( "#(.{0,})yahoo(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $navigateur = 'Robot | Yahoo';
    }
    else if ( preg_match ( "#(.{0,})NG/4.5(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $navigateur = 'Robot | Exabot';
    }
    else if ( preg_match ( "#(.{0,})yetibot(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $navigateur = 'Robot | Yetibot';
    }

    else if ( preg_match ( "#(.{0,})compatible; MSIE(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $navigateur = preg_replace ( "#(.{0,})\(compatible; MSIE[ /]([0-9.]{1,10})(.{0,})#i" , "Internet Explorer | $2" , $_SERVER['HTTP_USER_AGENT'] );
    }
    else if ( preg_match ( "#(.{0,})Konqueror(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $navigateur = preg_replace ( "#(.{0,})Konqueror[ /]([0-9.]{1,10})(.{0,})#i" , "Konqueror | $2" , $_SERVER['HTTP_USER_AGENT'] );
    }
    else if ( preg_match ( "#(.{0,})Safari(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $navigateur = preg_replace ( "#(.{0,})Safari[ /]([0-9.]{1,10})(.{0,})#i" , "Safari | $2" , $_SERVER['HTTP_USER_AGENT'] );
    }
    else if ( preg_match ( "#(.{0,})Firefox(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $navigateur = preg_replace ( "#(.{0,})Firefox[ /]([0-9.+]{1,10})(.{0,})#i" , "Mozilla Firefox | $2" , $_SERVER['HTTP_USER_AGENT'] );
    }
    else if ( preg_match ( "#(.{0,})Epiphany(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $navigateur = preg_replace ( "#(.{0,})Epiphany[ /]([0-9.+]{1,10})(.{0,})#i" , "Epiphany | $2" , $_SERVER['HTTP_USER_AGENT'] );
    }

    else if ( preg_match ( "#(.{0,})Mozilla(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $navigateur = preg_replace ( "#(.{0,})Mozilla[ /]([0-9.+]{1,10})(.{0,})#i" , "Mozilla | $2" , $_SERVER['HTTP_USER_AGENT'] );
    }

    else if ( preg_match ( "#(.{0,})SonyEricssonW850i(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $navigateur = 'SonyEricssonW850i';
    }

    // Autres
    else
    {
        $navigateur = 'Inconnu';
    }


    // Recherche du système d'exploitation

    // Windows
    if ( preg_match ( "#(.{0,})Windows(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        if ( preg_match ( "#(.{0,})Windows 95(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
        {
            $systeme = 'Windows | Windows 95';
        }
        else if ( preg_match ( "#(.{0,})Windows 98(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
        {
            $systeme = 'Windows | Windows 98';
        }
        else if ( preg_match ( "#(.{0,})Windows 2000(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
        {
            $systeme = 'Windows | Windows 2000';
        }
        else if ( preg_match ( "#(.{0,})Windows CE(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
        {
            $systeme = 'Windows | Windows CE';
        }
        else if ( preg_match ( "#(.{0,})Windows NT 4.0(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
        {
            $systeme = 'Windows | Windows NT';
        }
        else if ( preg_match ( "#(.{0,})Windows NT 5.0(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
        {
            $systeme = 'Windows | Windows 2000';
        }
        else if ( preg_match ( "#(.{0,})Windows NT 5.1(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
        {
            $systeme = 'Windows | Windows XP';
        }
        else if ( preg_match ( "#(.{0,})Windows NT 5.2(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
        {
            $systeme = 'Windows | Windows Server 2003';
        }
        else if ( preg_match ( "#(.{0,})Windows NT 6.0(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
        {
            $systeme = 'Windows | Windows Vista';
        }
        else if ( preg_match ( "#(.{0,})Windows XP(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
        {
            $systeme = 'Windows | Windows XP';
        }
        else
        {
            $systeme = 'Windows';
        }
    }

    // Robots
    else if ( preg_match ( "#(.{0,})Googlebot(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $systeme = 'Robot | GoogleBot';
    }
    else if ( preg_match ( "#(.{0,})\(Exabot-Thumbnails\)(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $systeme = 'Robot | Exabot Thumbnails';
    }
    else if ( preg_match ( "#(.{0,})Exabot(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $systeme = 'Robot | Exabot';
    }
    else if ( preg_match ( "#(.{0,})msnbot(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $systeme = 'Robot | MSN Bot';
    }
    else if ( preg_match ( "#(.{0,})W3C_Validator(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $systeme = 'Robot | Validateur W3C';
    }
    else if ( preg_match ( "#(.{0,})W3C_CSS_Validator(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $systeme = 'Robot | Validateur CSS W3C';
    }
    else if ( preg_match ( "#(.{0,})yahoo(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $systeme = 'Robot | Yahoo';
    }
    else if ( preg_match ( "#(.{0,})NG/4.5(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $systeme = 'Robot | Exabot';
    }
    else if ( preg_match ( "#(.{0,})yetibot(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $systeme = 'Robot | Yetibot';
    }

    // Linux
    else if ( preg_match ( "#(.{0,})Linux(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        if ( preg_match ( "#(.{0,})SUSE(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
        {
            $systeme = 'Linux | SUSE';
        }
        else if ( preg_match ( "#(.{0,})Ubuntu(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
        {
            $systeme = 'Linux | Ubuntu';
        }
        else if ( preg_match ( "#(.{0,})Debian(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
        {
            $systeme = 'Linux | Debian';
        }
        else if ( preg_match ( "#(.{0,})Fedora(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
        {
            $systeme = 'Linux | Fedora';
        }
        else if ( preg_match ( "#(.{0,})Gentoo(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
        {
            $systeme = 'Linux | Gentoo';
        }
        else if ( preg_match ( "#(.{0,})Red Hat(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
        {
            $systeme = 'Linux | Red Hat';
        }
        else if ( preg_match ( "#(.{0,})Mandriva(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
        {
            $systeme = 'Linux | Mandriva';
        }
        else
        {
            $systeme = 'Linux';
        }
    }

    // FreeBSD
    else if ( preg_match ( "#(.{0,})FreeBSD(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $systeme = 'FreeBSD';
    }

    // Mac
    else if ( preg_match ( "#(.{0,})PPC Mac OS X(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $systeme = 'Mac | Mac OS X PowerPC';
    }
    else if ( preg_match ( "#(.{0,})Mac_PowerPC Mac OS X(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $systeme = 'Mac | Mac OS X PowerPC';
    }
    else if ( preg_match ( "#(.{0,})PPC(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $systeme = 'Mac | PowerPC';
    }

    else if ( preg_match ( "#(.{0,})SonyEricssonW850i(.{0,})#i" , $_SERVER['HTTP_USER_AGENT'] ) )
    {
        $systeme = 'SonyEricsson W850i';
    }

    // Autres
    else
    {
        $systeme = 'Inconnu';
    }


    // Langue
    if ( isset ( $_SERVER['HTTP_ACCEPT_LANGUAGE'] ) )
    {
        $visiteur_langue = strtolower ( preg_replace ( "#^([-a-z]{2,5})(,|;)(.+)$#iU" , "$1" , $_SERVER['HTTP_ACCEPT_LANGUAGE'] ) );
    }
    else
    {
        $visiteur_langue = '00';
    }


    if ( $_SESSION['groupe'] != 1 )
    {
        $member = $_SESSION['membre_id'];
    }
    else
    {
        $member = 0;
    }

    if ( $_SERVER['REMOTE_ADDR'] === '127.0.0.1' )
    {
        $stat_pays = '00';
        $stat_fai = 'inconnu';
    }
    else
    {
        $host = trim ( strtolower ( GetHostByAddr ( $_SERVER['REMOTE_ADDR'] ) ) );

        $host_explode = explode ( '.' , $host );

        // Extension de l'hôte
        $ext = $host_explode[sizeof ( $host_explode ) - 1];

        if ( is_numeric ( $ext ) || in_array ( $ext , array ( 'com' , 'net' , 'org' , 'co' , 'info' ) ) )
        {
            $stat_pays = '00';
        }
        else
        {
            $stat_pays = strtoupper ( $ext );
        }

        if ( sizeof ( $host_explode ) > 1 )
        {
            $fai = $host_explode[sizeof ( $host_explode ) - 2];
        }
        else
        {
            $fai = '00';
        }

        // Les visiteurs de Free se terminent par .proxad.net
        if ( $ext == 'net' && $fai == 'proxad' )
        {
            $stat_pays = 'FR';
        }

        // Recherche du FAI
        if ( $stat_pays != '00' )
        {
            $stat_fai = $fai;
        }
        else
        {
            $stat_fai = 'inconnu';
        }
    }


    // Ajout de l'entrée dans la base
    $sql = "INSERT INTO `" . $database->pref . "stat`
            (`stat_ip`, `stat_navigateur`, `stat_os`, `stat_time`, `stat_langue`, `stat_membre`, `stat_hit`, `stat_pays`, `stat_fai`)
            VALUES
            ('" . ConvertIP ( $_SERVER['REMOTE_ADDR'] , '' ) . "', '" . $navigateur . "', '" . $systeme . "', '" . $time . "', '" . $visiteur_langue . "', '" . $member . "', '1', '" . $stat_pays . "', '" . $stat_fai . "');";

    $database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

    if ( $page_infos == 'Inconnue' )
    {
        trigger_error ( 'Les informations de la page ne sont pas renseignées : ' . $page  , E_USER_NOTICE );
    }
}

?>