<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /systeme/tables_odbc.php
 *  Date de création : 24/08/2007
 *  Dernière modification : 14/09/2007
 ***************************************************************************/

// Sécurité
if ( !defined ( 'TAGADASH' ) )
{
    header ( 'Location: ../' );
    die ( -1 );
}


$sql = "CREATE TABLE IF NOT EXISTS `" . $prefixe . "amis` (
  `ami_from` INT(9) UNSIGNED NOT NULL,
  `ami_to` INT(9) UNSIGNED NOT NULL,
  `ami_time` INT(10) UNSIGNED NOT NULL,
  `ami_accepte` ENUM('0','1') NOT NULL DEFAULT '0',
  PRIMARY KEY (`ami_from`,`ami_to`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE IF NOT EXISTS `" . $prefixe . "article_article` (
  `article_id` INT(9) UNSIGNED NOT NULL AUTO_INCREMENT,
  `article_texte` TEXT NOT NULL,
  `article_langue` VARCHAR(50) NOT NULL DEFAULT 'fr',
  `article_titre` VARCHAR(50) NOT NULL,
  `article_auteur` INT(9) UNSIGNED NOT NULL,
  `article_modification` INT(10) UNSIGNED NOT NULL,
  `article_compteur` INT(9) UNSIGNED NOT NULL DEFAULT '0',
  `article_categorie` INT(9) UNSIGNED NOT NULL DEFAULT '0',
  `article_actif` ENUM('0','1') NOT NULL DEFAULT '1',
  `article_commentaires` INT(9) UNSIGNED NOT NULL DEFAULT '0',
  PRIMARY KEY (`article_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE IF NOT EXISTS `" . $prefixe . "article_cat` (
  `cat_id` INT(9) UNSIGNED NOT NULL AUTO_INCREMENT,
  `cat_nom` VARCHAR(250) NOT NULL,
  `cat_categorie` INT(9) UNSIGNED NOT NULL,
  PRIMARY KEY (`cat_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE IF NOT EXISTS `" . $prefixe . "article_historique` (
  `historique_id` INT(9) UNSIGNED NOT NULL AUTO_INCREMENT,
  `historique_article` INT(9) UNSIGNED NOT NULL,
  `historique_texte` TEXT NOT NULL,
  `historique_langue` VARCHAR(10) NOT NULL DEFAULT 'fr',
  `historique_titre` VARCHAR(50) NOT NULL,
  `historique_categorie` INT(9) UNSIGNED NOT NULL,
  `historique_auteur` INT(9) UNSIGNED NOT NULL,
  `historique_time` INT(10) UNSIGNED NOT NULL,
  PRIMARY KEY (`historique_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE IF NOT EXISTS `" . $prefixe . "bannis` (
  `banni_ip` INT(10) UNSIGNED NOT NULL,
  `banni_time` INT(10) UNSIGNED NOT NULL,
  `banni_duree` INT(9) UNSIGNED NOT NULL,
  `banni_motif` VARCHAR(250) NOT NULL,
  `banni_membre` INT(9) UNSIGNED NOT NULL,
  PRIMARY KEY (`banni_ip`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE IF NOT EXISTS `" . $prefixe . "commentaires` (
  `commentaire_id` INT(9) UNSIGNED NOT NULL AUTO_INCREMENT,
  `commentaire_auteur` INT(9) UNSIGNED NOT NULL,
  `commentaire_time` INT(10) UNSIGNED NOT NULL,
  `commentaire_type` ENUM('0','1') NOT NULL,
  `commentaire_reference` INT(9) UNSIGNED NOT NULL,
  `commentaire_texte` TEXT NOT NULL,
  PRIMARY KEY (`commentaire_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE IF NOT EXISTS `" . $prefixe . "configuration` (
  `config_nom` VARCHAR(50) NOT NULL,
  `config_valeur` TEXT NOT NULL,
  PRIMARY KEY (`config_nom`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE IF NOT EXISTS `" . $prefixe . "droits` (
  `droit_groupe` SMALLINT(3) UNSIGNED NOT NULL,
  `droit_nom` VARCHAR(50) NOT NULL,
  `droit_valeur` ENUM('0','1') NOT NULL DEFAULT '0',
  PRIMARY KEY (`droit_groupe`, `droit_nom`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE IF NOT EXISTS `" . $prefixe . "fichiers` (
  `fichier_id` INT(9) UNSIGNED NOT NULL AUTO_INCREMENT,
  `fichier_nom` VARCHAR(50) NOT NULL,
  `fichier_extension` VARCHAR(4) NOT NULL,
  `fichier_time` INT(10) UNSIGNED NOT NULL,
  `fichier_membre` INT(9) UNSIGNED NOT NULL,
  `fichier_taille` INT(9) UNSIGNED NOT NULL,
  PRIMARY KEY (`fichier_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE IF NOT EXISTS `" . $prefixe . "forum_cat` (
  `forum_cat_id` INT(9) UNSIGNED NOT NULL AUTO_INCREMENT,
  `forum_cat_nom` VARCHAR(50) NOT NULL,
  `forum_cat_ordre` INT(9) UNSIGNED NOT NULL,
  PRIMARY KEY (`forum_cat_id`),
  UNIQUE KEY `forum_cat_ordre` (`forum_cat_ordre`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE IF NOT EXISTS `" . $prefixe . "forum_forum` (
  `forum_id` INT(9) UNSIGNED NOT NULL AUTO_INCREMENT,
  `forum_categorie` INT(9) UNSIGNED NOT NULL,
  `forum_nom` VARCHAR(50) NOT NULL,
  `forum_description` VARCHAR(250) DEFAULT NULL,
  `forum_ordre` INT(9) UNSIGNED NOT NULL DEFAULT '1',
  `forum_last_msg` INT(9) UNSIGNED NOT NULL DEFAULT '0',
  `forum_nbr_sujet` INT(9) UNSIGNED NOT NULL DEFAULT '0',
  `forum_nbr_msg` INT(9) UNSIGNED NOT NULL DEFAULT '0',
  PRIMARY KEY (`forum_id`),
  UNIQUE KEY `ordre` (`forum_categorie`, `forum_ordre`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE IF NOT EXISTS `" . $prefixe . "forum_msg` (
  `forum_msg_id` INT(9) UNSIGNED NOT NULL AUTO_INCREMENT,
  `forum_msg_auteur` INT(9) UNSIGNED NOT NULL,
  `forum_msg_texte` TEXT NOT NULL,
  `forum_msg_time` INT(10) UNSIGNED NOT NULL,
  `forum_msg_sujet` INT(9) UNSIGNED NOT NULL,
  `forum_msg_forum` INT(9) UNSIGNED NOT NULL,
  `forum_msg_edit_auteur` INT(9) UNSIGNED DEFAULT NULL,
  `forum_msg_edit_time` INT(10) UNSIGNED DEFAULT NULL,
  PRIMARY KEY (`forum_msg_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE IF NOT EXISTS `" . $prefixe . "forum_sujet` (
  `sujet_id` INT(9) UNSIGNED NOT NULL AUTO_INCREMENT,
  `sujet_forum` INT(9) UNSIGNED NOT NULL,
  `sujet_titre` VARCHAR(50) NOT NULL,
  `sujet_auteur` INT(9) UNSIGNED NOT NULL,
  `sujet_compteur` INT(9) UNSIGNED NOT NULL,
  `sujet_time` INT(10) UNSIGNED NOT NULL,
  `sujet_last_msg` INT(9) UNSIGNED NOT NULL,
  `sujet_first_msg` INT(9) UNSIGNED NOT NULL,
  `sujet_nbr_msg` INT(9) UNSIGNED NOT NULL DEFAULT '0',
  `sujet_epingle` ENUM('0','1') NOT NULL DEFAULT '0',
  `sujet_ferme` ENUM('0','1') NOT NULL DEFAULT '0',
  PRIMARY KEY (`sujet_id`),
  UNIQUE KEY `sujet_last_msg` (`sujet_last_msg`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE IF NOT EXISTS `" . $prefixe . "forum_sujet_view` (
  `sv_membre` INT(9) UNSIGNED NOT NULL,
  `sv_sujet` INT(9) UNSIGNED NOT NULL,
  `sv_message` INT(9) UNSIGNED NOT NULL,
  `sv_participe` ENUM('0','1') NOT NULL DEFAULT '0',
  PRIMARY KEY (`sv_membre`,`sv_sujet`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE IF NOT EXISTS `" . $prefixe . "groupes` (
  `groupe_id` SMALLINT(3) UNSIGNED NOT NULL AUTO_INCREMENT,
  `groupe_nom` VARCHAR(50) NOT NULL,
  `groupe_modo` INT(9) UNSIGNED NOT NULL,
  PRIMARY KEY (`groupe_id`),
  UNIQUE KEY `nom` (`groupe_nom`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE IF NOT EXISTS `" . $prefixe . "membres` (
  `membre_id` INT(9) UNSIGNED NOT NULL AUTO_INCREMENT,
  `membre_nom` VARCHAR(50) NOT NULL,
  `membre_mdp` VARCHAR(32) NOT NULL,
  `membre_email` VARCHAR(50) NOT NULL,
  `membre_afficher_email` ENUM('0','1') NOT NULL DEFAULT '1',
  `membre_cle` VARCHAR(32) NOT NULL DEFAULT '0',
  `membre_actif` ENUM('0','1') NOT NULL DEFAULT '1',
  `membre_inscription` INT(10) UNSIGNED NOT NULL,
  `membre_visite` INT(10) UNSIGNED NOT NULL,
  `membre_groupe` SMALLINT(3) UNSIGNED NOT NULL DEFAULT '2',
  `membre_langue` VARCHAR(50) NOT NULL DEFAULT 'fr',
  `membre_avatar` VARCHAR(15) DEFAULT NULL,
  `membre_signature` VARCHAR(250) DEFAULT NULL,
  `membre_style` VARCHAR(50) NOT NULL DEFAULT 'Chuwiki',
  `membre_site` VARCHAR(250) DEFAULT NULL,
  `membre_anniversaire` DATE NOT NULL DEFAULT '0000-00-00',
  `membre_profession` VARCHAR(50) DEFAULT NULL,
  `membre_localisation` VARCHAR(50) DEFAULT NULL,
  `membre_messagerie` VARCHAR(50) DEFAULT NULL,
  `membre_mail_pm` ENUM('0','1') NOT NULL DEFAULT '0',
  `membre_mail_fav` ENUM('0','1') NOT NULL DEFAULT '0',
  PRIMARY KEY (`membre_id`),
  UNIQUE KEY `nom` (`membre_nom`),
  UNIQUE KEY `email` (`membre_email`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE IF NOT EXISTS `" . $prefixe . "messages` (
  `msg_id` INT(9) UNSIGNED NOT NULL AUTO_INCREMENT,
  `msg_auteur` INT(9) UNSIGNED NOT NULL,
  `msg_destinataire` INT(9) UNSIGNED NOT NULL,
  `msg_time` INT(10) UNSIGNED NOT NULL,
  `msg_lectures` INT(9) UNSIGNED NOT NULL DEFAULT '0',
  `msg_sujet` VARCHAR(250) NOT NULL,
  `msg_texte` TEXT NOT NULL,
  `msg_reponse` INT(9) UNSIGNED NOT NULL DEFAULT '0',
  PRIMARY KEY (`msg_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE IF NOT EXISTS `" . $prefixe . "news` (
  `news_id` INT(9) UNSIGNED NOT NULL AUTO_INCREMENT,
  `news_titre` VARCHAR(250) NOT NULL,
  `news_texte` TEXT NOT NULL,
  `news_auteur` INT(9) UNSIGNED NOT NULL,
  `news_time` INT(10) UNSIGNED NOT NULL,
  `news_lectures` INT(9) UNSIGNED NOT NULL DEFAULT '0',
  `news_commentaires` INT(9) UNSIGNED NOT NULL DEFAULT '0',
  PRIMARY KEY (`news_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE IF NOT EXISTS `" . $prefixe . "sondages` (
  `sondage_id` INT(9) UNSIGNED NOT NULL AUTO_INCREMENT,
  `sondage_time` INT(10) UNSIGNED NOT NULL,
  `sondage_question` VARCHAR(50) NOT NULL,
  `sondage_rep_0` VARCHAR(50) NOT NULL,
  `sondage_rep_1` VARCHAR(50) NOT NULL,
  `sondage_rep_2` VARCHAR(50) DEFAULT NULL,
  `sondage_rep_3` VARCHAR(50) DEFAULT NULL,
  `sondage_rep_4` VARCHAR(50) DEFAULT NULL,
  `sondage_rep_5` VARCHAR(50) DEFAULT NULL,
  `sondage_rep_6` VARCHAR(50) DEFAULT NULL,
  `sondage_rep_7` VARCHAR(50) DEFAULT NULL,
  `sondage_rep_8` VARCHAR(50) DEFAULT NULL,
  `sondage_rep_9` VARCHAR(50) DEFAULT NULL,
  `sondage_type` ENUM('0','1') NOT NULL DEFAULT '0',
  `sondage_actif` ENUM('0','1') NOT NULL DEFAULT '1',
  `sondage_auteur` INT(9) UNSIGNED NOT NULL,
  PRIMARY KEY (`sondage_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE IF NOT EXISTS `" . $prefixe . "stat` (
  `stat_id` INT(9) UNSIGNED NOT NULL AUTO_INCREMENT,
  `stat_ip` INT(10) UNSIGNED NOT NULL,
  `stat_navigateur` VARCHAR(50) DEFAULT NULL,
  `stat_os` VARCHAR(50) DEFAULT NULL,
  `stat_langue` VARCHAR(20) DEFAULT NULL,
  `stat_time` INT(10) UNSIGNED NOT NULL,
  `stat_membre` INT(9) UNSIGNED NOT NULL DEFAULT '0',
  `stat_hit` SMALLINT(3) UNSIGNED NOT NULL DEFAULT '1',
  PRIMARY KEY (`stat_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE IF NOT EXISTS `" . $prefixe . "visiteurs` (
  `visiteur_ip` INT(10) UNSIGNED NOT NULL,
  `visiteur_nom` VARCHAR(50) NOT NULL,
  `visiteur_time` INT(10) UNSIGNED NOT NULL,
  `visiteur_page` VARCHAR(250) DEFAULT NULL,
  PRIMARY KEY (`visiteur_ip`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE IF NOT EXISTS `" . $prefixe . "votes` (
  `vote_sondage` INT(9) UNSIGNED NOT NULL,
  `vote_membre` INT(9) UNSIGNED NOT NULL,
  `vote_rep_0` ENUM('0','1') NOT NULL DEFAULT '0',
  `vote_rep_1` ENUM('0','1') NOT NULL DEFAULT '0',
  `vote_rep_2` ENUM('0','1') NOT NULL DEFAULT '0',
  `vote_rep_3` ENUM('0','1') NOT NULL DEFAULT '0',
  `vote_rep_4` ENUM('0','1') NOT NULL DEFAULT '0',
  `vote_rep_5` ENUM('0','1') NOT NULL DEFAULT '0',
  `vote_rep_6` ENUM('0','1') NOT NULL DEFAULT '0',
  `vote_rep_7` ENUM('0','1') NOT NULL DEFAULT '0',
  `vote_rep_8` ENUM('0','1') NOT NULL DEFAULT '0',
  `vote_rep_9` ENUM('0','1') NOT NULL DEFAULT '0',
  PRIMARY KEY (`vote_sondage`, `vote_membre`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

?>