<?php
/***************************************************************************
 *  Copyright (C) 2007 Michel Teddy
 *  This file is part of Tagadash
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 ***************************************************************************/
/***************************************************************************
 *  Fichier : /systeme/tables_pgsql.php
 *  Date de création : 13/08/2007
 *  Dernière modification : 14/09/2007
 ***************************************************************************/

// Sécurité
if ( !defined ( 'TAGADASH' ) )
{
    header ( 'Location: ../' );
    die ( -1 );
}


$sql = "CREATE TABLE " . $database->pref . "amis (
  ami_from INTEGER NOT NULL,
  ami_to INTEGER NOT NULL,
  ami_time INTEGER NOT NULL,
  ami_accepte SMALLINT NOT NULL DEFAULT 0,
  PRIMARY KEY (ami_from, ami_to)
);";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE " . $database->pref . "article_article (
  article_id SERIAL,
  article_texte TEXT NOT NULL,
  article_langue VARCHAR(50) DEFAULT 'fr',
  article_titre VARCHAR(50) NOT NULL,
  article_auteur INTEGER NOT NULL,
  article_modification INTEGER NOT NULL,
  article_compteur INTEGER NOT NULL DEFAULT 0,
  article_commentaires INTEGER NOT NULL DEFAULT 0,
  article_categorie INTEGER DEFAULT 0,
  article_actif SMALLINT NOT NULL DEFAULT 1,
  PRIMARY KEY (article_id)
);";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE " . $database->pref . "article_cat (
  cat_id SERIAL,
  cat_nom VARCHAR(250) NOT NULL,
  cat_categorie INTEGER NOT NULL,
  PRIMARY KEY (id)
);";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE " . $database->pref . "article_historique (
  historique_id SERIAL,
  historique_article INTEGER NOT NULL,
  historique_texte TEXT NOT NULL,
  historique_langue VARCHAR(10) DEFAULT 'fr',
  historique_titre VARCHAR(50) NOT NULL,
  historique_categorie INTEGER NOT NULL,
  historique_auteur INTEGER NOT NULL,
  historique_time INTEGER NOT NULL,
  PRIMARY KEY (id)
);";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE " . $database->pref . "bannis (
  banni_ip INTEGER NOT NULL,
  banni_time INTEGER NOT NULL,
  banni_duree INTEGER NOT NULL,
  banni_motif VARCHAR(250) NOT NULL,
  banni_membre INTEGER NOT NULL,
  PRIMARY KEY (banni_ip)
);";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE " . $database->pref . "commentaires (
  commentaire_id SERIAL,
  commentaire_auteur INTEGER NOT NULL,
  commentaire_time INTEGER NOT NULL,
  commentaire_type SMALLINT NOT NULL,
  commentaire_reference INTEGER NOT NULL,
  commentaire_texte TEXT NOT NULL,
  PRIMARY KEY (commentaire_id)
);";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE " . $database->pref . "configuration (
  config_nom VARCHAR(250) NOT NULL,
  config_valeur TEXT NOT NULL,
  PRIMARY KEY (config_nom)
);";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE " . $database->pref . "droits (
  droit_groupe INTEGER NOT NULL,
  droit_nom VARCHAR(50) NOT NULL,
  droit_valeur SMALLINT NOT NULL DEFAULT 0,
  PRIMARY KEY (droit_groupe, droit_nom)
);";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE " . $database->pref . "fichiers (
  fichier_id SERIAL,
  fichier_nom VARCHAR(50) NOT NULL,
  fichier_extension VARCHAR(4) NOT NULL,
  fichier_time INTEGER NOT NULL,
  fichier_membre INTEGER NOT NULL,
  fichier_taille INTEGER NOT NULL,
  PRIMARY KEY (fichier_id)
);";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE " . $database->pref . "forum_cat (
  forum_cat_id SERIAL,
  forum_cat_nom VARCHAR(50) NOT NULL,
  forum_cat_ordre INTEGER NOT NULL UNIQUE,
  PRIMARY KEY (forum_cat_id)
);";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE " . $database->pref . "forum_forum (
  forum_id SERIAL,
  forum_categorie INTEGER NOT NULL,
  forum_nom VARCHAR(50) NOT NULL,
  forum_description VARCHAR(250) DEFAULT NULL,
  forum_ordre INTEGER NOT NULL,
  forum_last_msg INTEGER NOT NULL,
  forum_nbr_sujet INTEGER NOT NULL DEFAULT 0,
  forum_nbr_msg INTEGER NOT NULL DEFAULT 0,
  PRIMARY KEY (forum_id),
  UNIQUE (forum_categorie, forum_ordre)
);";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE " . $database->pref . "forum_msg (
  forum_msg_id SERIAL,
  forum_msg_auteur INTEGER NOT NULL,
  forum_msg_texte TEXT NOT NULL,
  forum_msg_time INTEGER NOT NULL,
  forum_msg_sujet INTEGER NOT NULL,
  forum_msg_forum INTEGER NOT NULL,
  forum_msg_edit_auteur INTEGER DEFAULT NULL,
  forum_msg_edit_time INTEGER DEFAULT NULL,
  PRIMARY KEY (forum_msg_id)
);";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE " . $database->pref . "forum_sujet (
  sujet_id SERIAL,
  sujet_forum INTEGER NOT NULL,
  sujet_titre VARCHAR(100) NOT NULL,
  sujet_auteur INTEGER NOT NULL,
  sujet_compteur INTEGER NOT NULL DEFAULT 0,
  sujet_time INTEGER NOT NULL,
  sujet_last_msg INTEGER NOT NULL,
  sujet_first_msg INTEGER NOT NULL,
  sujet_nbr_msg INTEGER NOT NULL DEFAULT 0,
  sujet_epingle SMALLINT DEFAULT 0,
  sujet_ferme SMALLINT DEFAULT 0,
  PRIMARY KEY (sujet_id),
  UNIQUE (sujet_last_msg)
);";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE " . $database->pref . "forum_sujet_view (
  sv_membre INTEGER NOT NULL,
  sv_sujet INTEGER NOT NULL,
  sv_message INTEGER NOT NULL,
  sv_participe SMALLINT NOT NULL DEFAULT 0,
  PRIMARY KEY (sv_membre, sv_sujet)
);";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE " . $database->pref . "groupes (
  groupe_id SERIAL,
  groupe_nom VARCHAR(50) NOT NULL,
  groupe_modo INTEGER NOT NULL,
  PRIMARY KEY (`groupe_id`),
  UNIQUE (groupe_nom)
);";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE " . $database->pref . "membres (
  membre_id SERIAL,
  membre_nom VARCHAR(50) NOT NULL,
  membre_mdp VARCHAR(32) NOT NULL,
  membre_email VARCHAR(250) NOT NULL,
  membre_afficher_email SMALLINT NOT NULL DEFAULT 1,
  membre_cle VARCHAR(32) NOT NULL DEFAULT '0',
  membre_actif SMALLINT NOT NULL DEFAULT 1,
  membre_inscription INTEGER NOT NULL,
  membre_visite INTEGER NOT NULL,
  membre_groupe SMALLINT NOT NULL DEFAULT 2,
  membre_langue VARCHAR(50) NOT NULL DEFAULT 'fr',
  membre_avatar VARCHAR(15) DEFAULT NULL,
  membre_signature VARCHAR(250) DEFAULT NULL,
  membre_style VARCHAR(50) NOT NULL DEFAULT 'Chuwiki',
  membre_site VARCHAR(250) DEFAULT NULL,
  membre_anniversaire DATE DEFAULT NULL,
  membre_profession VARCHAR(250) DEFAULT NULL,
  membre_localisation VARCHAR(250) DEFAULT NULL,
  membre_messagerie VARCHAR(250) DEFAULT NULL,
  membre_mail_pm ENUM('0','1') NOT NULL DEFAULT 0,
  membre_mail_fav ENUM('0','1') NOT NULL DEFAULT 0,
  PRIMARY KEY (membre_id),
  UNIQUE (membre_nom),
  UNIQUE (membre_email)
);";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE " . $database->pref . "messages (
  msg_id SERIAL,
  msg_auteur INTEGER NOT NULL,
  msg_destinataire INTEGER NOT NULL,
  msg_time INTEGER NOT NULL,
  msg_lu SMALLINT NOT NULL DEFAULT 0,
  msg_sujet VARCHAR(250) NOT NULL,
  msg_texte TEXT NOT NULL,
  msg_reponse INTEGER NOT NULL DEFAULT 0,
  PRIMARY KEY (msg_id)
);";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE " . $database->pref . "news (
  news_id SERIAL,
  news_titre VARCHAR(250) NOT NULL,
  news_texte TEXT NOT NULL,
  news_auteur INTEGER NOT NULL,
  news_time INTEGER NOT NULL,
  news_lectures INTEGER NOT NULL DEFAULT 0,
  news_commentaires INTEGER NOT NULL DEFAULT 0,
  PRIMARY KEY (news_id)
);";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE " . $database->pref . "sondages (
  sondage_id SERIAL,
  sondage_time INTEGER NOT NULL,
  sondage_question VARCHAR(250) NOT NULL,
  sondage_rep_0 VARCHAR(250) NOT NULL,
  sondage_rep_1 VARCHAR(250) NOT NULL,
  sondage_rep_2 VARCHAR(250) DEFAULT NULL,
  sondage_rep_3 VARCHAR(250) DEFAULT NULL,
  sondage_rep_4 VARCHAR(250) DEFAULT NULL,
  sondage_rep_5 VARCHAR(250) DEFAULT NULL,
  sondage_rep_6 VARCHAR(250) DEFAULT NULL,
  sondage_rep_7 VARCHAR(250) DEFAULT NULL,
  sondage_rep_8 VARCHAR(250) DEFAULT NULL,
  sondage_rep_9 VARCHAR(250) DEFAULT NULL,
  sondage_type SMALLINT NOT NULL DEFAULT 0,
  sondage_actif SMALLINT NOT NULL DEFAULT 1,
  sondage_auteur INTEGER NOT NULL,
  PRIMARY KEY (sondage_id)
);";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE " . $database->pref . "stat (
  stat_id SERIAL,
  stat_ip INTEGER NOT NULL,
  stat_navigateur VARCHAR(50) DEFAULT NULL,
  stat_os VARCHAR(50) DEFAULT NULL,
  stat_langue VARCHAR(20) DEFAULT NULL,
  stat_time INTEGER NOT NULL,
  stat_membre INTEGER NOT NULL DEFAULT 0,
  PRIMARY KEY (stat_id)
);";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE " . $database->pref . "visiteurs (
  visiteur_ip INTEGER NOT NULL,
  visiteur_nom VARCHAR(50) NOT NULL,
  visiteur_time INTEGER NOT NULL,
  visiteur_page VARCHAR(250) DEFAULT NULL,
  PRIMARY KEY (visiteur_ip)
);";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );


$sql = "CREATE TABLE " . $database->pref . "votes (
  vote_sondage INTEGER NOT NULL,
  vote_membre INTEGER NOT NULL,
  vote_rep_0 SMALLINT NOT NULL DEFAULT 0,
  vote_rep_1 SMALLINT NOT NULL DEFAULT 0,
  vote_rep_2 SMALLINT NOT NULL DEFAULT 0,
  vote_rep_3 SMALLINT NOT NULL DEFAULT 0,
  vote_rep_4 SMALLINT NOT NULL DEFAULT 0,
  vote_rep_5 SMALLINT NOT NULL DEFAULT 0,
  vote_rep_6 SMALLINT NOT NULL DEFAULT 0,
  vote_rep_7 SMALLINT NOT NULL DEFAULT 0,
  vote_rep_8 SMALLINT NOT NULL DEFAULT 0,
  vote_rep_9 SMALLINT NOT NULL DEFAULT 0,
  PRIMARY KEY (vote_sondage, vote_membre)
);";

$database->Requete ( $sql ) or $database->Erreur ( __LINE__ , __FILE__ , $sql );

?>